proc comment_init {} {
    global closeImg
    
    #Creating menu buttons
    .menubar.tab.menu add command -label "Comment" -command "catch {create_tab comment}"
    
    set notebook .result.notebook2.nb
    set frame [$notebook insert end comment -text "Comment" -raisecmd "catch {update_info_comment}"]
    frame $frame.0
    label $frame.0.label1 -font 12
    button $frame.0.save -text "Save" -command comment_save
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command "::close_tab comment"
    frame $frame.1
    text $frame.1.panel -background white -width 100 -height 1
    
    pack $frame.0.save $frame.0.label1 -side left -fill both -anchor w
    pack $frame.0.exit -side right -fill both -anchor e
    pack $frame.1.panel -fill both -side left -expand true
    pack $frame.0 -side top -fill both; pack $frame.1 -side top -fill both -expand true
}

proc comment_remove {} {
    #Remove menu buttons
    .menubar.tab.menu delete "Comment"
    .result.notebook2.nb delete comment
}

proc comment_save {} {
    global env
    
    set comment [string trim [.result.notebook2.nb.fcomment.1.panel get -displaychars 1.0 end]]
    set comment [regsub -all {\n} $comment "#zub#"]
    
    if {$env(sequence_type) eq "nucleotide"} {
        catch {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT functions.nucComment('$env(contig.dbName)', '$env(contig.id_seq)', '$comment') AS out"}}]]
            foreach sRes $sql_res {
                set out [lindex $sRes 0]
            }
            unset sql_res
        } out
    } elseif {$env(sequence_type) eq "protein"} {
        catch {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT functions.protComment('$env(contig.dbName)', '$env(contig.id_prot)', '$comment') AS out"}}]]
            foreach sRes $sql_res {
                set out [lindex $sRes 0]
            }
            unset sql_res
        } out
    }   
    unset comment
}

proc update_info_comment {} {
    global env
    
    .result.notebook2.nb.fcomment.1.panel delete 1.0 end
    set comment ""
    if {$env(sequence_type) eq "nucleotide"} {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT comment FROM $env(contig.dbName).sequences_nucleotide_description WHERE id_seq = '$env(contig.id_seq)'"}}]]
        foreach sRes $sql_res {
            set comment [lindex $sRes 0]
        }
        unset sql_res
    } elseif {$env(sequence_type) eq "protein"} {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT comment FROM $env(contig.dbName).sequences_protein_description WHERE id_prot = '$env(contig.id_prot)'"}}]]
        foreach sRes $sql_res {
            set comment [lindex $sRes 0]
        }
        unset sql_res
    }
    
    if {$comment ne "" && $comment ne "\"\""} {
        .result.notebook2.nb.fcomment.1.panel insert end [regsub -all {#zub#} $comment "\n"]
    }
    .result.notebook2.nb.fcomment.0.label1 configure -text $env(contig.name)
}