proc domain_viewer_init {} {
    global closeImg
    global domain_canTagL
    
    set domain_canTagL ""
    
    #Creating menu buttons
    .menubar.tab.menu add command -label "Domain viewer" -command "catch {create_tab domain}"
    
    set notebook .result.notebook2.nb
    set frame [$notebook insert end domain -text "Domains" -raisecmd "catch {update_info_domain}"]
    frame $frame.0
    label $frame.0.label1 -font 12
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command "close_tab domain"
    frame $frame.1
    frame $frame.1.tab
    frame $frame.1.tab.table
    scrollbar $frame.1.tab.y -orient vertical -command "$frame.1.tab.table.l yview"
    scrollbar $frame.1.tab.table.x -orient horizontal -command "$frame.1.tab.table.l xview"
    set nb2_tl_domain $frame.1.tab.table.l
    tablelist::tablelist $nb2_tl_domain \
            -width 24 -height 1 -showseparators 1 -stripebackground lightblue\
            -columns {0 "feature" 0 "id" 0 "description" 0 "hstart" 0 "hend" 0 "fstart" 0 "fend" 0 "frame"} \
            -labelcommand "$nb2_tl_domain finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -selectmode single \
            -stretch {1 2} \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.tab.y set" \
            -xscrollcommand "$frame.1.tab.table.x set" \
            -background white
    $nb2_tl_domain columnconfigure 3 -hide yes
    $nb2_tl_domain columnconfigure 4 -hide yes
    $nb2_tl_domain columnconfigure 5 -hide yes
    $nb2_tl_domain columnconfigure 6 -hide yes
    $nb2_tl_domain columnconfigure 7 -hide yes
    frame $frame.1.can
    scrollbar $frame.1.can.y -orient vertical -command "$frame.1.can.c yview"
    canvas $frame.1.can.c -background white -width 600 -height 1 -yscrollcommand "$frame.1.can.y set"
    pack $frame.0.label1 -side left -fill both -anchor w
    pack $frame.0.exit -side right -fill both -anchor e
    pack $frame.1.can.c -fill both -side left -expand true; pack $frame.1.can.y -fill both -side left
    pack $frame.1.tab.table.l -fill both -side top -expand true; pack $frame.1.tab.table.x -fill both -side bottom
    pack $frame.1.tab.table -fill both -side left -expand true; pack $frame.1.tab.y -fill both -side left
    pack $frame.1.tab $frame.1.can -fill both -side left -expand true
    pack $frame.0 -side top -fill both; pack $frame.1 -side top -fill both -expand true
    
    
    set tl .result.notebook2.nb.fdomain.1.tab.table.l
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    set id \[lindex \[$tl get \$y\] 1\]
    rightmenu_domain_viewer domain domain \$id \$coord
    "
}

proc domain_viewer_remove {} {
    #Remove menu buttons
    .menubar.tab.menu delete "Domain viewer"
    .result.notebook2.nb delete domain
}

proc update_info_domain {} {
    global env
    global domain_canTagL
    
    .result.notebook2.nb.fdomain.0.label1 configure -text $env(contig.name)
    
    .result.notebook2.nb.fdomain.1.tab.table.l delete 0 end
    .result.notebook2.nb.fdomain.1.can.c delete a
    foreach tag $domain_canTagL {
        catch {.result.notebook2.nb.fdomain.1.can.c delete $tag}
    }
    set domain_canTagL ""
    if {$env(contig.proteinL) ne " "} {
        set protL ""
        if {$env(sequence_type) eq "nucleotide"} {
            foreach protein $env(contig.proteinL) {
                if {[lindex $protein 4] eq 1} {
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, frame, orf, sequence FROM $env(contig.dbName).sequences_protein WHERE id_prot = '[lindex $protein 3]'"}}]]
                    foreach sRes $sql_res {
                        set name  [lindex $sRes 0]
                        set frame  [lindex $sRes 1]
                        set orf  [lindex $sRes 2]
                        set sequence [lindex $sRes 3]
                    }
                    unset sql_res
                    switch $frame {
                        + {set h 0; set i 0}
                        - {set h 1; set i 0}
                        1 {set h 0; set i 0}
                        2 {set h 0; set i 1}
                        3 {set h 0; set i 2}
                        4 {set h 1; set i 0}
                        5 {set h 1; set i 1}
                        6 {set h 1; set i 2}
                    }
                    
                    set pos [translateNuc $env(contig.sequence) $sequence $frame]
                    if {$h} {
                        set nstart [expr [string length $env(contig.sequence)] - [lindex $pos 1] - 1]
                        set nend [expr [string length $env(contig.sequence)] - [lindex $pos 0]]
                    } else {
                        set nstart [expr [lindex $pos 0] + 1]
                        set nend [lindex $pos 1]
                    }
                    lappend protL "$frame $orf $nstart $nend"
                }
            }
            set protL [lsort -index 0 -index 2 -integer $protL]
            set x 3
        } elseif {$env(sequence_type) eq "protein"} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT frame, orf, length FROM $env(contig.dbName).sequences_protein WHERE id_prot = '$env(contig.id_prot)'"}}]]
            foreach sRes $sql_res {
                set protL "{[lindex $sRes 0] [lindex $sRes 1] 1 [lindex $sRes 2]}"
            }
            unset sql_res
            set x 1
        }
        if {$protL ne ""} {
            set width [expr [winfo width .result.notebook2.nb.fdomain.1.can] - 40]
            set height [winfo height .result.notebook2.nb.fdomain.1.can]
            if {$width < 600} {
                set width 600
            }
            set w [expr $width.0 / [string length $env(contig.sequence)].0]
            
            set hitL ""
            set tmpL ""
            foreach ips $env(contig.ipsHitL) {
                set tmp [split [lindex $ips 1] _]
                if {[lindex $ips 2] ne "go" && [lindex $ips 2] ne "interpro"} {
                    set fr [split [lindex $ips 1] _]; set orf [string range [lindex $fr end] 3 end]; set fr [lindex $fr [expr [llength $fr] - 2]]
                    foreach prot $protL {
                        if {[lindex $prot 0] eq $fr && [lindex $prot 1] eq $orf} {
                            lappend hitL "[lindex $ips 2] [lindex $ips 3] {[lindex $ips 4]} [expr [lindex $ips 5] - 1] [lindex $ips 6] [lindex $prot 2] [lindex $prot 3] $fr $orf"
                            break
                        }
                    }
                }
            }
            set hitL [lsort -index 0 [lsort -integer -index 7 -index 5 [lsort -unique $hitL]]]
            .result.notebook2.nb.fdomain.1.can.c create rect 15 5 [expr 15 + $width] 10 -fill yellow -tag a
            set q 10
            
            set type ""
            foreach hit $hitL {
                lappend tmpL "[lindex $hit 0] [lindex $hit 1] {[lindex $hit 2]} [lindex $hit 3] [lindex $hit 4] [lindex $hit 5] [lindex $hit 6] [lindex $hit 7]"
                if {$type eq [lindex $hit 0]} {
                    if {$f eq [lindex $hit 7]} {
                        if {[lindex $hit 8] ne $orf} {
                            set orf [lindex $hit 8]
                            foreach prot $protL {
                                if {[lindex $prot 0] eq $f && [lindex $prot 1] eq $orf} {
                                    .result.notebook2.nb.fdomain.1.can.c create rect [expr 15 + int($w * [lindex $prot 2].0)] $q [expr 15 + int($w * [lindex $prot 3].0)] [expr $q + 3] -fill green -tag a
                                }
                            }
                        }
                        .result.notebook2.nb.fdomain.1.can.c create rect [expr 15 + int($w * ([lindex $hit 3].0 * $x.0 + [lindex $hit 5].0))] [expr $q - 2] [expr 15 + int($w * ([lindex $hit 4].0 * $x.0 + [lindex $hit 5].0))] [expr $q + 5] -fill red -tag "[lindex $hit 1][lindex $hit 3]"
                        lappend domain_canTagL "[lindex $hit 1][lindex $hit 3]"
                    } else {
                        set f [lindex $hit 7]
                        set orf [lindex $hit 8]
                        set q [expr $q + 16]
                        set fr_num 1
                        foreach prot $protL {
                            if {[lindex $prot 0] eq $f && [lindex $prot 1] eq $orf} {
                                if {$fr_num} {
                                    set fr_num 0
                                    .result.notebook2.nb.fdomain.1.can.c create text [expr 5 + int($w * [lindex $prot 2].0)] $q -text $f -anchor w -tag a
                                }
                                .result.notebook2.nb.fdomain.1.can.c create rect [expr 15 + int($w * [lindex $prot 2].0)] $q [expr 15 + int($w * [lindex $prot 3].0)] [expr $q + 3] -fill green -tag a
                            }
                        }
                        .result.notebook2.nb.fdomain.1.can.c create rect [expr 15 + int($w * ([lindex $hit 3].0 * $x.0 + [lindex $hit 5].0))] [expr $q - 2] [expr 15 + int($w * ([lindex $hit 4].0 * $x.0 + [lindex $hit 5].0))] [expr $q + 5] -fill red -tag "[lindex $hit 1][lindex $hit 3]"
                        lappend domain_canTagL "[lindex $hit 1][lindex $hit 3]"
                    }
                } else {
                    set f 0
                    set orf 0
                    set type [lindex $hit 0]
                    set q [expr $q + 16]
                    .result.notebook2.nb.fdomain.1.can.c create line 0 $q [expr $width + 20] $q -tag a
                    set q [expr $q + 10]
                    .result.notebook2.nb.fdomain.1.can.c create text 5 $q -text $type -anchor w -tag a
                    if {[lindex $hit 7] eq $f} {
                        if {[lindex $hit 8] ne $orf} {
                            set orf [lindex $hit 8]
                            foreach prot $protL {
                                if {[lindex $prot 0] eq $f && [lindex $prot 1] eq $orf} {
                                    .result.notebook2.nb.fdomain.1.can.c create rect [expr 15 + int($w * [lindex $prot 2].0)] $q [expr 15 + int($w * [lindex $prot 3].0)] [expr $q + 3] -fill green -tag a
                                }
                            }
                        }
                        .result.notebook2.nb.fdomain.1.can.c create rect [expr 15 + int($w * ([lindex $hit 3].0 * $x.0 + [lindex $hit 5].0))] [expr $q - 2] [expr 15 + int($w * ([lindex $hit 4].0 * $x.0 + [lindex $hit 5].0))] [expr $q + 5] -fill red -tag "[lindex $hit 1][lindex $hit 3]"
                        lappend domain_canTagL "[lindex $hit 1][lindex $hit 3]"
                    } else {
                        set f [lindex $hit 7]
                        set orf [lindex $hit 8]
                        set q [expr $q + 16]
                        set fr_num 1
                        foreach prot $protL {
                            if {[lindex $prot 0] eq $f && [lindex $prot 1] eq $orf} {
                                if {$fr_num} {
                                    set fr_num 0
                                    .result.notebook2.nb.fdomain.1.can.c create text [expr 5 + int($w * [lindex $prot 2].0)] $q -text $f -anchor w -tag a
                                }
                                .result.notebook2.nb.fdomain.1.can.c create rect [expr 15 + int($w * [lindex $prot 2].0)] $q [expr 15 + int($w * [lindex $prot 3].0)] [expr $q + 3] -fill green -tag a
                            }
                        }
                        .result.notebook2.nb.fdomain.1.can.c create rect [expr 15 + int($w * ([lindex $hit 3].0 * $x.0 + [lindex $hit 5].0))] [expr $q - 2] [expr 15 + int($w * ([lindex $hit 4].0 * $x.0 + [lindex $hit 5].0))] [expr $q + 5] -fill red -tag "[lindex $hit 1][lindex $hit 3]"
                        lappend domain_canTagL "[lindex $hit 1][lindex $hit 3]"
                    }
                }
            }
            set domain_canTagL [lsort -unique $domain_canTagL]
            set tmpL [lsort -unique $tmpL]
            foreach hit $tmpL {
                .result.notebook2.nb.fdomain.1.tab.table.l insert end "$hit"
                .result.notebook2.nb.fdomain.1.tab.table.l cellconfigure end,1 -window fillTable_createButton
            }
            unset hitL; unset tmpL
            
            set scrollregion "0 0 [expr $width + 20] [expr $q + 20]"
            .result.notebook2.nb.fdomain.1.can.c configure -scrollregion $scrollregion
            
            # Bindings.
            bind [.result.notebook2.nb.fdomain.1.tab.table.l bodypath] <Button-1> "
            set y \[.result.notebook2.nb.fdomain.1.tab.table.l nearest \[expr {%y + \[winfo y %W\]}\]\]
            set id \[lindex \[.result.notebook2.nb.fdomain.1.tab.table.l get \$y\] 1\]
            set hstart \[lindex \[.result.notebook2.nb.fdomain.1.tab.table.l get \$y\] 3\]
            set hend \[lindex \[.result.notebook2.nb.fdomain.1.tab.table.l get \$y\] 4\]
            set fstart \[lindex \[.result.notebook2.nb.fdomain.1.tab.table.l get \$y\] 5\]
            set fend \[lindex \[.result.notebook2.nb.fdomain.1.tab.table.l get \$y\] 6\]
            set fr \[lindex \[.result.notebook2.nb.fdomain.1.tab.table.l get \$y\] 7\]
            append id \$hstart
            update_info_domain_viewer \$id \$hstart \$hend \$fstart \$fend \$fr
            "
        }
    }
}

proc update_info_domain_viewer {id hstart hend fs fe fr} {
    global env
    global oldTag_dv
    
    if {$env(sequence_type) eq "nucleotide"} {
        set x 3
    } elseif {$env(sequence_type) eq "protein"} {
        set x 1
    }
    
    catch {.result.notebook2.nb.fdomain.1.can.c itemconfigure [lindex $oldTag_dv 0] -fill [lindex $oldTag_dv 1]}
    catch {
        set oldTag_dv "$id [.result.notebook2.nb.fdomain.1.can.c itemcget $id -fill]"
        .result.notebook2.nb.fdomain.1.can.c itemconfigure $id -fill yellow
    }
    catch {.result.notebook1.nb.fsb.1.panel tag remove markedGreen 1.0 1000.end}
    catch {.result.notebook1.nb.fsb.1.panel tag remove markedOrange 1.0 1000.end}
    if {$fr < 4} {
        set fstart $fs
        set fend $fe
    } else  {
        set fstart [expr [string length [.result.notebook1.nb.fsb.1.panel get -displaychars 2.0 2.end]] - $fe]
        set fend [expr [string length [.result.notebook1.nb.fsb.1.panel get -displaychars 2.0 2.end]] - $fs]
    }
    .result.notebook1.nb.fsb.1.panel tag add markedGreen 2.$fstart 2.$fend
    catch {
        if {$hstart > $hend} {
            .result.notebook1.nb.fsb.1.panel tag add markedOrange 2.[expr $x * $hend + $fstart] 2.[expr $x * $hstart + $fstart]
        } else {
            .result.notebook1.nb.fsb.1.panel tag add markedOrange 2.[expr $x * $hstart + $fstart] 2.[expr $x * $hend + $fstart]
        }
    }
}

proc rightmenu_domain_viewer {mode feat id coord} {
    global env
    
    .rightmenu delete 0 end
    .rightmenu.hidemenuColumn delete 0 end
    .rightmenu.copymenu delete 0 end
    
    .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
    .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook2.nb.fdomain.1.tab.table.l}"
    .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook2.nb.fdomain.1.tab.table.l}"
    .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook2.nb.fdomain.1.tab.table.l}"
    .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook2.nb.fdomain.1.tab.table.l}"
    
    tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
}