proc makeblastDB_init {} {
    #Creating menu buttons
    .menubar.module.menu add command -label "Create Blast-Database" -command "makeBlastDB"
}

proc makeblastDB_remove {} {
    #Remove menu buttons
    .menubar.module.menu delete "Create Blast-Database"
}

proc makeBlastDB {} {
    global env
    
    if {$env(dbName) ne " "} {
        set t .makeBlastDB
        catch {destroy $t}
        toplevel $t
        wm title $t "Create Blast Database"
        wm resizable $t 0 0
        wm attributes $t -topmost 1
        
        frame $t.ptitle
        label $t.ptitle.label -text "Create Blast dastabase of:\n\n$env(dbName)\n"
        label $t.ptitle.label2 -text "Choose input sequences:"
        ComboBox $t.ptitle.cb -width 15 -hottrack 1 -background white -text "sequences_nucleotide" -values {sequences_nucleotide sequences_protein sequences_read}
        
        set comm "makeBlastDB_run $env(dbName) 1"
        frame $t.buts -bd 2 -relief groove
        button $t.buts.ok -text "OK" -command $comm
        button $t.buts.cancel -text "Cancel" -command "destroy $t"
        
        pack $t.ptitle.label -side top -fill both; pack $t.ptitle.label2 $t.ptitle.cb -side top -fill both -anchor w
        pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
        pack $t.ptitle $t.buts -side top -fill both
        
        wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
        raise $t
    } else {
        ::errorPopUp "Error" "No database selected."
    }
}

proc makeBlastDB_run {dbName mode} {
    global env
    if {$mode} {
        set db_input [.makeBlastDB.ptitle.cb get]
        destroy .makeBlastDB
        if {$db_input eq "sequences_protein"} {
            set dbtype prot
            set dbblast "$dbName"; append dbblast "_prot"
        } else {
            set dbtype nucl
            set dbblast "$dbName"
            if {$db_input eq "sequences_read"} {
                append dbblast "_reads"
            }
        }
        set out ""
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, sequence FROM $dbName.$db_input"}}]]
        foreach sRes $sql_res {
            append out ">[lindex $sRes 0]\n[lindex $sRes 1]\n"
        }
        unset sql_res
        if {$out ne ""} {
            set dir [tk_chooseDirectory -initialdir [pwd]/blast_dbs/]
            if {[catch {set ft [open [pwd]/blast_dbs/$dbblast.fasta w]} ]} {
            } else {
                puts $ft $out
                close $ft
                if {$env(platform) == "windows"} {
                    set comm "makeblastdb.exe -parse_seqids -dbtype $dbtype -in [pwd]/blast_dbs/$dbblast.fasta -out $dir/$dbblast"
                } elseif {$env(platform) == "unix"} {
                    set comm "makeblastdb -parse_seqids -dbtype $dbtype -in [pwd]/blast_dbs/$dbblast.fasta -out $dir/$dbblast"
                }
                set err ""
                if {[catch {eval exec $comm} err]} {
                    ::errorPopUp module "Error: Format database failed.\n\n$err"
                }
                catch {file delete [pwd]/blast_dbs/$dbblast.fasta}
            }
            ::blast_dbL
        } else {
            ::errorPopUp module "Error: No sequences found."
        }
    }  
}
