proc primer3_init {} {
    global env
    global checkedImg
    global uncheckedImg
    global closeImg
    global primer3_minTm
    global primer3_optTm
    global primer3_maxTm
    global primer3_minLen
    global primer3_optLen
    global primer3_maxLen
    global primer3_minGC
    global primer3_optGC
    global primer3_maxGC
    global primer3_minPTm
    global primer3_optPTm
    global primer3_maxPTm
    global primer3_polyx
    global primer3_productSize
    global primer3_optionsCheck
    global primer3_primNum
    global primer3_maxTmDiff
    global primer3_saltCon
    global primer3_primCon
    global primer3_maxSelf
    global primer3_maxEnd
    global primer3_numNs
    
    set primer_listCheck 0
    
    #Creating menu buttons
    .menubar.config.menu add command -label "Primer" -command "primer3_config"
    .menubar.tool.menu add command -label "Primer3" -command "primer3_window - all"
    .menubar.tab.menu add command -label "Primer" -command "catch {create_tab primer}"
    
    if {[catch {set ft [open [pwd]/conf/primer3_tace.conf r]} ]} {
        #Primer
        set env(primer.sequence) "+"
        set env(primer.pair_penalty) "+"
        set env(primer.penalty) "-"
        set env(primer.pos) "+"
        set env(primer.len) "-"
        set env(primer.tm) "+"
        set env(primer.gc) "-"
        set env(primer.self_any) "-"
        set env(primer.self_end) "-"
        set env(primer.end_stability) "-"
        set env(primer.pair_compl_any) "-"
        set env(primer.pair_compl_end) "-"
        set env(primer.product_size) "+"
        set env(primer.product_tm) "+"
        set env(primer.product_tm_oligo_tm_diff) "-"
        set env(primer.pair_t_opt_a) "+"
        set env(primer.salt_con) "-"
        set env(primer.dna_con) "-"
        #Primer Parameters
        set primer3_minTm 55.0
        set primer3_optTm 60.0
        set primer3_maxTm 65.0
        set primer3_minLen 17
        set primer3_optLen 20
        set primer3_maxLen 23
        set primer3_minGC 20
        set primer3_optGC 50
        set primer3_maxGC 80
        set primer3_minPTm 65.0
        set primer3_optPTm 75.0
        set primer3_maxPTm 85.0
        set primer3_polyx 3
        set primer3_productSize "100-300"
        set primer3_optionsCheck 0
        set primer3_primNum 5
        set primer3_maxTmDiff 2.0
        set primer3_saltCon 50
        set primer3_primCon 50
        set primer3_maxSelf 8.00
        set primer3_maxEnd 3.00
        set primer3_numNs 0
    } else {
        #Primer
        gets $ft line
        gets $ft line
        set env(primer.sequence) [lindex $line 0]
        set env(primer.pair_penalty) [lindex $line 1]
        set env(primer.penalty) [lindex $line 2]
        set env(primer.pos) [lindex $line 3]
        set env(primer.len) [lindex $line 4]
        set env(primer.tm) [lindex $line 5]
        set env(primer.gc) [lindex $line 6]
        set env(primer.self_any) [lindex $line 7]
        set env(primer.self_end) [lindex $line 8]
        set env(primer.end_stability) [lindex $line 9]
        set env(primer.pair_compl_any) [lindex $line 10]
        set env(primer.pair_compl_end) [lindex $line 11]
        set env(primer.product_size) [lindex $line 12]
        set env(primer.product_tm) [lindex $line 13]
        set env(primer.product_tm_oligo_tm_diff) [lindex $line 14]
        set env(primer.pair_t_opt_a) [lindex $line 15]
        set env(primer.salt_con) [lindex $line 16]
        set env(primer.dna_con) [lindex $line 17]
        #Primer Parameters
        gets $ft line
        gets $ft line
        set primer3_minTm [lindex $line 0]
        set primer3_optTm [lindex $line 1]
        set primer3_maxTm [lindex $line 2]
        set primer3_minLen [lindex $line 3]
        set primer3_optLen [lindex $line 4]
        set primer3_maxLen [lindex $line 5]
        set primer3_minGC [lindex $line 6]
        set primer3_optGC [lindex $line 7]
        set primer3_maxGC [lindex $line 8]
        set primer3_minPTm [lindex $line 9]
        set primer3_optPTm [lindex $line 10]
        set primer3_maxPTm [lindex $line 11]
        set primer3_polyx [lindex $line 12]
        set primer3_productSize [lindex $line 13]
        set primer3_primNum [lindex $line 14]
        set primer3_maxTmDiff [lindex $line 15]
        set primer3_saltCon [lindex $line 16]
        set primer3_primCon [lindex $line 17]
        set primer3_maxSelf [lindex $line 18]
        set primer3_maxEnd [lindex $line 19]
        set primer3_numNs [lindex $line 20]
        set primer3_optionsCheck [lindex $line 21]
    }
    
    set notebook .result.notebook2.nb
    set frame [$notebook insert end primer -text "Primer" -raisecmd "catch {update_info_primer}"]
    frame $frame.0
    label $frame.0.label1 -font 12
    checkbutton $frame.0.list -text "List" -variable primer_listCheck -command {if {$primer_listCheck} {primer_list} else {catch {destroy .primer_list}}}
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command "::close_tab primer"
    frame $frame.1
    frame $frame.1.table
    scrollbar $frame.1.y -orient vertical -command "$frame.1.table.l yview"
    scrollbar $frame.x -orient horizontal -command "$frame.1.table.l xview"
    set nb2_tl_primer $frame.1.table.l
    tablelist::tablelist $nb2_tl_primer \
            -width 10 -height 1 -showseparators 1 -stripebackground lightblue\
            -columns {
                0 "" 0 "Penalty" 0 "F penalty" 0 "R penalty" 0 "Forward Primer" 0 "Reverse Primer" 0 "Prod. size" 0 "F Len" 0 "R Len" \
                0 "F Pos" 0 "R Pos" 0 "Opt. Ta" 0 "Prod. Tm" 0 "Tm diff. (prod. vs. oligo)" \
                0 "F Tm" 0 "R Tm" 0 "F GC" 0 "R GC" 0 "Pair compl." 0 "Pair compl. end" 0 "F self align" \
                0 "R self align" 0 "F self align end" 0 "R self align end" 0 "F end stability" \
                0 "R end stability" 0 "Salt conc. (mM)" 0 "Oligo conc. (nM)" 0 "id_seq"} \
            -labelcommand "$nb2_tl_primer finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -stretch all \
            -selectmode single \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.y set" \
            -xscrollcommand "$frame.x set" \
            -background white
    $nb2_tl_primer columnconfigure 0 \
            -sortmode integer \
            -editable yes \
            -editwindow checkbutton \
            -formatcommand emptystr \
            -labelimage [expr {1 ? $checkedImg : $uncheckedImg}] \
            -labelcommand "table_selection"
    
    $nb2_tl_primer columnconfigure 28 -hide yes
    for {set i 1} {$i <= 5} {incr i} {
        $nb2_tl_primer columnconfigure $i -sortmode dictionary
    }
    
    if {$env(primer.sequence) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 4 -hide no
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 5 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 4 -hide yes
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 5 -hide yes
    }
    if {$env(primer.pair_penalty) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 1 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 1 -hide yes
    }
    if {$env(primer.penalty) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 2 -hide no
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 3 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 2 -hide yes
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 3 -hide yes
    }
    if {$env(primer.pos) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 9 -hide no
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 10 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 9 -hide yes
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 10 -hide yes
    }
    if {$env(primer.len) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 7 -hide no
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 8 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 7 -hide yes
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 8 -hide yes
    }
    if {$env(primer.tm) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 14 -hide no
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 15 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 14 -hide yes
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 15 -hide yes
    }
    if {$env(primer.gc) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 16 -hide no
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 17 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 16 -hide yes
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 17 -hide yes
    }
    if {$env(primer.self_any) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 20 -hide no
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 21 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 20 -hide yes
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 21 -hide yes
    }
    if {$env(primer.self_end) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 22 -hide no
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 23 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 22 -hide yes
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 23 -hide yes
    }
    if {$env(primer.end_stability) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 24 -hide no
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 25 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 24 -hide yes
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 25 -hide yes
    }
    if {$env(primer.pair_compl_any) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 18 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 18 -hide yes
    }
    if {$env(primer.pair_compl_end) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 19 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 19 -hide yes
    }
    if {$env(primer.product_size) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 6 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 6 -hide yes
    }
    if {$env(primer.product_tm) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 12 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 12 -hide yes
    }
    if {$env(primer.product_tm_oligo_tm_diff) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 13 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 13 -hide yes
    }
    if {$env(primer.pair_t_opt_a) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 11 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 11 -hide yes
    }
    if {$env(primer.salt_con) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 26 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 26 -hide yes
    }
    if {$env(primer.dna_con) eq "+"} {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 27 -hide no
    } else {
        .result.notebook2.nb.fprimer.1.table.l columnconfigure 27 -hide yes
    }
    
    pack $frame.1.table.l -side left -fill both -expand true
    pack $frame.1.y -side left -fill both; pack $frame.1.table -side left -fill both -expand true
    pack $frame.0.label1 -side left -fill both -anchor w; pack $frame.0.exit $frame.0.list -side right -fill both -anchor e
    pack $frame.0 -side top -fill both; pack $frame.1 -side top -fill both -expand true
    pack $frame.x -side top -fill both
    
    #Primer3 rightmenu
    set tl .result.notebook2.nb.fprimer.1.table.l
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    set id \[lindex \[$tl get \$y\] 2\]
    rightmenu_primer3 primer primer \$id \$coord
    "
}

proc primer3_remove {} {
    #Remove menu buttons
    .menubar.config.menu delete "Primer"
    .menubar.tool.menu delete "Primer3"
    .menubar.tab.menu delete "Primer"
    .result.notebook2.nb delete primer
}

proc primer3_window {db id_seq} {
    global env
    global primer3_minTm
    global primer3_optTm
    global primer3_maxTm
    global primer3_minLen
    global primer3_optLen
    global primer3_maxLen
    global primer3_minGC
    global primer3_optGC
    global primer3_maxGC
    global primer3_minPTm
    global primer3_optPTm
    global primer3_maxPTm
    global primer3_polyx
    global primer3_productSize
    global primer3_optionsCheck
    global primer3_primNum
    global primer3_maxTmDiff
    global primer3_saltCon
    global primer3_primCon
    global primer3_maxSelf
    global primer3_maxEnd
    global primer3_numNs
    global primer3_writeDB
    
    if {$env(dbName) ne " "} {
        if {[.result.notebook1.nb raise] ne "db_info" && [.result.notebook1.nb raise] ne "blast"  && [.result.notebook1.nb raise] ne "db_stat" && [.result.notebook1.nb raise] ne "sb" && [.result.notebook1.nb raise] ne "process"} {
            set t .primer3
            catch {destroy $t}
            toplevel $t
            wm title $t "Create primers (Primer3)"
            wm resizable $t 0 0
            wm attributes $t -topmost 1
            
            # Top "primer parameters" control panel
            frame $t.params
            frame $t.params.top -bd 2 -relief groove
            
            frame $t.params.top.tm
            label $t.params.top.tm.label -text "Tm (° Celsius)"
            frame $t.params.top.tm.min -bd 2 -relief groove
            label $t.params.top.tm.min.label -text "Min"
            entry $t.params.top.tm.min.ent -textvariable primer3_minTm -width 5 -background white
            frame $t.params.top.tm.opt -bd 2 -relief groove
            label $t.params.top.tm.opt.label -text "Opt"
            entry $t.params.top.tm.opt.ent -textvariable primer3_optTm -width 5 -background white
            frame $t.params.top.tm.max -bd 2 -relief groove
            label $t.params.top.tm.max.label -text "Max"
            entry $t.params.top.tm.max.ent -textvariable primer3_maxTm -width 5 -background white
            
            frame $t.params.top.len
            label $t.params.top.len.label -text "Primer length (bp)"
            frame $t.params.top.len.min -bd 2 -relief groove
            label $t.params.top.len.min.label -text "Min"
            entry $t.params.top.len.min.ent -textvariable primer3_minLen -width 5 -background white
            frame $t.params.top.len.opt -bd 2 -relief groove
            label $t.params.top.len.opt.label -text "Opt"
            entry $t.params.top.len.opt.ent -textvariable primer3_optLen -width 5 -background white
            frame $t.params.top.len.max -bd 2 -relief groove
            label $t.params.top.len.max.label -text "Max"
            entry $t.params.top.len.max.ent -textvariable primer3_maxLen -width 5 -background white
            
            frame $t.params.top.gc
            label $t.params.top.gc.label -text "GC content (%)"
            frame $t.params.top.gc.min -bd 2 -relief groove
            label $t.params.top.gc.min.label -text "Min"
            entry $t.params.top.gc.min.ent -textvariable primer3_minGC -width 5 -background white
            frame $t.params.top.gc.opt -bd 2 -relief groove
            label $t.params.top.gc.opt.label -text "Opt"
            entry $t.params.top.gc.opt.ent -textvariable primer3_optGC -width 5 -background white
            frame $t.params.top.gc.max -bd 2 -relief groove
            label $t.params.top.gc.max.label -text "Max"
            entry $t.params.top.gc.max.ent -textvariable primer3_maxGC -width 5 -background white
            
            label $t.params.top.label -text "   "
            
            frame $t.params.top.ptm
            label $t.params.top.ptm.label -text "Product Tm (°C)"
            frame $t.params.top.ptm.min -bd 2 -relief groove
            label $t.params.top.ptm.min.label -text "Min"
            entry $t.params.top.ptm.min.ent -textvariable primer3_minPTm -width 5 -background white
            frame $t.params.top.ptm.opt -bd 2 -relief groove
            label $t.params.top.ptm.opt.label -text "Opt"
            entry $t.params.top.ptm.opt.ent -textvariable primer3_optPTm -width 5 -background white
            frame $t.params.top.ptm.max -bd 2 -relief groove
            label $t.params.top.ptm.max.label -text "Max"
            entry $t.params.top.ptm.max.ent -textvariable primer3_maxPTm -width 5 -background white
            
            frame $t.params.top.polx
            label $t.params.top.polx.label -text "Max. Poly X"
            entry $t.params.top.polx.ent -textvariable primer3_polyx -width 5 -background white
            
            frame $t.params.top.psize
            label $t.params.top.psize.label -text "Product size list"
            entry $t.params.top.psize.ent -textvariable primer3_productSize -width 23 -background white
            
            #Packing top parameters
            pack $t.params.top.tm.min.label $t.params.top.tm.min.ent -side left
            pack $t.params.top.tm.opt.label $t.params.top.tm.opt.ent -side left
            pack $t.params.top.tm.max.label $t.params.top.tm.max.ent -side left
            pack $t.params.top.tm.label -side left
            pack $t.params.top.tm.max $t.params.top.tm.opt $t.params.top.tm.min -side right
            
            pack $t.params.top.len.min.label $t.params.top.len.min.ent -side left
            pack $t.params.top.len.opt.label $t.params.top.len.opt.ent -side left
            pack $t.params.top.len.max.label $t.params.top.len.max.ent -side left
            pack $t.params.top.len.label -side left
            pack $t.params.top.len.max $t.params.top.len.opt $t.params.top.len.min -side right
            
            pack $t.params.top.gc.min.label $t.params.top.gc.min.ent -side left
            pack $t.params.top.gc.opt.label $t.params.top.gc.opt.ent -side left
            pack $t.params.top.gc.max.label $t.params.top.gc.max.ent -side left
            pack $t.params.top.gc.label -side left
            pack $t.params.top.gc.max $t.params.top.gc.opt $t.params.top.gc.min -side right
            
            pack $t.params.top.polx.label -side left; pack $t.params.top.polx.ent -side right
            
            pack $t.params.top.ptm.min.label $t.params.top.ptm.min.ent -side left
            pack $t.params.top.ptm.opt.label $t.params.top.ptm.opt.ent -side left
            pack $t.params.top.ptm.max.label $t.params.top.ptm.max.ent -side left
            pack $t.params.top.ptm.label -side left
            pack $t.params.top.ptm.max $t.params.top.ptm.opt $t.params.top.ptm.min -side right
            
            pack $t.params.top.psize.label -side left; pack $t.params.top.psize.ent -side right
            
            pack $t.params.top.tm $t.params.top.len $t.params.top.gc $t.params.top.polx $t.params.top.label $t.params.top.ptm $t.params.top.psize -side top -fill both
            pack $t.params.top -side top -fill both
            
            # Extended "primer parameters" control panel
            frame $t.params.bottom -bd 2 -relief groove
            frame $t.params.bottom.primNum
            label $t.params.bottom.primNum.label -text "Num. of results"
            entry $t.params.bottom.primNum.ent -textvariable primer3_primNum -width 5 -background white
            frame $t.params.bottom.maxTmDiff
            label $t.params.bottom.maxTmDiff.label -text "Max. Tm differance"
            entry $t.params.bottom.maxTmDiff.ent -textvariable primer3_maxTmDiff -width 5 -background white
            frame $t.params.bottom.saltCon
            label $t.params.bottom.saltCon.label -text "Salt conc. (mM) in PCR"
            entry $t.params.bottom.saltCon.ent -textvariable primer3_saltCon -width 5 -background white
            frame $t.params.bottom.primCon
            label $t.params.bottom.primCon.label -text "Primer conc. (nM) in PCR"
            entry $t.params.bottom.primCon.ent -textvariable primer3_primCon -width 5 -background white
            frame $t.params.bottom.maxSelf
            label $t.params.bottom.maxSelf.label -text "Max. complementary"
            entry $t.params.bottom.maxSelf.ent -textvariable primer3_maxSelf -width 5 -background white
            frame $t.params.bottom.maxEnd
            label $t.params.bottom.maxEnd.label -text "Max. 3' complementary"
            entry $t.params.bottom.maxEnd.ent -textvariable primer3_maxEnd -width 5 -background white
            frame $t.params.bottom.numNs
            label $t.params.bottom.numNs.label -text "Num of allowed Ns"
            entry $t.params.bottom.numNs.ent -textvariable primer3_numNs -width 5 -background white
            
            #Packing extended parameters
            pack $t.params.bottom.primNum.label -side left; pack $t.params.bottom.primNum.ent -side right
            pack $t.params.bottom.maxTmDiff.label -side left; pack $t.params.bottom.maxTmDiff.ent -side right
            pack $t.params.bottom.saltCon.label -side left; pack $t.params.bottom.saltCon.ent -side right
            pack $t.params.bottom.primCon.label -side left; pack $t.params.bottom.primCon.ent -side right
            pack $t.params.bottom.maxSelf.label -side left; pack $t.params.bottom.maxSelf.ent -side right
            pack $t.params.bottom.maxEnd.label -side left; pack $t.params.bottom.maxEnd.ent -side right
            pack $t.params.bottom.numNs.label -side left; pack $t.params.bottom.numNs.ent -side right
            pack $t.params.bottom.primNum $t.params.bottom.maxTmDiff $t.params.bottom.saltCon $t.params.bottom.primCon $t.params.bottom.maxSelf $t.params.bottom.maxEnd $t.params.bottom.numNs -side top -fill both
            if {$primer3_optionsCheck} {pack .primer3.params.bottom -side bottom -fill both}
            
            pack $t.params -side top
            
            #Show extended options
            checkbutton $t.optionsCheck -text "Extended options" -variable primer3_optionsCheck -command {if {$primer3_optionsCheck} {pack .primer3.params.bottom -side bottom -fill both} else {pack forget .primer3.params.bottom}}
            pack $t.optionsCheck -side top -fill both
            
            #Write to DB or show results
            frame $t.radio
            radiobutton $t.radio.showRes -text "Show results" -variable primer3_writeDB -value "0"
            radiobutton $t.radio.writeDB -text "Write to DB" -variable primer3_writeDB -value "1"
            $t.radio.showRes select
            
            pack $t.radio.showRes $t.radio.writeDB -side top -anchor w
            pack $t.radio -side top -anchor w
            
            #The Buttons Ok, Close, Help and Save
            frame $t.buts -bd 2 -relief groove
            button $t.buts.okay -text "OK" -command "primer3_run $db $id_seq; destroy $t"
            button $t.buts.cancel -text "Cancel" -command "destroy $t"
            button $t.buts.save -text "Save" -command "primer3_changeConfig p3params"
            pack $t.buts.okay $t.buts.cancel -side left; pack $t.buts.save -side right
            pack $t.buts -side bottom -fill both
            
            wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
            raise $t
        } else {
            ::errorPopUp "Error - Primer3" "Please select 'Database browser' or a project tab."
        }
    } else {
        ::errorPopUp "Error" "No database selected."
    }
}

proc primer3_run {db id_seq} {
    global env
    global dbName_contig
    global primer3_minTm
    global primer3_optTm
    global primer3_maxTm
    global primer3_minLen
    global primer3_optLen
    global primer3_maxLen
    global primer3_minGC
    global primer3_optGC
    global primer3_maxGC
    global primer3_minPTm
    global primer3_optPTm
    global primer3_maxPTm
    global primer3_polyx
    global primer3_productSize
    global primer3_optionsCheck
    global primer3_primNum
    global primer3_maxTmDiff
    global primer3_saltCon
    global primer3_primCon
    global primer3_maxSelf
    global primer3_maxEnd
    global primer3_numNs
    global primer3_writeDB
    
    set primer3_minTm [.primer3.params.top.tm.min.ent get]
    set primer3_optTm [.primer3.params.top.tm.opt.ent get]
    set primer3_maxTm [.primer3.params.top.tm.max.ent get]
    set primer3_minLen [.primer3.params.top.len.min.ent get]
    set primer3_optLen [.primer3.params.top.len.opt.ent get]
    set primer3_maxLen [.primer3.params.top.len.max.ent get]
    set primer3_minGC [.primer3.params.top.gc.min.ent get]
    set primer3_optGC [.primer3.params.top.gc.opt.ent get]
    set primer3_maxGC [.primer3.params.top.gc.max.ent get]
    set primer3_minPTm [.primer3.params.top.ptm.min.ent get]
    set primer3_optPTm [.primer3.params.top.ptm.opt.ent get]
    set primer3_maxPTm [.primer3.params.top.ptm.max.ent get]
    set primer3_polyx [.primer3.params.top.polx.ent get]
    set primer3_productSize [.primer3.params.top.psize.ent get]
    lappend paramL "PRIMER_MIN_TM $primer3_minTm"
    lappend paramL "PRIMER_OPT_TM $primer3_optTm"
    lappend paramL "PRIMER_MAX_TM $primer3_maxTm"
    lappend paramL "PRIMER_MIN_SIZE $primer3_minLen"
    lappend paramL "PRIMER_OPT_SIZE $primer3_optLen"
    lappend paramL "PRIMER_MAX_SIZE $primer3_maxLen"
    lappend paramL "PRIMER_MIN_GC $primer3_minGC"
    lappend paramL "PRIMER_OPT_GC $primer3_optGC"
    lappend paramL "PRIMER_MAX_GC $primer3_maxGC"
    lappend paramL "PRIMER_PRODUCT_MIN_TM $primer3_minPTm"
    lappend paramL "PRIMER_PRODUCT_OPT_TM $primer3_optPTm"
    lappend paramL "PRIMER_PRODUCT_MAX_TM $primer3_maxPTm"
    lappend paramL "PRIMER_MAX_POLY_X $primer3_polyx"
    lappend paramL "PRIMER_PRODUCT_SIZE_RANGE {$primer3_productSize}"
    if {$primer3_optionsCheck} {
        set primer3_primNum [.primer3.params.bottom.primNum.ent get]
        set primer3_maxTmDiff [.primer3.params.bottom.maxTmDiff.ent get]
        set primer3_saltCon [.primer3.params.bottom.saltCon.ent get]
        set primer3_primCon [.primer3.params.bottom.primCon.ent get]
        set primer3_maxSelf [.primer3.params.bottom.maxSelf.ent get]
        set primer3_maxEnd [.primer3.params.bottom.maxEnd.ent get]
        set primer3_numNs [.primer3.params.bottom.numNs.ent get]
        lappend paramL "PRIMER_NUM_RETURN $primer3_primNum"
        lappend paramL "PRIMER_MAX_DIFF_TM $primer3_maxTmDiff"
        lappend paramL "PRIMER_SALT_CONC $primer3_saltCon"
        lappend paramL "PRIMER_DNA_CONC $primer3_primCon"
        lappend paramL "PRIMER_SELF_ANY $primer3_maxSelf"
        lappend paramL "PRIMER_SELF_END $primer3_maxEnd"
        lappend paramL "PRIMER_NUM_NS_ACCEPTED $primer3_numNs"
    }
    
    if {[.result.notebook1.nb raise] ne "db_info" && [.result.notebook1.nb raise] ne "blast"  && [.result.notebook1.nb raise] ne "db_stat" && [.result.notebook1.nb raise] ne "sb" && [.result.notebook1.nb raise] ne "process"} {
        if {$id_seq eq "all"} {
            set tl ".result.notebook1.nb.f[.result.notebook1.nb raise].1.table.l"
            $tl finishediting
            set idL ""
            set tmpString ""
            set stop 0
            set i 0
            while {$stop ne 1} {
                if {[lindex [$tl get $i] 0] eq 1} {
                    lappend idL "[lindex [$tl get $i] 23] [lindex [$tl get $i] 24] [lindex [$tl get $i] 2]"
                } elseif {[lindex [$tl get $i] 0] eq ""} {
                    set stop 1
                }
                incr i
            }
            set idL [lsort -index 1 $idL]
        } else {
            set idL "{$id_seq $db Query}"
        }
        set primer3_input ""
        if {$idL ne ""} {
            foreach param $paramL {
                if {[lindex $param 1] ne ""} {
                    append primer3_input "\n[lindex $param 0]=[lindex $param 1]"
                    if {$param eq "nPRIMER_NUM_NS_ACCEPTED"} {
                        append primer3_input "\nPRIMER_LIBERAL_BASE=1"
                    }
                }
            }
            set primer3_input [regsub {\n} $primer3_input ""]
            
            set ::threadPrimer3 [thread::create {
                proc primer3 {idL primer3_input primer3_writeDB mainThreadID phpThreadID} {
                    global env
                    set db ""
                    set tmpString ""
                    
                    set id_seq ""
                    set primer_pair_penalty ""
                    set primer_forward_penalty ""
                    set primer_reverse_penalty ""
                    set primer_forward_sequence ""
                    set primer_reverse_sequence ""
                    set primer_forward_pos ""
                    set primer_reverse_pos ""
                    set primer_forward_len ""
                    set primer_reverse_len ""
                    set primer_forward_tm ""
                    set primer_reverse_tm ""
                    set primer_forward_gc ""
                    set primer_reverse_gc ""
                    set primer_forward_self_any ""
                    set primer_reverse_self_any ""
                    set primer_forward_self_end ""
                    set primer_reverse_self_end ""
                    set primer_forward_end_stability ""
                    set primer_reverse_end_stability ""
                    set primer_pair_compl_any ""
                    set primer_pair_compl_end ""
                    set primer_product_size ""
                    set primer_product_tm ""
                    set primer_product_tm_oligo_tm_diff ""
                    set primer_pair_t_opt_a ""
                    set salt_con "?"
                    set dna_con "?"
                    
                    foreach id $idL {
                        if {$db eq [lindex $id 1]} {
                            append tmpString ", '[lindex $id 0]'"
                        } elseif {$db eq ""} {
                            set tmpString ", '[lindex $id 0]'"
                            set db [lindex $id 1]
                        } else {
                            set tmpString [string range $tmpString 2 end]
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, sequence FROM $db.sequences_nucleotide WHERE id_seq IN ($tmpString)"}}]]
                            foreach sRes $sql_res {
                                append primer3_input "\nPRIMER_SEQUENCE_ID=[lindex $sRes 0]\nSEQUENCE=[string map {R N Y N K N M N H N D N B N V N r N y N k N m N h N d N b N v N} [lindex $sRes 1]]\n="
                            }
                            unset sql_res
                            set tmpString ", '[lindex $id 0]'"
                            set db [lindex $id 1]
                        }
                    }
                    set tmpString [string range $tmpString 2 end]
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, sequence FROM $db.sequences_nucleotide WHERE id_seq IN ($tmpString)"}}]]
                    foreach sRes $sql_res {
                        append primer3_input "\nPRIMER_SEQUENCE_ID=[lindex $sRes 0]\nSEQUENCE=[lindex $sRes 1]\n="
                    }
                    unset sql_res; unset tmpString
                    if {[catch {set ft [open $env(homeFolder)/primer3input.txt w]}]} {
                        eval [subst {thread::send -async $mainThreadID {errorPopUp "Error" "Could not write file primer3input.txt.\n\nPlease check the HomeFolder setting."}}]
                    } else {
                        puts -nonewline $ft $primer3_input
                        close $ft
                        unset primer3_input
                        
                        #Running Primer3
                        if {$env(platform) == "windows"} {
                            set comm "primer3_core.exe < $env(homeFolder)/primer3input.txt"
                        } elseif {$env(platform) == "unix"} {
                            set comm "primer3_core < $env(homeFolder)/primer3input.txt"
                        }
                        if {[catch {set primer3result [eval exec $comm]}]} {
                            eval [subst {thread::send -async $mainThreadID {errorPopUp "Error" "Could not execute Primer3.\n\nIs the primer3_core executable\nincluded in the system path?"}}]
                        }
                        
                        catch {file delete $env(homeFolder)/primer3input.txt}
                        set primer3result "{[regsub -all {\n} $primer3result "\} \{"]}"
                        
                        puts $primer3result
                        set primL ""
                        foreach line $primer3result {
                            set line [split $line =]
                            if {[lindex $line 0] eq "PRIMER_SEQUENCE_ID"} {
                                if {$primer_pair_penalty ne ""} {
                                    set i [lsearch -index 0 $idL $id_seq]
                                    lappend primL "$id_seq $primer_forward_sequence $primer_reverse_sequence \
                                            $primer_pair_penalty $primer_forward_penalty $primer_reverse_penalty \
                                            $primer_forward_pos $primer_reverse_pos $primer_forward_len \
                                            $primer_reverse_len $primer_forward_tm $primer_reverse_tm \
                                            $primer_forward_gc $primer_reverse_gc $primer_forward_self_any \
                                            $primer_reverse_self_any $primer_forward_self_end $primer_reverse_self_end \
                                            $primer_forward_end_stability $primer_reverse_end_stability \
                                            $primer_pair_compl_any $primer_pair_compl_end $primer_product_size \
                                            $primer_product_tm $primer_product_tm_oligo_tm_diff $primer_pair_t_opt_a \
                                            $salt_con $dna_con [lindex [lindex $idL $i] 1] [lindex [lindex $idL $i] 2]"
                                }
                                set id_seq ""
                                set primer_pair_penalty ""
                                set primer_forward_penalty ""
                                set primer_reverse_penalty ""
                                set primer_forward_sequence ""
                                set primer_reverse_sequence ""
                                set primer_forward_pos ""
                                set primer_reverse_pos ""
                                set primer_forward_len ""
                                set primer_reverse_len ""
                                set primer_forward_tm ""
                                set primer_reverse_tm ""
                                set primer_forward_gc ""
                                set primer_reverse_gc ""
                                set primer_forward_self_any ""
                                set primer_reverse_self_any ""
                                set primer_forward_self_end ""
                                set primer_reverse_self_end ""
                                set primer_forward_end_stability ""
                                set primer_reverse_end_stability ""
                                set primer_pair_compl_any ""
                                set primer_pair_compl_end ""
                                set primer_product_size ""
                                set primer_product_tm ""
                                set primer_product_tm_oligo_tm_diff ""
                                set primer_pair_t_opt_a ""
                                set id_seq [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_PAIR_PENALTY_*[0-9]*)} [lindex $line 0]]} {
                                if {$primer_pair_penalty ne ""} {
                                    set i [lsearch -index 0 $idL $id_seq]
                                    lappend primL "$id_seq $primer_forward_sequence $primer_reverse_sequence \
                                            $primer_pair_penalty $primer_forward_penalty $primer_reverse_penalty \
                                            $primer_forward_pos $primer_reverse_pos $primer_forward_len \
                                            $primer_reverse_len $primer_forward_tm $primer_reverse_tm \
                                            $primer_forward_gc $primer_reverse_gc $primer_forward_self_any \
                                            $primer_reverse_self_any $primer_forward_self_end $primer_reverse_self_end \
                                            $primer_forward_end_stability $primer_reverse_end_stability \
                                            $primer_pair_compl_any $primer_pair_compl_end $primer_product_size \
                                            $primer_product_tm $primer_product_tm_oligo_tm_diff $primer_pair_t_opt_a \
                                            $salt_con $dna_con [lindex [lindex $idL $i] 1] [lindex [lindex $idL $i] 2]"
                                }
                                set primer_pair_penalty [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_LEFT_*[0-9]*_PENALTY)} [lindex $line 0]]} {
                                set primer_forward_penalty [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_RIGHT_*[0-9]*_PENALTY)} [lindex $line 0]]} {
                                set primer_reverse_penalty [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_LEFT_*[0-9]*_SEQUENCE)} [lindex $line 0]]} {
                                set primer_forward_sequence [lindex $line 1]
                                set primer_forward_len [string length $primer_forward_sequence]
                            } elseif {[regexp -- {(PRIMER_RIGHT_*[0-9]*_SEQUENCE)} [lindex $line 0]]} {
                                set primer_reverse_sequence [lindex $line 1]
                                set primer_reverse_len [string length $primer_reverse_sequence]
                            } elseif {[regexp -- {(PRIMER_LEFT_*[0-9]*_TM)} [lindex $line 0]]} {
                                set primer_forward_tm [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_RIGHT_*[0-9]*_TM)} [lindex $line 0]]} {
                                set primer_reverse_tm [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_LEFT_*[0-9]*_GC_PERCENT)} [lindex $line 0]]} {
                                set primer_forward_gc [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_RIGHT_*[0-9]*_GC_PERCENT)} [lindex $line 0]]} {
                                set primer_reverse_gc [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_LEFT_*[0-9]*_SELF_ANY)} [lindex $line 0]]} {
                                set primer_forward_self_any [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_RIGHT_*[0-9]*_SELF_ANY)} [lindex $line 0]]} {
                                set primer_reverse_self_any [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_LEFT_*[0-9]*_SELF_END)} [lindex $line 0]]} {
                                set primer_forward_self_end [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_RIGHT_*[0-9]*_SELF_END)} [lindex $line 0]]} {
                                set primer_reverse_self_end [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_LEFT_*[0-9]*_END_STABILITY)} [lindex $line 0]]} {
                                set primer_forward_end_stability [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_RIGHT_*[0-9]*_END_STABILITY)} [lindex $line 0]]} {
                                set primer_reverse_end_stability [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_PAIR_*[0-9]*_COMPL_ANY)} [lindex $line 0]]} {
                                set primer_pair_compl_any [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_PAIR_*[0-9]*_COMPL_END)} [lindex $line 0]]} {
                                set primer_pair_compl_end [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_PRODUCT_SIZE_*[0-9]*)} [lindex $line 0]]} {
                                set primer_product_size [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_PRODUCT_TM_OLIGO_TM_DIFF*[0-9]*)} [lindex $line 0]]} {
                                set primer_product_tm_oligo_tm_diff [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_PRODUCT_TM_*[0-9]*)} [lindex $line 0]]} {
                                set primer_product_tm [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_PAIR_*[0-9]*_T_OPT_A)} [lindex $line 0]]} {
                                set primer_pair_t_opt_a [lindex $line 1]
                            } elseif {[regexp -- {(PRIMER_LEFT_*[0-9]*)} [lindex $line 0]]} {
                                set primer_forward_pos [lindex [split [lindex $line 1] ,] 0]
                            } elseif {[regexp -- {(PRIMER_RIGHT_*[0-9]*)} [lindex $line 0]]} {
                                set primer_reverse_pos [lindex [split [lindex $line 1] ,] 0]
                            } elseif {[lindex $line 0] eq "PRIMER_SALT_CONC"} {
                                set salt_con [lindex $line 1]
                            } elseif {[lindex $line 0] eq "PRIMER_DNA_CONC"} {
                                set dna_con [lindex $line 1]
                            }
                        }
                        if {$primer_pair_penalty ne ""} {
                            set i [lsearch -index 0 $idL $id_seq]
                            lappend primL "$id_seq $primer_forward_sequence $primer_reverse_sequence \
                                    $primer_pair_penalty $primer_forward_penalty $primer_reverse_penalty \
                                    $primer_forward_pos $primer_reverse_pos $primer_forward_len \
                                    $primer_reverse_len $primer_forward_tm $primer_reverse_tm \
                                    $primer_forward_gc $primer_reverse_gc $primer_forward_self_any \
                                    $primer_reverse_self_any $primer_forward_self_end $primer_reverse_self_end \
                                    $primer_forward_end_stability $primer_reverse_end_stability \
                                    $primer_pair_compl_any $primer_pair_compl_end $primer_product_size \
                                    $primer_product_tm $primer_product_tm_oligo_tm_diff $primer_pair_t_opt_a \
                                    $salt_con $dna_con [lindex [lindex $idL $i] 1] [lindex [lindex $idL $i] 2]"
                        }
                        if {$primL ne ""} {
                            if {$primer3_writeDB} {
                                primer3_writeDB "$primL" $phpThreadID $mainThreadID
                            } else {
                                primer3_showResults "$primL" $mainThreadID
                            }
                        } else {
                            eval [subst {thread::send -async $mainThreadID {errorPopUp "Primer3" "No primer pairs found."}}]
                        }
                    }
                }
                
                proc primer3_showResults {primL mainThreadID} {
                    foreach prim $primL {
                        lappend primL2 "{} [lindex $prim 29] [lindex $prim 3] [lindex $prim 4] [lindex $prim 5] \
                                [lindex $prim 1] [lindex $prim 2] \
                                [lindex $prim 22] [lindex $prim 8] [lindex $prim 9] \
                                [lindex $prim 6] [lindex $prim 7] [lindex $prim 25] \
                                [lindex $prim 23] [lindex $prim 24] [lindex $prim 10] \
                                [lindex $prim 11] [lindex $prim 12] [lindex $prim 13] \
                                [lindex $prim 20] [lindex $prim 21] \
                                [lindex $prim 14] [lindex $prim 15] [lindex $prim 16] \
                                [lindex $prim 17] [lindex $prim 18] [lindex $prim 19] \
                                [lindex $prim 26] [lindex $prim 27] [lindex $prim 0] [lindex $prim 28]"
                    }
                    puts [lindex $primL 0]
                    puts [lindex $primL2 0]
                    set columns "{} Name Penalty {F penalty} {R penalty} {Forward Primer} {Reverse Primer} {Prod. size} {F Len} {R Len} {F Pos} {R Pos} {Opt. Ta} {Prod. Tm} {Tm diff. (prod. vs. oligo)} {F Tm} {R Tm} {F GC} {R GC} {Pair compl.} {Pair compl. end} {F self align} {R self align} {F self align end} {R self align end} {F end stability} {R end stability} {Salt conc. (mM)} {Oligo conc. (nM)} id_seq db"
                    set binding "set y \[.primer3_showResults nearest \[expr {%y + \[winfo y %W\]}\]\]; set row \[lrange \[.primer3_showResults get \$y\] 1 end\]; update_info_primer_table \$row"
                    eval [subst {thread::send -async $mainThreadID {fillTable_custom .primer3_showResults "Primer3 results" "$columns" update_info_primer_showResults 0 {28 29} "$primL2"}}]
                }
                
                proc primer3_writeDB {primL phpThreadID mainThreadID} {
                    #Writing Results to Database
                    catch {
                        eval [subst {thread::send $phpThreadID {::php_getSQLresults "\
                                        CREATE TABLE $env(dbName).sequences_nucleotide_primer (id_seq integer NOT NULL, primer_forward_sequence text, primer_reverse_sequence text,\
                                        primer_pair_penalty text, primer_forward_penalty text, primer_reverse_penalty text,\
                                        primer_forward_pos integer, primer_reverse_pos integer,\
                                        primer_forward_len integer, primer_reverse_len integer, primer_forward_tm text,\
                                        primer_reverse_tm text, primer_forward_gc text, primer_reverse_gc text,\
                                        primer_forward_self_any text, primer_reverse_self_any text, primer_forward_self_end text,\
                                        primer_reverse_self_end text, primer_forward_end_stability text,\
                                        primer_reverse_end_stability text, primer_pair_compl_any text, primer_pair_compl_end text,\
                                        primer_product_size integer, primer_product_tm text, primer_product_tm_oligo_tm_diff text,\
                                        primer_pair_t_opt_a text, primer_salt_con text, primer_dna_con text,\
                                        CONSTRAINT sequences_nucleotide_primer_pkey PRIMARY KEY (id_seq, primer_forward_sequence, primer_reverse_sequence, primer_salt_con, primer_dna_con)\
                                        );"}}]
                    }
                    foreach prim $primL {
                        set db [lindex $prim 28]
                        set prim "'[lindex $prim 0]', '[lindex $prim 1]', '[lindex $prim 2]', \
                                '[lindex $prim 3]', '[lindex $prim 4]', '[lindex $prim 5]', \
                                '[lindex $prim 6]', '[lindex $prim 7]', '[lindex $prim 8]', \
                                '[lindex $prim 9]', '[lindex $prim 10]', '[lindex $prim 11]', \
                                '[lindex $prim 12]', '[lindex $prim 13]', '[lindex $prim 14]', \
                                '[lindex $prim 15]', '[lindex $prim 16]', '[lindex $prim 17]', \
                                '[lindex $prim 18]', '[lindex $prim 19]', \
                                '[lindex $prim 20]', '[lindex $prim 21]', '[lindex $prim 22]', \
                                '[lindex $prim 23]', '[lindex $prim 24]', '[lindex $prim 25]', \
                                '[lindex $prim 26]', '[lindex $prim 27]'"
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "INSERT INTO $db.sequences_nucleotide_primer VALUES ($prim);"}}]]
                        #puts $sql_res
                    }
                    unset primL; unset prim; unset db
                    eval [subst {thread::send -async $mainThreadID {update_info_primer}}]
                }
                thread::wait
            }]
            eval [subst {thread::send -async $::threadPrimer3 {primer3 \"$idL\" \"$primer3_input\" $primer3_writeDB $env(mainThreadID) $env(phpThreadID)}}]
            catch {::create_tab primer}
        }
    }
}

proc primer_list {} {
    global primer_listCheck
    
    set t .primer_list
    toplevel $t
    wm title $t "Primer list"
    wm attributes $t -topmost 1
    
    text $t.panel -background white -yscrollcommand "$t.y set"
    scrollbar $t.y -orient vertical -command "$t.panel yview"
    
    pack $t.panel -side left -fill both -expand true; pack $t.y -side left -fill both
}

proc update_info_primer {} {
    global env
    
    set primL ""
    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq, primer_pair_penalty, primer_forward_penalty, primer_reverse_penalty, primer_forward_sequence, primer_reverse_sequence, primer_product_size, primer_forward_len, primer_reverse_len, primer_forward_pos, primer_reverse_pos, primer_pair_t_opt_a, primer_product_tm, primer_product_tm_oligo_tm_diff, primer_forward_tm, primer_reverse_tm, primer_forward_gc, primer_reverse_gc, primer_pair_compl_any, primer_pair_compl_end, primer_forward_self_any, primer_reverse_self_any, primer_forward_self_end, primer_reverse_self_end, primer_forward_end_stability, primer_reverse_end_stability, primer_salt_con, primer_dna_con FROM $env(contig.dbName).sequences_nucleotide_primer WHERE id_seq = '$env(contig.id_seq)' ORDER BY primer_pair_penalty"}}]]
    foreach sRes $sql_res {
        lappend primL "{[lindex $sRes 1]} {[lindex $sRes 2]} {[lindex $sRes 3]} {[lindex $sRes 4]} {[lindex $sRes 5]} {[lindex $sRes 6]} {[lindex $sRes 7]} {[lindex $sRes 8]} {[lindex $sRes 9]} {[lindex $sRes 10]} {[lindex $sRes 11]} {[lindex $sRes 12]} {[lindex $sRes 13]} {[lindex $sRes 14]} {[lindex $sRes 15]} {[lindex $sRes 16]} {[lindex $sRes 17]} {[lindex $sRes 18]} {[lindex $sRes 19]} {[lindex $sRes 20]} {[lindex $sRes 21]} {[lindex $sRes 22]} {[lindex $sRes 23]} {[lindex $sRes 24]} {[lindex $sRes 25]} {[lindex $sRes 26]} {[lindex $sRes 27]} [lindex $sRes 0]"
    }
    unset sql_res
    .result.notebook2.nb.fprimer.0.label1 configure -text $env(contig.name)
    fillTable_primer "$primL"
}

proc fillTable_primer {primerL} {
    global checkedImg
    global uncheckedImg
    
    set tl .result.notebook2.nb.fprimer.1.table.l
    $tl finishediting
    if {[$tl columncget 0 -labelimage] eq "image1"} {
        set use 1
    } else {
        set use 0
    }
    
    $tl delete 0 end
    foreach ent $primerL {
        $tl insert end "1 $ent"
        $tl cellconfigure end,0 -image [expr {1 ? $checkedImg : $uncheckedImg}]
    }
    
    # Bindings.
    bind [$tl bodypath] <Button-1> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    set row \[lrange \[$tl get \$y\] 1 end\]
    update_info_primer_table \$row
    "
}

proc update_info_primer_table {row} {
    global tabArr
    global primer_listCheck
    
    set contig [.result.notebook2.nb.fprimer.0.label1 cget -text]
    set penalty [lindex $row 0]
    set fpen [lindex $row 1]
    set rpen [lindex $row 2]
    set fseq [lindex $row 3]
    set rseq [lindex $row 4]
    set plen [lindex $row 5]
    set flen [lindex $row 6]
    set rlen [lindex $row 7]
    set fpos [lindex $row 8]
    set rpos [lindex $row 9]
    set ta [lindex $row 10]
    set ptm [lindex $row 11]
    set difftm [lindex $row 12]
    set ftm [lindex $row 13]
    set rtm [lindex $row 14]
    set fgc [lindex $row 15]
    set rgc [lindex $row 16]
    set pa [lindex $row 17]
    set pae [lindex $row 18]
    set fsa [lindex $row 19]
    set rsa [lindex $row 20]
    set fsae [lindex $row 21]
    set rsae [lindex $row 22]
    set fes [lindex $row 23]
    set res [lindex $row 24]
    set salt [lindex $row 25]
    set oligo [lindex $row 26]
    
    if {$tabArr(sb.exist) && $row ne ""} {
        set nucSeq [.result.notebook1.nb.fsb.1.panel get -displaychars 2.0 2.end]
        catch {.result.notebook1.nb.fsb.1.panel tag remove markedRed 1.0 1000.end}
        catch {.result.notebook1.nb.fsb.1.panel tag remove markedYellow 1.0 1000.end}
        .result.notebook1.nb.fsb.1.panel tag add markedRed 2.[expr int($fpos)] 2.[expr int($fpos + $flen)]
        .result.notebook1.nb.fsb.1.panel tag add markedRed 2.[expr int($rpos - $rlen) + 1] 2.[expr int($rpos) + 1]
        .result.notebook1.nb.fsb.1.panel tag add markedYellow 2.[expr int($fpos + $flen)] 2.[expr int($rpos - $rlen) + 1]
    }
    if {$primer_listCheck} {
        if {[
            catch {
                .primer_list.panel delete 1.0 end
                .primer_list.panel insert end "Contig:\t$contig\n\
                        Product Tm:\t$ptm\n\
                        Product Length:\t$plen\n\
                        Tm diff. (oligo vs. product):\t$difftm\n\
                        Opt. Ta:\t$ta\n\n\
                        Forward Primer\n\
                        Penalty:\t$fpen\n\
                        Sequence:\t$fseq\n\
                        Length:\t$flen\n\
                        Position:\t$fpos\n\
                        Tm:\t$ftm\n\
                        GC content:\t$fgc\n\
                        Self align:\t$fsa\n\
                        Self align end:\t$fsae\n\
                        End stability:\t$fes\n\n\
                        Reverse Primer\n\
                        Penalty:\t$rpen\n\
                        Sequence:\t$rseq\n\
                        Length:\t$rlen\n\
                        Position:\t$rpos\n\
                        Tm:\t$rtm\n\
                        GC content:\t$rgc\n\
                        Self align:\t$rsa\n\
                        Self align end:\t$rsae\n\
                        End stability:\t$res\n\n\
                        Pair Penalty:\t$penalty\n\
                        Pair align:\t$pa\n\
                        Pair align end:\t$pae\n\
                        Salt conc. (mM):\t$salt\n\
                        Oligo conc. (nM):\t$oligo"
            }
            ]} {
            set primer_listCheck 0
        }
    }
}

proc update_info_primer_showResults {row} {
    global env
    if {[.result.notebook1.nb raise] eq "sb"} {
        if {[catch {
                if {$env(contig.id_seq) ne "[lindex $row 28]"} {
                    update_info_get_name [lindex $row 28] id
                }
        }]} {
            update_info_get_name [lindex $row 28] id
        }
        update_info_primer_table "[lindex $row 0] [lrange $row 2 end]"
    }  
}

proc primer3_config {} {
    global env
    
    set t .primer_config
    toplevel $t
    wm title $t "Primer Configuration"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    frame $t.show
    
    frame $t.showColumn -bd 2 -relief groove
    label $t.showColumn.label -text "Columns displayed: "
    checkbutton $t.showColumn.sequence -text "primer sequences" -variable env(primer.sequence) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.pair_penalty -text "pair penalty" -variable env(primer.pair_penalty) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.penalty -text "primer penalty" -variable env(primer.penalty) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.pos -text "primer positions" -variable env(primer.pos) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.len -text "primer length" -variable env(primer.len) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.tm -text "melting temperature" -variable env(primer.tm) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.gc -text "gc content" -variable env(primer.gc) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.self_any -text "self alignment" -variable env(primer.self_any) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.self_end -text "self alignment (end)" -variable env(primer.self_end) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.end_stability -text "end stability" -variable env(primer.end_stability) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.pair_compl_any -text "complementation" -variable env(primer.pair_compl_any) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.pair_compl_end -text "complementation (end)" -variable env(primer.pair_compl_end) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.product_size -text "product size" -variable env(primer.product_size) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.product_tm -text "melting temperature (product)" -variable env(primer.product_tm) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.tm_oligo_tm_diff -text "Tm diff. (prod. vs. oligo)" -variable env(primer.product_tm_oligo_tm_diff) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.pair_t_opt_a -text "opt. annealing temp." -variable env(primer.pair_t_opt_a) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.salt_con -text "salt concentration" -variable env(primer.salt_con) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.dna_con -text "oligo concentration" -variable env(primer.dna_con) -offvalue "-" -onvalue "+"
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "Set" -command "primer3_changeConfig primer; destroy $t"
    button $t.buts.cancel -text "Cancel" -command "destroy $t"
    
    pack $t.showColumn.sequence $t.showColumn.pair_penalty $t.showColumn.penalty $t.showColumn.pos \
            $t.showColumn.len $t.showColumn.tm $t.showColumn.gc  $t.showColumn.self_any \
            $t.showColumn.self_end $t.showColumn.end_stability $t.showColumn.pair_compl_any \
            $t.showColumn.pair_compl_end $t.showColumn.product_size $t.showColumn.product_tm \
            $t.showColumn.tm_oligo_tm_diff $t.showColumn.pair_t_opt_a \
            $t.showColumn.salt_con $t.showColumn.dna_con -side top -anchor w
    pack $t.buts.ok $t.buts.cancel -side left -fill both
    pack $t.showColumn $t.buts -side top -fill both
}

proc primer3_changeConfig {mode} {
    global env
    global primer3_minTm
    global primer3_optTm
    global primer3_maxTm
    global primer3_minLen
    global primer3_optLen
    global primer3_maxLen
    global primer3_minGC
    global primer3_optGC
    global primer3_maxGC
    global primer3_minPTm
    global primer3_optPTm
    global primer3_maxPTm
    global primer3_polyx
    global primer3_productSize
    global primer3_optionsCheck
    global primer3_primNum
    global primer3_maxTmDiff
    global primer3_saltCon
    global primer3_primCon
    global primer3_maxSelf
    global primer3_maxEnd
    global primer3_numNs
    
    if {$mode eq "primer"} {
        if {$env(primer.sequence) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 4 -hide no
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 5 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 4 -hide yes
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 5 -hide yes
        }
        if {$env(primer.pair_penalty) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 1 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 1 -hide yes
        }
        if {$env(primer.penalty) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 2 -hide no
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 3 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 2 -hide yes
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 3 -hide yes
        }
        if {$env(primer.pos) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 9 -hide no
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 10 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 9 -hide yes
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 10 -hide yes
        }
        if {$env(primer.len) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 7 -hide no
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 8 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 7 -hide yes
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 8 -hide yes
        }
        if {$env(primer.tm) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 14 -hide no
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 15 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 14 -hide yes
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 15 -hide yes
        }
        if {$env(primer.gc) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 16 -hide no
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 17 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 16 -hide yes
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 17 -hide yes
        }
        if {$env(primer.self_any) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 20 -hide no
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 21 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 20 -hide yes
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 21 -hide yes
        }
        if {$env(primer.self_end) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 22 -hide no
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 23 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 22 -hide yes
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 23 -hide yes
        }
        if {$env(primer.end_stability) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 24 -hide no
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 25 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 24 -hide yes
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 25 -hide yes
        }
        if {$env(primer.pair_compl_any) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 18 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 18 -hide yes
        }
        if {$env(primer.pair_compl_end) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 19 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 19 -hide yes
        }
        if {$env(primer.product_size) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 6 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 6 -hide yes
        }
        if {$env(primer.product_tm) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 12 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 12 -hide yes
        }
        if {$env(primer.product_tm_oligo_tm_diff) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 13 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 13 -hide yes
        }
        if {$env(primer.pair_t_opt_a) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 11 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 11 -hide yes
        }
        if {$env(primer.salt_con) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 26 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 26 -hide yes
        }
        if {$env(primer.dna_con) eq "+"} {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 27 -hide no
        } else {
            .result.notebook2.nb.fprimer.1.table.l columnconfigure 27 -hide yes
        }
    } elseif {$mode eq "p3params"} {
        set primer3_minTm [.primer3.params.top.tm.min.ent get]
        set primer3_optTm [.primer3.params.top.tm.opt.ent get]
        set primer3_maxTm [.primer3.params.top.tm.max.ent get]
        set primer3_minLen [.primer3.params.top.len.min.ent get]
        set primer3_optLen [.primer3.params.top.len.opt.ent get]
        set primer3_maxLen [.primer3.params.top.len.max.ent get]
        set primer3_minGC [.primer3.params.top.gc.min.ent get]
        set primer3_optGC [.primer3.params.top.gc.opt.ent get]
        set primer3_maxGC [.primer3.params.top.gc.max.ent get]
        set primer3_minPTm [.primer3.params.top.ptm.min.ent get]
        set primer3_optPTm [.primer3.params.top.ptm.opt.ent get]
        set primer3_maxPTm [.primer3.params.top.ptm.max.ent get]
        set primer3_polyx [.primer3.params.top.polx.ent get]
        set primer3_productSize [.primer3.params.top.psize.ent get]
        set primer3_primNum [.primer3.params.bottom.primNum.ent get]
        set primer3_maxTmDiff [.primer3.params.bottom.maxTmDiff.ent get]
        set primer3_saltCon [.primer3.params.bottom.saltCon.ent get]
        set primer3_primCon [.primer3.params.bottom.primCon.ent get]
        set primer3_maxSelf [.primer3.params.bottom.maxSelf.ent get]
        set primer3_maxEnd [.primer3.params.bottom.maxEnd.ent get]
        set primer3_numNs [.primer3.params.bottom.numNs.ent get]
    }
    if {[catch {set ft [open [pwd]/conf/primer3_tace.conf w]} ]} {
        ::errorPopUp "Error" "Could not write file:\n[pwd]/conf/primer3_tace.conf"
    } else {
        puts $ft "Primer"
        puts $ft "$env(primer.sequence) \
                $env(primer.pair_penalty) \
                $env(primer.penalty) \
                $env(primer.pos) \
                $env(primer.len) \
                $env(primer.tm) \
                $env(primer.gc) \
                $env(primer.self_any) \
                $env(primer.self_end) \
                $env(primer.end_stability) \
                $env(primer.pair_compl_any) \
                $env(primer.pair_compl_end) \
                $env(primer.product_size) \
                $env(primer.product_tm) \
                $env(primer.product_tm_oligo_tm_diff) \
                $env(primer.pair_t_opt_a) \
                $env(primer.salt_con) \
                $env(primer.dna_con)"
        puts $ft "Primer Parameters"
        puts $ft "{$primer3_minTm} \
                {$primer3_optTm} \
                {$primer3_maxTm} \
                {$primer3_minLen} \
                {$primer3_optLen} \
                {$primer3_maxLen} \
                {$primer3_minGC} \
                {$primer3_optGC} \
                {$primer3_maxGC} \
                {$primer3_minPTm} \
                {$primer3_optPTm} \
                {$primer3_maxPTm} \
                {$primer3_polyx} \
                {$primer3_productSize} \
                {$primer3_primNum} \
                {$primer3_maxTmDiff} \
                {$primer3_saltCon} \
                {$primer3_primCon} \
                {$primer3_maxSelf} \
                {$primer3_maxEnd} \
                {$primer3_numNs} \
                $primer3_optionsCheck"
        close $ft
    }
}

proc rightmenu_primer3 {mode feat id coord} {
    global env
    
    .rightmenu delete 0 end
    .rightmenu.hidemenuColumn delete 0 end
    .rightmenu.copymenu delete 0 end
    
    .rightmenu add cascade -label "Hide column..." -menu .rightmenu.hidemenuColumn
    .rightmenu.hidemenuColumn add command -label "$env(primer.pair_compl_any) complementation" -command "table_col_sh .result.notebook2.nb.fprimer.1.table.l primer.pair_compl_any 18"
    .rightmenu.hidemenuColumn add command -label "$env(primer.pair_compl_end) complementation (end)" -command "table_col_sh .result.notebook2.nb.fprimer.1.table.l primer.pair_compl_end 19"
    .rightmenu.hidemenuColumn add command -label "$env(primer.end_stability) end stability" -command "table_col_sh .result.notebook2.nb.fprimer.1.table.l primer.end_stability \"24 25\""
    .rightmenu.hidemenuColumn add command -label "$env(primer.gc) GC content" -command "table_col_sh .result.notebook2.nb.fprimer.1.table.l primer.gc \"16 17\""
    .rightmenu.hidemenuColumn add command -label "$env(primer.tm) melting temperature" -command "table_col_sh .result.notebook2.nb.fprimer.1.table.l primer.tm \"14 15\""
    .rightmenu.hidemenuColumn add command -label "$env(primer.product_tm) melting temperature (product)" -command "table_col_sh .result.notebook2.nb.fprimer.1.table.l primer.product_tm 12"
    .rightmenu.hidemenuColumn add command -label "$env(primer.dna_con) oligo concentration" -command "table_col_sh .result.notebook2.nb.fprimer.1.table.l primer.dna_con 27"
    .rightmenu.hidemenuColumn add command -label "$env(primer.pair_t_opt_a) opt. annealing temperature" -command "table_col_sh .result.notebook2.nb.fprimer.1.table.l primer.pair_t_opt_a 11"
    .rightmenu.hidemenuColumn add command -label "$env(primer.pair_penalty) pair penalty" -command "table_col_sh .result.notebook2.nb.fprimer.1.table.l primer.pair_penalty 1"
    .rightmenu.hidemenuColumn add command -label "$env(primer.len) primer length" -command "table_col_sh .result.notebook2.nb.fprimer.1.table.l primer.len \"7 8\""
    .rightmenu.hidemenuColumn add command -label "$env(primer.penalty) primer penalty" -command "table_col_sh .result.notebook2.nb.fprimer.1.table.l primer.penalty \"2 3\""
    .rightmenu.hidemenuColumn add command -label "$env(primer.pos) primer positions" -command "table_col_sh .result.notebook2.nb.fprimer.1.table.l primer.pos \"9 10\""
    .rightmenu.hidemenuColumn add command -label "$env(primer.sequence) primer sequences" -command "table_col_sh .result.notebook2.nb.fprimer.1.table.l primer.sequence \"4 5\""
    .rightmenu.hidemenuColumn add command -label "$env(primer.product_size) product size" -command "table_col_sh .result.notebook2.nb.fprimer.1.table.l primer.product_size 6"
    .rightmenu.hidemenuColumn add command -label "$env(primer.salt_con) salt concentration" -command "table_col_sh .result.notebook2.nb.fprimer.1.table.l primer.salt_con 26"
    .rightmenu.hidemenuColumn add command -label "$env(primer.self_any) self alignment" -command "table_col_sh .result.notebook2.nb.fprimer.1.table.l primer.self_any \"20 21\""
    .rightmenu.hidemenuColumn add command -label "$env(primer.self_end) self alignment (end)" -command "table_col_sh .result.notebook2.nb.fprimer.1.table.l primer.self_end \"22 23\""
    .rightmenu add command -label "Save config" -command "catch {primer3_changeConfig primer}"
    .rightmenu add separator
    .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
    .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook2.nb.fprimer.1.table.l}"
    .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook2.nb.fprimer.1.table.l}"
    .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook2.nb.fprimer.1.table.l}"
    .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook2.nb.fprimer.1.table.l}"
    
    tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
}