proc rightmenu {mode feat id coord} {
    global env
    
    .rightmenu delete 0 end
    .rightmenu.hidemenuColumn delete 0 end
    .rightmenu.copymenu delete 0 end
    
    if {$mode eq "db_info"} {
        #Database_info
        .rightmenu add command -label "All to A" -command "db_info_change_ab A"
        .rightmenu add command -label "All to B" -command "db_info_change_ab B"
        .rightmenu add separator
        .rightmenu add cascade -label "Hide/Show column..." -menu .rightmenu.hidemenuColumn
        .rightmenu.hidemenuColumn add command -label "$env(db_info.assembled) assembled" -command "table_col_sh .result.notebook1.nb.fdb_info.1.table.l db_info.assembled 7"
        .rightmenu.hidemenuColumn add command -label "$env(db_info.comment) comment" -command "table_col_sh .result.notebook1.nb.fdb_info.1.table.l db_info.comment 15"
        .rightmenu.hidemenuColumn add command -label "$env(db_info.data) data" -command "table_col_sh .result.notebook1.nb.fdb_info.1.table.l db_info.data 14"
        .rightmenu.hidemenuColumn add command -label "$env(db_info.dateIn) date in" -command "table_col_sh .result.notebook1.nb.fdb_info.1.table.l db_info.dateIn 12"
        .rightmenu.hidemenuColumn add command -label "$env(db_info.dateOut) date out" -command "table_col_sh .result.notebook1.nb.fdb_info.1.table.l db_info.dateOut 13"
        .rightmenu.hidemenuColumn add command -label "$env(db_info.description) description" -command "table_col_sh .result.notebook1.nb.fdb_info.1.table.l db_info.description 4"
        .rightmenu.hidemenuColumn add command -label "$env(db_info.id_run) run id" -command "table_col_sh .result.notebook1.nb.fdb_info.1.table.l db_info.id_run 3"
        .rightmenu.hidemenuColumn add command -label "$env(db_info.runs) runs" -command "table_col_sh .result.notebook1.nb.fdb_info.1.table.l db_info.runs 11"
        .rightmenu.hidemenuColumn add command -label "$env(db_info.sequencer) sequencer" -command "table_col_sh .result.notebook1.nb.fdb_info.1.table.l db_info.sequencer 9"
        .rightmenu.hidemenuColumn add command -label "$env(db_info.sequences) sequences" -command "table_col_sh .result.notebook1.nb.fdb_info.1.table.l db_info.sequences 6"
        .rightmenu.hidemenuColumn add command -label "$env(db_info.singletons) singletons" -command "table_col_sh .result.notebook1.nb.fdb_info.1.table.l db_info.singletons 8"
        .rightmenu.hidemenuColumn add command -label "$env(db_info.treatment) treatment" -command "table_col_sh .result.notebook1.nb.fdb_info.1.table.l db_info.treatment 5"
        .rightmenu.hidemenuColumn add command -label "$env(db_info.type) type" -command "table_col_sh .result.notebook1.nb.fdb_info.1.table.l db_info.type 10"
        .rightmenu add separator
        .rightmenu add command -label "Export read distribution" -command "db_info_export_readDistribution 0"
        .rightmenu add separator
        .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
        .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook1.nb.fdb_info.1.table.l}"
        .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook1.nb.fdb_info.1.table.l}"
        .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook1.nb.fdb_info.1.table.l}"
        .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook1.nb.fdb_info.1.table.l}"
    } elseif {$mode eq "dbb"} {
        #Database_browser    
        .rightmenu add command -label "Add to blast" -command "catch {blast_add_seq $feat $id}"
        .rightmenu add command -label "Coverage" -command "catch {sequence_edit_coverage_show $feat $id}"
        if {[lsearch $env(loaded_modules) "primer3_tace"] ne -1} {
            .rightmenu add command -label "Create primer" -command "catch {primer3_window $feat $id}"
        }
        if {[lsearch $env(loaded_modules) "sequence_edit_tace"] ne -1} {
            .rightmenu add command -label "Edit sequence" -command "catch {sequence_edit_window $feat $id}"
        }
        .rightmenu add command -label "New sequence" -command "catch {database_nucleotide_new_window $feat $id}"
        if {[lsearch $env(loaded_modules) "phobos_tace"] ne -1} {
            .rightmenu add command -label "Search repeats" -command "catch {phobos_window $feat $id}"
        }
        .rightmenu add separator
        .rightmenu add cascade -label "Hide/Show column..." -menu .rightmenu.hidemenuColumn
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.coverage) coverage" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.coverage 22"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.description) description" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.description 5"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.length) length" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.length 3"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.nr) nr" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.nr 1"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.numreads) reads" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.numreads 4"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.proteins) proteins" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.proteins 6"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.blast) blast" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.blast 7"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.blastprodom) blastprodom" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.blastprodom 8"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.coil) coil" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.coil 9"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.gene3d) gene3d" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.gene3d 10"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.go) go" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.go 11"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.interpro) interpro" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.interpro 12"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.kegg) kegg" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.kegg 13"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.panther) panther" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.panther 14"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.patternscan) patternscan" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.patternscan 15"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.pfam) pfam" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.pfam 16"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.pir) pir" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.pir 17"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.profilescan) profilescan" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.profilescan 18"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.smart) smart" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.smart 19"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.superfamily) superfamily" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.superfamily 20"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.tigr) tigr" -command "table_col_sh .result.notebook1.nb.fdbb.1.table.l database_browser.tigr 21"
        .rightmenu add separator
        .rightmenu add command -label "Export reads" -command "readMapping_export_reads $feat $id 0"
        .rightmenu add command -label "Save table" -command "catch {table_save}"
        .rightmenu add separator
        .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
        .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook1.nb.fdbb.1.table.l}"
        .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook1.nb.fdbb.1.table.l}"
        .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook1.nb.fdbb.1.table.l}"
        .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook1.nb.fdbb.1.table.l}"
        .rightmenu.copymenu add separator
        .rightmenu.copymenu add command -label "Sequence" -command "catch {table_copy \"sequence $id $feat\" .result.notebook1.nb.fdbb.1.table.l}"
    } else {
        #project_tab
        .rightmenu add command -label "Add to blast" -command "catch {blast_add_seq $feat $id}"
        .rightmenu add command -label "Coverage" -command "catch {sequence_edit_coverage_show $feat $id}"
        if {[lsearch $env(loaded_modules) "primer3_tace"] ne -1} {
            .rightmenu add command -label "Create primer" -command "catch {primer3_window $feat $id}"
        }
        if {[lsearch $env(loaded_modules) "sequence_edit_tace"] ne -1} {
            .rightmenu add command -label "Edit sequence" -command "catch {sequence_edit_window $feat $id}"
        }
        .rightmenu add command -label "New sequence" -command "catch {database_nucleotide_new_window $feat $id}"
        if {[lsearch $env(loaded_modules) "phobos_tace"] ne -1} {
            .rightmenu add command -label "Search repeats" -command "catch {phobos_window $feat $id}"
        }
        .rightmenu add separator
        .rightmenu add command -label "Insert contig list" -command "project_insert_contig_list_window $mode"
        .rightmenu add separator
        .rightmenu add cascade -label "Hide/Show column..." -menu .rightmenu.hidemenuColumn
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.coverage) coverage" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.coverage 22"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.description) description" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.description 5"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.length) length" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.length 3"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.nr) nr" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.nr 1"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.numreads) reads" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.numreads 4"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.proteins) proteins" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.proteins 6"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.blast) blast" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.blast 7"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.blastprodom) blastprodom" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.blastprodom 8"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.coil) coil" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.coil 9"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.gene3d) gene3d" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.gene3d 10"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.go) go" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.go 11"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.interpro) interpro" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.interpro 12"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.kegg) kegg" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.kegg 13"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.panther) panther" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.panther 14"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.patternscan) patternscan" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.patternscan 15"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.pfam) pfam" -command "stable_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.pfam 16"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.pir) pir" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.pir 17"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.profilescan) profilescan" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.profilescan 18"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.smart) smart" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.smart 19"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.superfamily) superfamily" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.superfamily 20"
        .rightmenu.hidemenuColumn add command -label "$env(database_browser.tigr) tigr" -command "table_col_sh .result.notebook1.nb.f$mode.1.table.l database_browser.tigr 21"
        .rightmenu add separator
        .rightmenu add command -label "Export reads" -command "readMapping_export_reads $feat $id 0"
        .rightmenu add command -label "Export read distribution" -command "db_info_export_readDistribution $mode"
        .rightmenu add command -label "Save table" -command "catch {table_save}"
        .rightmenu add separator
        .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
        .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook1.nb.f$mode.1.table.l}"
        .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook1.nb.f$mode.1.table.l}"
        .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook1.nb.f$mode.1.table.l}"
        .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook1.nb.f$mode.1.table.l}"
        .rightmenu.copymenu add separator
        .rightmenu.copymenu add command -label "Sequence" -command "catch {table_copy \"sequence $id $feat\" .result.notebook1.nb.f$mode.1.table.l}"
    }
    
    tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
}

proc rightmenu_bind {} {
        # Popup-Menu
        menu .rightmenu -tearoff false
        menu .rightmenu.hidemenuColumn
        menu .rightmenu.hidemenuHit
        menu .rightmenu.copymenu
        
        #Database_browser
        set tl .result.notebook1.nb.fdbb.1.table.l
        bind [$tl bodypath] <Button-3> "
        set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
        catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
        set db \[lindex \[$tl get \$y\] 24\]
        set id \[lindex \[$tl get \$y\] 23\]
        rightmenu dbb \$db \$id \$coord
        "
        #Database_info
        set tl .result.notebook1.nb.fdb_info.1.table.l
        bind [$tl bodypath] <Button-3> "
        set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
        catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
        set id \[lindex \[$tl get \$y\] 3\]
        rightmenu db_info db_info \$id \$coord
        "
}