proc sequence_browser_init {} {
    global env
    global closeImg
    global checkedImg
    global uncheckedImg
    
    #Creating menu buttons
    .menubar.tab.menu add command -label "Sequence browser" -command "catch {create_tab sb}"
    
    # Sequence Browser
    set notebook .result.notebook1.nb
    set frame [$notebook insert end sb -text "Sequence browser" -raisecmd "catch {update_info_sb}"]
    frame $frame.0
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command ".result.notebook1.nb raise dbb; close_tab sb"
    ComboBox $frame.0.feat -modifycmd {getRefs .result.notebook1.nb.fsb.0.feat} -width 15 -hottrack 1 -background white -text "all" -values {all {with hits} {without hits} {with comment}}
    label $frame.0.label0 -text "    "
    button $frame.0.first -text "<<" -command "database_browser_showSeq 0"
    button $frame.0.prev -text "<"  -command "database_browser_showSeq 2"
    label $frame.0.label1 -text ""
    label $frame.0.label2 -text " to "
    label $frame.0.label3 -text ""
    label $frame.0.label4 -text ""
    button $frame.0.next -text ">" -command "database_browser_showSeq 3"
    button $frame.0.last -text ">>" -command "database_browser_showSeq 1"
    frame $frame.0.goto -bd 2 -relief groove
    label $frame.0.goto.label -text "Entry: "
    entry $frame.0.goto.ent  -width 6 -background white -textvariable database_browser_goto
    button $frame.0.goto.but -text "Go" -command "database_browser_showSeq 5"
    frame $frame.0.search -bd 2 -relief groove
    entry $frame.0.search.ent  -width 26 -background white -textvariable database_browser_search
    button $frame.0.search.but -text "Search" -command "search_quick 0"
    frame $frame.1
    scrollbar $frame.1.panely -orient vertical -command "$frame.1.panel yview"
    text $frame.1.panel -height 1 -background white -width 100 -yscrollcommand "$frame.1.panely set"
    frame $frame.1.table
    scrollbar $frame.1.y -orient vertical -command "$frame.1.table.l yview"
    scrollbar $frame.1.table.x -orient horizontal -command "$frame.1.table.l xview"
    set nb1_tl_sequence_browser $frame.1.table.l
    tablelist::tablelist $nb1_tl_sequence_browser \
            -width 24 -height 1 -showseparators 1 -stripebackground lightblue\
            -columns {0 "" 0 "nr" 0 "seq name" 0 "id_seq" 0 "dbName"} \
            -labelcommand "$nb1_tl_sequence_browser finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -selectmode single \
            -stretch 2 \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.y set" \
            -xscrollcommand "$frame.1.table.x set" \
            -background white
    $nb1_tl_sequence_browser columnconfigure 0 \
            -editable yes \
            -editwindow checkbutton \
            -formatcommand emptystr \
            -labelimage [expr {1 ? $checkedImg : $uncheckedImg}] \
            -labelcommand "table_selection"
    $nb1_tl_sequence_browser columnconfigure 1 -sortmode real -align right -labelalign left
    $nb1_tl_sequence_browser columnconfigure 2 -sortmode dictionary
    $nb1_tl_sequence_browser columnconfigure 3 -hide yes
    $nb1_tl_sequence_browser columnconfigure 4 -hide yes
    
    pack $frame.0.goto.label $frame.0.goto.ent $frame.0.goto.but -side left -fill both
    pack $frame.0.feat $frame.0.label0 $frame.0.first $frame.0.prev $frame.0.label1 $frame.0.label2 $frame.0.label3 \
            $frame.0.label4 $frame.0.next $frame.0.last $frame.0.goto -side left -fill both
    pack $frame.0.search.ent $frame.0.search.but -side left -fill both -anchor e
    pack $frame.0.exit $frame.0.search -side right -fill both -anchor e
    pack $frame.1.table.l -side top -fill both -expand true; pack $frame.1.table.x -side top -fill both
    pack $frame.1.y $frame.1.table -side left -fill both; pack $frame.1.panel -side left -fill both -expand true; pack  $frame.1.panely -side left -fill both
    pack $frame.0 -side top -fill both
    pack $frame.1 -side top -fill both -expand true
    
    # Set up the tags
    .result.notebook1.nb.fsb.1.panel tag configure bold12 -font {-family courier -size 12 -weight bold}
    .result.notebook1.nb.fsb.1.panel tag configure bold11 -font {-family courier -size 11 -weight bold}
    .result.notebook1.nb.fsb.1.panel tag configure bold11r -font {-family courier -size 11 -weight bold} -foreground red2
    .result.notebook1.nb.fsb.1.panel tag configure bold_italics -font {-family courier -size 12 -weight bold -slant italic}
    .result.notebook1.nb.fsb.1.panel tag configure hel -font {-family helvetica -size 16 -weight bold}
    .result.notebook1.nb.fsb.1.panel tag configure helred -font {-family helvetica -size 16 -weight bold} -foreground red4
    .result.notebook1.nb.fsb.1.panel tag configure color1 -foreground red
    .result.notebook1.nb.fsb.1.panel tag configure smallBut -font {-family courier -size 6 -weight bold}
    .result.notebook1.nb.fsb.1.panel tag configure sunken -relief sunken -borderwidth 1
    
    .result.notebook1.nb.fsb.1.panel tag configure markedYellow -background yellow
    .result.notebook1.nb.fsb.1.panel tag configure markedGreen -background green
    .result.notebook1.nb.fsb.1.panel tag configure markedOrange -background orange
    .result.notebook1.nb.fsb.1.panel tag configure markedRed -background red
    .result.notebook1.nb.fsb.1.panel tag configure markedBlue -background blue
    .result.notebook1.nb.fsb.1.panel tag configure unmarked -background white
    .result.notebook1.nb.fsb.1.panel tag configure textGreen -foreground green

    #Sequence_browser rightmenu
    set tl .result.notebook1.nb.fsb.1.table.l
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    set db \[lindex \[$tl get \$y\] 4\]
    set id \[lindex \[$tl get \$y\] 3\]
    rightmenu_sequence_browser sb \$db \$id \$coord
    "
    #Sequence_browser_search rightmenu
    bind .result.notebook1.nb.fsb.1.panel <Button-3> "
    rightmenu_sequence_browser sb search - -
    "
}

proc sequence_browser_remove {} {
    #Remove menu buttons
    .menubar.tab.menu delete "Sequence browser"
    .result.notebook1.nb delete sb
}

proc update_info_sb {} {
    global env
    
    .result.notebook1.nb.fsb.1.panel delete 1.0 end
    if {$env(contig.dbType) eq "nucleotide"} {
        .result.notebook1.nb.fsb.1.panel insert end ">$env(contig.name) length=$env(contig.length) numreads=$env(contig.numreads)\n" bold11
        .result.notebook1.nb.fsb.1.panel insert end "$env(contig.sequence)\n\n"
        
        foreach prot $env(contig.proteinL) {
            .result.notebook1.nb.fsb.1.panel insert end ">[lindex $prot 5] length=[lindex $prot 2]\n" bold11
            .result.notebook1.nb.fsb.1.panel insert end "[lindex $prot 6]\n"
        }
    } elseif {$env(contig.dbType) eq "protein"} {
        foreach prot $env(contig.proteinL) {
            .result.notebook1.nb.fsb.1.panel insert end ">[lindex $prot 5] length=[lindex $prot 2]\n" bold11
            .result.notebook1.nb.fsb.1.panel insert end "[lindex $prot 6]\n\n"
        }
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, numreads, sequence FROM $env(dbName).sequences_nucleotide WHERE id_seq = '$env(contig.id_seq)'"}}]]
        foreach sRes $sql_res {
            .result.notebook1.nb.fsb.1.panel insert end ">[lindex $sRes 0] length=[lindex $sRes 1] numreads=[lindex $sRes 2]\n" bold11
            .result.notebook1.nb.fsb.1.panel insert end "[lindex $sRes 3]"
        }
        unset sql_res
    } elseif {$env(contig.dbType) eq "reads"} {
        .result.notebook1.nb.fsb.1.panel insert end ">$env(contig.name) length=$env(contig.length)\n" bold11
        .result.notebook1.nb.fsb.1.panel insert end "$env(contig.sequence)\n\n"
    }
}

proc rightmenu_sequence_browser {mode feat id coord} {
    global env
    
    .rightmenu delete 0 end
    .rightmenu.hidemenuColumn delete 0 end
    .rightmenu.copymenu delete 0 end
    
    if {$feat eq "sb"} {
        .rightmenu add command -label "Add to blast" -command "catch {blast_add_seq $feat $id}"
        .rightmenu add command -label "Create primer" -command "catch {primer3_window $feat $id}"
        .rightmenu add command -label "Edit sequence" -command "catch {sequence_edit_window $feat $id}"
        .rightmenu add command -label "New sequence" -command "catch {database_nucleotide_new_window $feat $id}"
        .rightmenu add command -label "Search repeats" -command "catch {phobos_window $feat $id}"
        .rightmenu add separator
        .rightmenu add command -label "Save table" -command "catch {table_save}"
        .rightmenu add separator
        .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
        .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook1.nb.fsb.1.table.l}"
        .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook1.nb.fsb.1.table.l}"
        .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook1.nb.fsb.1.table.l}"
        .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook1.nb.fsb.1.table.l}"
    } elseif {$feat eq "search"} {
        .rightmenu add command -label "Search" -command "search_pattern_window search_pattern_mark .result.notebook1.nb.fsb.1.panel"
    }
    
    tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
}