proc sequence_edit_init {} {
}

proc sequence_edit_remove {} {
}

proc sequence_edit_window {db id} {
    global env
    global sequence_editArr
    global sequence_edit_multiple
    global sequence_edit_search_markedSeq
    
    set sequence_edit_search_markedSeq "0 0"
    
    if {[info exists sequence_edit_multiple] ne 1} {
        set sequence_edit_multiple 0
    }
    if {$env(dbName) ne " "} {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, sequence, sequence_gap, base_cover FROM [string tolower $db].sequences_nucleotide WHERE id_seq = '$id'"}}]]
        foreach sRes $sql_res {
            set name [lindex $sRes 0]
            if {[lindex $sRes 2] ne ""} {
                set sequence_editArr($name.seq) [lindex $sRes 2]
            } else {
                set sequence_editArr($name.seq) [lindex $sRes 1]
            }
            set sequence_editArr($name.base_cover) [lindex $sRes 3]
        }
        unset sql_res
        
        set draw 0
        if {[string length $sequence_editArr($name.seq)] > 20000} {
            set draw [tk_dialog .dialog "Warning!" "The sequence is [string length $sequence_editArr($name.seq)] bp long,\nthis may take a while.\nAre you sure to proceed?" "" 1 "Yes" "No"]
        }
        if {$draw eq 0} {
            set sequence_editArr($name.id_seq) $id
            set sequence_editArr($name.db) $db
            set sequence_editArr($name.selected_seq) " "
            if {$sequence_edit_multiple} {
                set sequence_editArr($name.windowName) .editNuc$name
                catch {destroy $sequence_editArr($name.windowName)}
            } else {
                set sequence_editArr($name.windowName) .editNuc
                catch {destroy $sequence_editArr($name.windowName)}
            }
            set t $sequence_editArr($name.windowName)
            toplevel $t
            wm minsize $t 800 600
            wm title $t "Edit: $name"
            
            frame $t.seq
            frame $t.seq.head
            label $t.seq.head.l -text "Contig sequence:"
            label $t.seq.head.pos -text ""
            canvas $t.seq.c -height 88 -width 300 -xscrollcommand "$t.seq.x set" -background white
            scrollbar $t.seq.x -orient horizontal -command "$t.seq.c xview"
            frame $t.prot
            label $t.prot.l -text "Open reading frames:"
            canvas $t.prot.c -height 200 -width 300 -background white
            frame $t.panel
            label $t.panel.l -text "Selected sequence:"
            text $t.panel.p -background white -width 100 -height 10
            frame $t.buts -bd 2 -relief groove
            checkbutton $t.buts.multiple -text "multiple Windows" -variable sequence_edit_multiple
            button $t.buts.cancel -text "Close" -command "destroy $t"
            
            pack $t.seq.head.l -side left; pack $t.seq.head.pos -side right
            pack $t.seq.head -side top -fill both; pack $t.seq.c -side top -fill both; pack $t.seq.x -side top -fill both
            pack $t.prot.l -side top -fill both; pack $t.prot.c -expand true -side top -fill both
            pack $t.panel.l -side top -fill both; pack $t.panel.p -expand true -side top -fill both
            pack $t.buts.cancel -side left -expand 1 -anchor c; pack $t.buts.multiple -side right
            pack $t.seq $t.prot -side top -fill both; pack $t.panel -expand true -side top -fill both; pack $t.buts -side top -fill both
            
            wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
            raise $t
            
            #seq
            sequence_edit_seq_draw $name
            
            #ORFs
            set sequence_editArr($name.width) 790
            set sequence_editArr($name.height) 590
            set sequence_editArr($name.posx) [expr $sequence_editArr($name.width).0 / [string length $sequence_editArr($name.seq)].0]
            sequence_edit_orf_draw $name
            
            $t.panel.p tag configure markedGreen -background green
            set comm "sequence_edit_right_menu $name bottom"
            bind $t.panel.p <ButtonRelease-3> $comm
            
            bind $t.prot.c <ButtonRelease-1> "sequence_edit_bind $name"
        }
    }
}

proc sequence_edit_right_menu {name pos} {
    .sequence_edit_rightmenu delete 0 end
    if {$pos eq "bottom"} {
        .sequence_edit_rightmenu add command -label "Search" -command "sequence_edit_search $name bottom"
    } else {
        .sequence_edit_rightmenu.insert delete 0 end
        .sequence_edit_rightmenu.replace delete 0 end
        .sequence_edit_rightmenu add cascade -label "Insert..." -menu .sequence_edit_rightmenu.insert
        .sequence_edit_rightmenu add cascade -label "Replace with..." -menu .sequence_edit_rightmenu.replace
        .sequence_edit_rightmenu.insert add command -label "A" -command "sequence_edit $name i $pos A"
        .sequence_edit_rightmenu.insert add command -label "T" -command "sequence_edit $name i $pos T"
        .sequence_edit_rightmenu.insert add command -label "C" -command "sequence_edit $name i $pos C"
        .sequence_edit_rightmenu.insert add command -label "G" -command "sequence_edit $name i $pos G"
        .sequence_edit_rightmenu.replace add command -label "A" -command "sequence_edit $name r $pos A"
        .sequence_edit_rightmenu.replace add command -label "T" -command "sequence_edit $name r $pos T"
        .sequence_edit_rightmenu.replace add command -label "C" -command "sequence_edit $name r $pos C"
        .sequence_edit_rightmenu.replace add command -label "G" -command "sequence_edit $name r $pos G"
        .sequence_edit_rightmenu.replace add command -label "*" -command "sequence_edit $name r $pos *"
        .sequence_edit_rightmenu add command -label "Delete" -command "sequence_edit $name d $pos -"
        .sequence_edit_rightmenu add separator
        .sequence_edit_rightmenu add command -label "Search" -command "sequence_edit_search $name head"
    }   
    tk_popup .sequence_edit_rightmenu [winfo pointerx .] [winfo pointery .]
}

proc sequence_edit {name type pos base} {
    global sequence_editArr
    
    if {$sequence_editArr($name.base_cover) eq ""} {
        if {$type eq "d"} {
            set sequence_editArr($name.seq) [string replace $sequence_editArr($name.seq) $pos $pos]
        } elseif {$type eq "i"} {
            set sequence_editArr($name.seq) [string replace $sequence_editArr($name.seq) $pos $pos "$base[string index $sequence_editArr($name.seq) $pos]"]
        } elseif {$type eq "r"} {
            set sequence_editArr($name.seq) [string replace $sequence_editArr($name.seq) $pos $pos $base]
        }
    } else {
        if {$type eq "d"} {
            set sequence_editArr($name.seq) [string replace $sequence_editArr($name.seq) $pos $pos]
            set sequence_editArr($name.base_cover) [lreplace $sequence_editArr($name.base_cover) $pos $pos]
        } elseif {$type eq "i"} {
            set sequence_editArr($name.seq) [string replace $sequence_editArr($name.seq) $pos $pos "$base[string index $sequence_editArr($name.seq) $pos]"]
            set sequence_editArr($name.base_cover) [linsert $sequence_editArr($name.base_cover) $pos "0 0 0 0 0"]
        } elseif {$type eq "r"} {
            set sequence_editArr($name.seq) [string replace $sequence_editArr($name.seq) $pos $pos $base]
        }
    }
    
    set sequence_editArr($name.width) [expr [winfo width $sequence_editArr($name.windowName).prot] - 10]
    set sequence_editArr($name.height) [winfo height $sequence_editArr($name.windowName).prot]
    set sequence_editArr($name.posx) [expr $sequence_editArr($name.width).0 / [string length $sequence_editArr($name.seq)].0]
    sequence_edit_seq_draw $name
    sequence_edit_orf_draw $name
}

proc sequence_edit_complement {mode name} {
    global sequence_editArr
    set tmp ""
    set seq [string map {A T T A G C C G a t t a g c c g R Y Y R K M M K H D D H B V V B r y y r k m m k h d d h b v v b} [regsub -all {\*} $sequence_editArr($name.seq) ""]]
    for {set n [expr [string length $seq] - 1]} {$n >= 0} {set n [expr $n - 1]} {
        append tmp [string index $seq $n]
    }
    set seq $tmp
    unset tmp
    
    if {$mode eq "sequence_edit"} {
        $sequence_editArr($name.windowName).panel.p delete 1.0 end
        $sequence_editArr($name.windowName).panel.p insert end $seq
    }
}

proc sequence_edit_seq_draw {name} {
    global sequence_editArr
    
    catch {$sequence_editArr($name.windowName).seq.c delete base}
    catch {
        foreach tag $sequence_editArr($name.seq_TagL) {
            $sequence_editArr($name.windowName).seq.c delete $tag
        }
    }
    
    set x 5
    for {set i 0} {$i < [string length $sequence_editArr($name.seq)]} {incr i} {
        $sequence_editArr($name.windowName).seq.c create text $x 48 -text [string index $sequence_editArr($name.seq) $i] -anchor w -tag base_$i
        set base_sum 0
        set base_max 0
        if {$sequence_editArr($name.base_cover) ne ""} {
            foreach b [lindex $sequence_editArr($name.base_cover) $i] {
                set base_sum [expr $base_sum + $b]
                if {$b > $base_max} {
                    set base_max $b
                }
            }
            if {$base_sum eq 0} {
                set base_color blue
            } elseif {[expr $base_max.0 / $base_sum.0] > 0.9} {
                set base_color green
            } elseif {[expr $base_max.0 / $base_sum.0] > 0.6} {
                set base_color orange
            } else {
                set base_color red
            }
            $sequence_editArr($name.windowName).seq.c create rect [expr $x - 2] 32 [expr $x + 9] 40 -tag base -fill $base_color
            set base_sum [expr $base_sum - [lindex [lindex $sequence_editArr($name.base_cover) $i] 4]]
            if {$base_sum > 30} {
                set base_sum 30
            }
            $sequence_editArr($name.windowName).seq.c create rect [expr $x - 2] [expr 30 - $base_sum] [expr $x + 9] 30 -tag base -fill blue
        }
        set comm "sequence_edit_seq_bind $name base_$i $i $x"
        $sequence_editArr($name.windowName).seq.c bind base_$i <ButtonRelease-1> $comm
        set comm "sequence_edit_right_menu $name $i"
        $sequence_editArr($name.windowName).seq.c bind base_$i <ButtonPress-3> $comm
        lappend sequence_editArr($name.seq_TagL) base_$i
        set x [expr $x + 12]
    }
    set scrollregion "0 0 $x 0"
    $sequence_editArr($name.windowName).seq.c configure -scrollregion $scrollregion
}

proc sequence_edit_orf_draw {name} {
    global sequence_editArr
    catch {$sequence_editArr($name.windowName).prot.c delete seq}
    catch {$sequence_editArr($name.windowName).prot.c delete line}
    catch {$sequence_editArr($name.windowName).prot.c delete start}
    catch {$sequence_editArr($name.windowName).prot.c delete stop}
    catch {$sequence_editArr($name.windowName).seq.c delete orfs}
    catch {
        foreach tag $sequence_editArr($name.orf_TagL) {
            $sequence_editArr($name.windowName).prot.c delete $tag
        }
    }
    $sequence_editArr($name.windowName).prot.c create rect 5 7 [expr 5 + $sequence_editArr($name.width)] 22 -tag seq -fill yellow
    set comm "sequence_edit_orf_bind seq $name seq 0 0"
    $sequence_editArr($name.windowName).prot.c bind seq <ButtonRelease-1> $comm
    set comm "rightmenu_sequence_edit sequence_edit sequence_edit $name [regsub -all {[*-:]} $sequence_editArr($name.seq) ""]"
    $sequence_editArr($name.windowName).prot.c bind seq <Button-3> $comm
    lappend ssequence_editArr($name.orf_TagL) seq
    set sequence_editArr($name.protL) ""
    if {$sequence_editArr($name.seq) ne ""} {
        for {set fr 1} {$fr <= 6} {incr fr} {
            $sequence_editArr($name.windowName).seq.c create line 3 [expr 68 + 3 * $fr] [expr 5 + [string length $sequence_editArr($name.seq)] * 12] [expr 68 + 3 * $fr] -tag orfs
            switch $fr {
                1 {set h 0; set i 0}
                2 {set h 0; set i 1}
                3 {set h 0; set i 2}
                4 {set h 1; set i 2}
                5 {set h 1; set i 1}
                6 {set h 1; set i 0}
            }
            
            if {$h} {
                set drawEnd [string length $sequence_editArr($name.seq)]
                set orf 0
                set tag $fr; append tag "_$orf"
                set pos [translateNuc $sequence_editArr($name.seq) T $fr]
                if {[lindex $pos 1] ne ""} {
                    set drawEnd [lindex [lindex $pos 1] 0]
                    $sequence_editArr($name.windowName).prot.c create rect [expr 5 + int([lindex [lindex $pos 1] 0].0 * $sequence_editArr($name.posx))] [expr 10 + $fr * 25] [expr 5 + $sequence_editArr($name.width)] [expr 25 + $fr * 25] -tag $tag -fill green -outline green
                    lappend sequence_editArr($name.orf_TagL) $tag
                    set comm "sequence_edit_orf_bind $tag $name [lindex [lindex [lindex $pos 2] $orf] 0] $fr [expr [string length $sequence_editArr($name.seq)] - (6 - $fr)]"
                    $sequence_editArr($name.windowName).prot.c bind $tag <ButtonRelease-1> $comm
                    lappend sequence_editArr($name.protL) "$fr [lindex [lindex $pos 2] $orf]"
                } else {
                    set drawEnd 0
                    $sequence_editArr($name.windowName).prot.c create rect 5 [expr 10 + $fr * 25] [expr 5 + $sequence_editArr($name.width)] [expr 25 + $fr * 25] -tag $tag -fill green -outline green
                    lappend sequence_editArr($name.orf_TagL) $tag
                    set comm "sequence_edit_orf_bind $tag $name [lindex [lindex [lindex $pos 2] $orf] 0] $fr [expr [string length $sequence_editArr($name.seq)] - (6 - $fr)]"
                    $sequence_editArr($name.windowName).prot.c bind $tag <ButtonRelease-1> $comm
                    lappend sequence_editArr($name.protL) "$fr [lindex [lindex $pos 2] $orf]"
                }
                incr orf
                foreach s [lindex $pos 0] {
                    if {$s < $drawEnd} {
                        foreach e "[lindex $pos 1] 0" {
                            if {$e < $s} {
                                set tag $fr; append tag "_$orf"
                                set drawEnd $e
                                $sequence_editArr($name.windowName).prot.c create rect [expr 5 + int($e.0 * $sequence_editArr($name.posx))] [expr 10 + $fr * 25] [expr 5 + int($s.0 * $sequence_editArr($name.posx))] [expr 25 + $fr * 25] -tag $tag -fill green -outline green
                                lappend sequence_editArr($name.orf_TagL) $tag
                                set comm "sequence_edit_orf_bind $tag $name [lindex [lindex [lindex $pos 2] $orf] 0] $fr $s"
                                $sequence_editArr($name.windowName).prot.c bind $tag <ButtonRelease-1> $comm
                                lappend sequence_editArr($name.protL) "$fr [lindex [lindex $pos 2] $orf]"
                                incr orf
                                break
                            }
                        }
                    }
                    $sequence_editArr($name.windowName).prot.c create line [expr 5 + int($s.0 * $sequence_editArr($name.posx))] [expr 10 + $fr * 25] [expr 5 + int($s.0 * $sequence_editArr($name.posx))] [expr 25 + $fr * 25] -tag start -fill blue
                    $sequence_editArr($name.windowName).seq.c create rect [expr 3 + ($s - 3) * 12] [expr 67 + $fr * 3] [expr 3 + $s * 12] [expr 68 + $fr * 3] -tag orfs -fill yellow -outline blue
                }
                foreach s [lindex $pos 1] {
                    $sequence_editArr($name.windowName).prot.c create line [expr 5 + int($s.0 * $sequence_editArr($name.posx))] [expr 10 + $fr * 25] [expr 5 + int($s.0 * $sequence_editArr($name.posx))] [expr 25 + $fr * 25] -tag stop -fill red
                    $sequence_editArr($name.windowName).seq.c create rect [expr -9 + ($s - 3) * 12] [expr 67 + $fr * 3] [expr -9 + $s * 12] [expr 68 + $fr * 3] -tag orfs -fill red -outline red
                }
            } else {
                set drawEnd 0
                set orf 0
                set tag $fr; append tag "_$orf"
                set pos [translateNuc $sequence_editArr($name.seq) T $fr]
                if {[lindex $pos 1] ne ""} {
                    set drawEnd [lindex [lindex $pos 1] 0]
                    $sequence_editArr($name.windowName).prot.c create rect 5 [expr 10 + $fr * 25] [expr 5 + int([lindex [lindex $pos 1] 0].0 * $sequence_editArr($name.posx))] [expr 25 + $fr * 25] -tag $tag -fill green -outline green
                    lappend sequence_editArr($name.orf_TagL) $tag
                    set comm "sequence_edit_orf_bind $tag $name [lindex [lindex [lindex $pos 2] $orf] 0] $fr [expr $fr - 1]"
                    $sequence_editArr($name.windowName).prot.c bind $tag <ButtonRelease-1> $comm
                    lappend sequence_editArr($name.protL) "$fr [lindex [lindex $pos 2] $orf]"
                } else {
                    set drawEnd [string length $sequence_editArr($name.seq)]
                    $sequence_editArr($name.windowName).prot.c create rect 5 [expr 10 + $fr * 25] [expr 5 + $sequence_editArr($name.width)] [expr 25 + $fr * 25] -tag $tag -fill green -outline green
                    lappend sequence_editArr($name.orf_TagL) $tag
                    set comm "sequence_edit_orf_bind $tag $name [lindex [lindex [lindex $pos 2] $orf] 0] $fr [expr $fr - 1]"
                    $sequence_editArr($name.windowName).prot.c bind $tag <ButtonRelease-1> $comm
                    lappend sequence_editArr($name.protL) "$fr [lindex [lindex $pos 2] $orf]"
                }
                incr orf
                foreach s [lindex $pos 0] {
                    if {$s > $drawEnd} {
                        foreach e "[lindex $pos 1] [string length $sequence_editArr($name.seq)]" {
                            if {$e > $s} {
                                set tag $fr; append tag "_$orf"
                                set drawEnd $e
                                $sequence_editArr($name.windowName).prot.c create rect [expr 5 + int($s.0 * $sequence_editArr($name.posx))] [expr 10 + $fr * 25] [expr 5 + int($e.0 * $sequence_editArr($name.posx))] [expr 25 + $fr * 25] -tag $tag -fill green -outline green
                                lappend sequence_editArr($name.orf_TagL) $tag
                                set comm "sequence_edit_orf_bind $tag $name [lindex [lindex [lindex $pos 2] $orf] 0] $fr $s"
                                $sequence_editArr($name.windowName).prot.c bind $tag <ButtonRelease-1> $comm
                                lappend sequence_editArr($name.protL) "$fr [lindex [lindex $pos 2] $orf]"
                                incr orf
                                break
                            }
                        }
                    }
                    $sequence_editArr($name.windowName).prot.c create line [expr 5 + int($s.0 * $sequence_editArr($name.posx))] [expr 10 + $fr * 25] [expr 5 + int($s.0 * $sequence_editArr($name.posx))] [expr 25 + $fr * 25] -tag start -fill blue
                    $sequence_editArr($name.windowName).seq.c create rect [expr 3 + $s * 12] [expr 67 + $fr * 3] [expr 3 + ($s + 3) * 12] [expr 68 + $fr * 3] -tag orfs -fill yellow -outline blue
                }
                foreach s [lindex $pos 1] {
                    $sequence_editArr($name.windowName).prot.c create line [expr 5 + int($s.0 * $sequence_editArr($name.posx))] [expr 10 + $fr * 25] [expr 5 + int($s.0 * $sequence_editArr($name.posx))] [expr 25 + $fr * 25] -tag stop -fill red
                    $sequence_editArr($name.windowName).seq.c create rect [expr 3 + $s * 12] [expr 67 + $fr * 3] [expr 3 + ($s + 3) * 12] [expr 68 + $fr * 3] -tag orfs -fill red  -outline red
                }
            }
        }
    }
}

proc sequence_edit_bind {name} {
    global sequence_editArr
    
    #x position
    set x [expr [winfo pointerx $sequence_editArr($name.windowName).prot.c] - [winfo rootx $sequence_editArr($name.windowName).prot.c]]
    set i [expr int(($x.0 - 5.0) / $sequence_editArr($name.posx))]
    if {$i < 1} {
        set i 1
    } elseif {$i >= [string length $sequence_editArr($name.seq)]} {
        set i [expr [string length $sequence_editArr($name.seq)] - 1]
    }
    set x [expr 5 + $i * 12]
    sequence_edit_seq_bind $name base_$i $i $x
    set xscroll [expr ($i.0 - 20.0) / [string length $sequence_editArr($name.seq)].0]
    if {$xscroll < 0} {
        set xscroll 0.0
    }
    $sequence_editArr($name.windowName).seq.c xview moveto $xscroll
    
    #y position
    catch {$sequence_editArr($name.windowName).prot.c delete box}
    set y [expr [winfo pointery $sequence_editArr($name.windowName).prot.c] - [winfo rooty $sequence_editArr($name.windowName).prot.c]]
    if {$y > 155} {
        $sequence_editArr($name.windowName).prot.c create line 3 155 [expr $sequence_editArr($name.width) + 8] 155 -tag box
        $sequence_editArr($name.windowName).prot.c create line 3 180 [expr $sequence_editArr($name.width) + 8] 180 -tag box
        $sequence_editArr($name.windowName).prot.c create line 3 155 3 180 -tag box
        $sequence_editArr($name.windowName).prot.c create line [expr $sequence_editArr($name.width) + 8] 155 [expr $sequence_editArr($name.width) + 8] 180 -tag box
    } elseif {$y > 130} {
        $sequence_editArr($name.windowName).prot.c create line 3 130 [expr $sequence_editArr($name.width) + 8] 130 -tag box
        $sequence_editArr($name.windowName).prot.c create line 3 155 [expr $sequence_editArr($name.width) + 8] 155 -tag box
        $sequence_editArr($name.windowName).prot.c create line 3 130 3 155 -tag box
        $sequence_editArr($name.windowName).prot.c create line [expr $sequence_editArr($name.width) + 8] 130 [expr $sequence_editArr($name.width) + 8] 155 -tag box
    } elseif {$y > 105} {
        $sequence_editArr($name.windowName).prot.c create line 3 105 [expr $sequence_editArr($name.width) + 8] 105 -tag box
        $sequence_editArr($name.windowName).prot.c create line 3 130 [expr $sequence_editArr($name.width) + 8] 130 -tag box
        $sequence_editArr($name.windowName).prot.c create line 3 105 3 130 -tag box
        $sequence_editArr($name.windowName).prot.c create line [expr $sequence_editArr($name.width) + 8] 105 [expr $sequence_editArr($name.width) + 8] 130 -tag box
    } elseif {$y > 80} {
        $sequence_editArr($name.windowName).prot.c create line 3 80 [expr $sequence_editArr($name.width) + 8] 80 -tag box
        $sequence_editArr($name.windowName).prot.c create line 3 105 [expr $sequence_editArr($name.width) + 8] 105 -tag box
        $sequence_editArr($name.windowName).prot.c create line 3 80 3 105 -tag box
        $sequence_editArr($name.windowName).prot.c create line [expr $sequence_editArr($name.width) + 8] 80 [expr $sequence_editArr($name.width) + 8] 105 -tag box
    } elseif {$y > 55} {
        $sequence_editArr($name.windowName).prot.c create line 3 55 [expr $sequence_editArr($name.width) + 8] 55 -tag box
        $sequence_editArr($name.windowName).prot.c create line 3 80 [expr $sequence_editArr($name.width) + 8] 80 -tag box
        $sequence_editArr($name.windowName).prot.c create line 3 55 3 80 -tag box
        $sequence_editArr($name.windowName).prot.c create line [expr $sequence_editArr($name.width) + 8] 55 [expr $sequence_editArr($name.width) + 8] 80 -tag box
    } elseif {$y > 30} {
        $sequence_editArr($name.windowName).prot.c create line 3 30 [expr $sequence_editArr($name.width) + 8] 30 -tag box
        $sequence_editArr($name.windowName).prot.c create line 3 55 [expr $sequence_editArr($name.width) + 8] 55 -tag box
        $sequence_editArr($name.windowName).prot.c create line 3 30 3 55 -tag box
        $sequence_editArr($name.windowName).prot.c create line [expr $sequence_editArr($name.width) + 8] 30 [expr $sequence_editArr($name.width) + 8] 55 -tag box
    }
}

proc sequence_edit_seq_bind {name base i pos} {
    global sequence_editArr
    
    catch {$sequence_editArr($name.windowName).seq.c delete rect}
    catch {$sequence_editArr($name.windowName).prot.c delete line}
    catch {$sequence_editArr($name.windowName).seq.c itemconfigure [lindex $sequence_editArr($name.base) 0] -fill black}
    catch {
        $sequence_editArr($name.windowName).seq.c itemconfigure $base -fill red
        $sequence_editArr($name.windowName).seq.c create rect [expr $pos - 2] 41 [expr $pos + 9] 55 -tag rect
    }
    catch {$sequence_editArr($name.windowName).seq.head.pos configure -text "Position: $i    (A: [lindex [lindex $sequence_editArr($name.base_cover) $i] 0];  T:[lindex [lindex $sequence_editArr($name.base_cover) $i] 1];  C: [lindex [lindex $sequence_editArr($name.base_cover) $i] 2];  G: [lindex [lindex $sequence_editArr($name.base_cover) $i] 3];  *: [lindex [lindex $sequence_editArr($name.base_cover) $i] 4])"}
    $sequence_editArr($name.windowName).prot.c create rect [expr 4 + int($i.0 * $sequence_editArr($name.posx))] 0 [expr 6 + int($i.0 * $sequence_editArr($name.posx))] $sequence_editArr($name.height) -tag line -fill red
    set sequence_editArr($name.base) "$base $pos"
}

proc sequence_edit_orf_bind {tag name id fr pos} {
    global sequence_editArr
    
    catch {$sequence_editArr($name.windowName).seq.c delete amino}
    
    if {$id eq "seq"} {
        $sequence_editArr($name.windowName).panel.p delete 1.0 end
        $sequence_editArr($name.windowName).panel.p insert end [regsub -all {\*} $sequence_editArr($name.seq) ""]
        if {$sequence_editArr($name.selected_seq) ne " " && $sequence_editArr($name.selected_seq) ne "seq"} {
            $sequence_editArr($name.windowName).prot.c itemconfigure $sequence_editArr($name.selected_seq) -fill green -outline green
        }
        set sequence_editArr($name.selected_seq) seq
        $sequence_editArr($name.windowName).prot.c itemconfigure seq -fill orange
    } elseif {$id eq "all"} {
        if {$sequence_editArr($name.selected_seq) ne " "} {
            if {$sequence_editArr($name.selected_seq) eq "seq"} {
                $sequence_editArr($name.windowName).prot.c itemconfigure seq -fill yellow
            } else {
                $sequence_editArr($name.windowName).prot.c itemconfigure $sequence_editArr($name.selected_seq) -fill green -outline green
            }
        }
        set prot [translateNuc $sequence_editArr($name.seq) A $fr]
        $sequence_editArr($name.windowName).panel.p delete 1.0 end
        $sequence_editArr($name.windowName).panel.p insert end ">Protein_Frame_$fr\n$prot"
        
        if {$fr > 3} {
            set pos [expr [string length $sequence_editArr($name.seq)] - (6 - $fr)]
            set j 0
            set x [expr -7 + 12 * ($pos - 1)]
            for {set i 0} {$i < [string length $prot]} {incr i} {
                set window 1
                set ok 0
                while {$ok ne 2} {
                    incr window
                    set gaps [regexp -all {\*} [string range $sequence_editArr($name.seq) [expr $pos - 1 - $j - $window - $i * 3] [expr $pos - 1 - $j - $i * 3]]]
                    set ok [expr $window - $gaps]
                }
                set x [expr $x - 12 * $gaps]
                set j [expr $j + $gaps]
                $sequence_editArr($name.windowName).seq.c create text $x 62 -text [string index $prot $i] -anchor w -tag amino -fill green
                set x [expr $x - 12 * 3]
            }
            
        } else {
            set pos [expr $fr - 1]
            set j 0
            set x [expr 17 + 12 * $pos]
            for {set i 0} {$i < [string length $prot]} {incr i} {
                set window 1
                set ok 0
                while {$ok ne 2} {
                    incr window
                    set gaps [regexp -all {\*} [string range $sequence_editArr($name.seq) [expr $pos + $j + $i * 3] [expr $pos + $j + $window + $i * 3]]]
                    set ok [expr $window - $gaps]
                }
                set x [expr $x + 12 * $gaps]
                set j [expr $j + $gaps]
                $sequence_editArr($name.windowName).seq.c create text $x 62 -text [string index $prot $i] -anchor w -tag amino -fill green
                set x [expr $x + 12 * 3]
            }
        }
    } else {
        if {$sequence_editArr($name.selected_seq) ne " "} {
            if {$sequence_editArr($name.selected_seq) eq "seq"} {
                $sequence_editArr($name.windowName).prot.c itemconfigure seq -fill yellow 
            } else {
                $sequence_editArr($name.windowName).prot.c itemconfigure $sequence_editArr($name.selected_seq) -fill green -outline green
            }
        }
        set sequence_editArr($name.selected_seq) $tag
        $sequence_editArr($name.windowName).prot.c itemconfigure $tag -fill darkgreen -outline darkgreen
        $sequence_editArr($name.windowName).panel.p delete 1.0 end
        foreach prot $sequence_editArr($name.protL) {
            if {[lindex $prot 0] eq $fr && [lindex $prot 1] eq $id} {
                $sequence_editArr($name.windowName).panel.p insert end ">Protein_Frame_[lindex $prot 0]_ORF_[lindex $prot 1]\n[lindex $prot 2]"
                if {$fr > 3} {
                    set j 0
                    set x [expr -7 + 12 * ($pos - 1)]
                    for {set i 0} {$i < [string length [lindex $prot 2]]} {incr i} {
                        set window 1
                        set ok 0
                        while {$ok ne 2} {
                            incr window
                            set gaps [regexp -all {\*} [string range $sequence_editArr($name.seq) [expr $pos - 1 - $j - $window - $i * 3] [expr $pos - 1 - $j - $i * 3]]]
                            set ok [expr $window - $gaps]
                        }
                        set x [expr $x - 12 * $gaps]
                        set j [expr $j + $gaps]
                        $sequence_editArr($name.windowName).seq.c create text $x 62 -text [string index [lindex $prot 2] $i] -anchor w -tag amino -fill green
                        set x [expr $x - 12 * 3]
                    }
                    
                } else {
                    set j 0
                    set x [expr 17 + 12 * $pos]
                    for {set i 0} {$i < [string length [lindex $prot 2]]} {incr i} {
                        set window 1
                        set ok 0
                        while {$ok ne 2} {
                            incr window
                            set gaps [regexp -all {\*} [string range $sequence_editArr($name.seq) [expr $pos + $j + $i * 3] [expr $pos + $j + $window + $i * 3]]]
                            set ok [expr $window - $gaps]
                        }
                        set x [expr $x + 12 * $gaps]
                        set j [expr $j + $gaps]
                        $sequence_editArr($name.windowName).seq.c create text $x 62 -text [string index [lindex $prot 2] $i] -anchor w -tag amino -fill green
                        set x [expr $x + 12 * 3]
                    }
                }
                break
            }
        }
    }
}

proc sequence_edit_search {name mode} {
    global sequence_editArr
    
    if {$mode eq "head"} {
        search_pattern_window sequence_edit_search_show "$name $sequence_editArr($name.seq)"
    } elseif {$mode eq "bottom"} {
        search_pattern_window search_pattern_mark $sequence_editArr($name.windowName).panel.p
    }
}

proc sequence_edit_search_show {name pos} {
    global sequence_editArr
    global sequence_edit_search_markedSeq
    
    for {set i [lindex $sequence_edit_search_markedSeq 0]} {$i <= [lindex $sequence_edit_search_markedSeq 1]} {incr i} {
        catch {$sequence_editArr($name.windowName).seq.c itemconfigure base_$i -fill black}
    }
    for {set i [lindex $pos 0]} {$i <= [lindex $pos 1]} {incr i} {
        $sequence_editArr($name.windowName).seq.c itemconfigure base_$i -fill red
    }
    set x [expr 5 + [lindex $pos 0] * 12]
    sequence_edit_seq_bind $name base_[lindex $pos 0] [lindex $pos 0] $x
    set xscroll [expr ([lindex $pos 0].0 - 20.0) / [string length $sequence_editArr($name.seq)].0]
    if {$xscroll < 0} {
        set xscroll 0.0
    }
    $sequence_editArr($name.windowName).seq.c xview moveto $xscroll
    set sequence_edit_search_markedSeq $pos
}

proc sequence_edit_coverage_show {db id} {
    global env
    global sequence_editArr
    
    if {$db eq "sequence_edit"} {
        set db $sequence_editArr($id.db)
        set id $sequence_editArr($id.id_seq)
    }
    if {$env(dbName) ne " "} {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, base_cover FROM [string tolower $db].sequences_nucleotide WHERE id_seq = '$id'"}}]]
        foreach sRes $sql_res {
            set name [lindex $sRes 0]
            set base_cover [lindex $sRes 1]
        }
        unset sql_res
        catch {destroy .contigCoverage}
        set t .contigCoverage
        toplevel $t
        wm minsize $t 800 400
        wm resizable $t 1 0
        wm title $t "Coverage: $name"
        
        frame $t.seq
        frame $t.seq.head
        label $t.seq.head.pos -text ""
        canvas $t.seq.c -height 350 -width 300 -xscrollcommand "$t.seq.x set" -background white
        scrollbar $t.seq.x -orient horizontal -command "$t.seq.c xview"
        frame $t.buts -bd 2 -relief groove
        button $t.buts.cancel -text "Close" -command "destroy $t"
        
        pack $t.seq.head.pos -side right
        pack $t.seq.head -side top -fill both; pack $t.seq.c -side top -fill both; pack $t.seq.x -side top -fill both
        pack $t.buts.cancel -side left -expand 1 -anchor c
        pack $t.seq $t.buts -side top -fill both
        
        wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
        raise $t
        
        $t.seq.c create line 25 5 25 330 -tag a
        $t.seq.c create line 25 330 [expr 175 + [llength $base_cover]] 330 -tag a
        set max 0
        foreach base $base_cover {
            set base_sum 0
            set base_max 0
            foreach b $base {
                set base_sum [expr $base_sum + $b]
                if {$b > $base_max} {
                    set base_max $b
                }
            }
            if {$base_sum eq 0} {
                set base_color blue
            } elseif {[expr $base_max.0 / $base_sum.0] > 0.9} {
                set base_color green
            } elseif {[expr $base_max.0 / $base_sum.0] > 0.6} {
                set base_color orange
            } else {
                set base_color red
            }
            set base_sum [expr $base_sum - [lindex $base 4]]
            if {$base_sum > $max} {
                set max $base_sum
            }
            lappend coverL "$base_sum $base_color"
        }
        set levels 5
        if {$max < 5} {
            set levels $max
        }
        for {set i 0} {$i <= $levels} {incr i} {
            $t.seq.c create line 22 [expr 5 + int(325.0 / $levels.0 * $i.0)] [expr 25 + [llength $base_cover]] [expr 5 + int(325.0 / $levels.0 * $i.0)] -tag a
            set y "[expr int($max.0 / $levels.0 * ($levels.0 - $i.0))]"
            $t.seq.c create text 3 [expr 5 + int(325.0 / $levels.0 * $i.0)] -text $y -anchor w -tag a
        }
        for {set i 0} {$i <= [expr 150 + [llength $base_cover]]} {set i [expr $i + 150]} {
            $t.seq.c create line [expr 24 + $i] 330 [expr 24 + $i] 335 -tag a
            $t.seq.c create text [expr 24 + $i] 340 -text $i -anchor c -tag a
        }
        
        set x 25
        foreach cover $coverL {
            incr x
            $t.seq.c create line $x [expr 330 - int((325.0 / $max.0) * [lindex $cover 0].0)] $x 330 -tag a -fill [lindex $cover 1]
        }
        set scrollregion "0 0 [expr 5 + [llength $base_cover]] 0"
        $t.seq.c configure -scrollregion $scrollregion
    }
}

proc rightmenu_sequence_edit {mode feat id coord} {
    global env
    
    .rightmenu delete 0 end
    .rightmenu.hidemenuColumn delete 0 end
    .rightmenu.copymenu delete 0 end
    
    .rightmenu add command -label "Add to blast" -command "catch {blast_add_seq $feat $coord}"
    .rightmenu add command -label "Coverage" -command "sequence_edit_coverage_show $feat $id"
    .rightmenu add command -label "New sequence" -command "catch {database_nucleotide_new_window $feat $coord}"
    .rightmenu add command -label "Show complementary strand" -command "catch {sequence_edit_complement $feat $id}"
    .rightmenu add cascade -label "Translate whole frame..." -menu .rightmenu.hidemenuColumn
    .rightmenu.hidemenuColumn add command -label "1" -command "catch {sequence_edit_orf_bind - $id all 1 all}"
    .rightmenu.hidemenuColumn add command -label "2" -command "catch {sequence_edit_orf_bind - $id all 2 all}"
    .rightmenu.hidemenuColumn add command -label "3" -command "catch {sequence_edit_orf_bind - $id all 3 all}"
    .rightmenu.hidemenuColumn add command -label "4" -command "catch {sequence_edit_orf_bind - $id all 4 all}"
    .rightmenu.hidemenuColumn add command -label "5" -command "catch {sequence_edit_orf_bind - $id all 5 all}"
    .rightmenu.hidemenuColumn add command -label "6" -command "catch {sequence_edit_orf_bind - $id all 6 all}"
    .rightmenu add separator
    .rightmenu add command -label "Refresh" -command "sequence_edit $id  - - -"
    
    tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
}