package require http
package require textutil
package require Pgtcl

proc init {argv} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set host "134.245.63.223"
    set port "5432"
    set user "lkraemer"
    set password ""
    set parentDB "transcriptomes"
    
    set arg [lindex $argv 0]
    set q 0
    set stop 0
    if {$arg eq ""} {
        openGUI
    }
    while {$stop ne 1} {
        set stop 1
        switch $arg {
            _h {set stop 0; set host [lindex $argv [expr $q + 1]]; set q [expr $q + 2]; set arg [lindex $argv $q]}
            _p {set stop 0; set port [lindex $argv [expr $q + 1]]; set q [expr $q + 2]; set arg [lindex $argv $q]}
            _u {set stop 0; set user [lindex $argv [expr $q + 1]]; set q [expr $q + 2]; set arg [lindex $argv $q]}
            _pwd {set stop 0; set password [lindex $argv [expr $q + 1]]; set q [expr $q + 2]; set arg [lindex $argv $q]}
            _parentDB {set stop 0; set parentDB [lindex $argv [expr $q + 1]]; set q [expr $q + 2]; set arg [lindex $argv $q]}
            _cDB {createDB [lindex $argv [expr $q + 1]]}
            _dDB {deleteDB [lindex $argv [expr $q + 1]]; set q [expr $q + 2]; set arg [lindex $argv $q]}
            _addNuc {addNuc [lindex $argv [expr $q + 1]] [lindex $argv [expr $q + 2]]}
            _addProt {addProt [lindex $argv [expr $q + 1]] [lindex $argv [expr $q + 2]]}
            _addReads {addReads [lindex $argv [expr $q + 1]] [lindex $argv [expr $q + 2]] [lindex $argv [expr $q + 3]]}
            _seqInfo {seqInfo [lindex $argv [expr $q + 1]] [lindex $argv [expr $q + 2]]}
            _goStat {goStat [lindex $argv [expr $q + 1]]}
            "-h" {set stop 0; set host [lindex $argv [expr $q + 1]]; set q [expr $q + 2]; set arg [lindex $argv $q]; puts "hostname: $host"}
            "-p" {set stop 0; set port [lindex $argv [expr $q + 1]]; set q [expr $q + 2]; set arg [lindex $argv $q]; puts "port: $port"}
            "-u" {set stop 0; set user [lindex $argv [expr $q + 1]]; set q [expr $q + 2]; set arg [lindex $argv $q]; puts "username: $user"}
            "-pwd" {set stop 0; set password [lindex $argv [expr $q + 1]]; set q [expr $q + 2]; set arg [lindex $argv $q]; puts "password: $password"}
            "-parentDB" {set stop 0; set parentDB [lindex $argv [expr $q + 1]]; set q [expr $q + 2]; set arg [lindex $argv $q]; puts "parentDB: $parentDB"}
            "-cDB" {createDB [lindex $argv [expr $q + 1]]}
            "-cRefDB" {createRefDB}
            "-backupRefDB" {backupRefDB [lindex $argv [expr $q + 1]]; set q [expr $q + 2]; set arg [lindex $argv $q]}
            "-loadRefDB" {loadRefDB [lindex $argv [expr $q + 1]]; set q [expr $q + 2]; set arg [lindex $argv $q]}
            "-dDB" {deleteDB [lindex $argv [expr $q + 1]]; set q [expr $q + 2]; set arg [lindex $argv $q]}
            "-addNucF" {addNuc [lindex $argv [expr $q + 1]] [lindex $argv [expr $q + 2]]}
            "-addProtF" {addProt [lindex $argv [expr $q + 1]] [lindex $argv [expr $q + 2]]}
            "-addReadF" {addReads [lindex $argv [expr $q + 1]] [lindex $argv [expr $q + 2]] [lindex $argv [expr $q + 3]]}
            "-seqInfo" {seqInfo [lindex $argv [expr $q + 1]] [lindex $argv [expr $q + 2]]}
            "-aBRef" {addBlastRef [lindex $argv [expr $q + 1]] [lindex $argv [expr $q + 2]] [lindex $argv [expr $q + 3]]}
            "-goStat" {goStat [lindex $argv [expr $q + 1]]}
            "-cFunc" {createFunctions}
            "-grantToFunc" {grantToFunc [lindex $argv [expr $q + 1]] [lindex $argv [expr $q + 2]]}
            "-revokeOnFunc" {revokeOnFunc [lindex $argv [expr $q + 1]]}
            "-prot2ipr" {prot2ipr [lindex $argv [expr $q + 1]]}
            "-ipr2go" {ipr2go [lindex $argv [expr $q + 1]]}
            "-ipr2domain" {ipr2domain [lindex $argv [expr $q + 1]]}
            "-blast2interpro" {blast2interpro [lindex $argv [expr $q + 1]] [lindex $argv [expr $q + 2]]}
            "-domain2interpro" {domain2interpro [lindex $argv [expr $q + 1]]}
            "-prot2kegg" {prot2kegg [lindex $argv [expr $q + 1]] [lindex $argv [expr $q + 2]]}
            "-prot2keggJGI" {prot2keggJGI [lindex $argv [expr $q + 1]]}
            "-KEGGMaps" {getKEGGMaps [lindex $argv [expr $q + 1]] [lindex $argv [expr $q + 2]]}
            "-KEGGRef" {keggRef [lindex $argv [expr $q + 1]]}
            "-SMARTRef" {smartRef [lindex $argv [expr $q + 1]]}
            "-GORef" {goRef [lindex $argv [expr $q + 1]]}
            "-GOTree" {goTree_build}
            "-help" {help 1}
            "--help" {help 1}
            "--" {help 1}
            "-newUser" {newUser [lindex $argv [expr $q + 1]] [lindex $argv [expr $q + 2]]}
            "-delUser" {delUser [lindex $argv [expr $q + 1]]}
            "-grantToDB" {grantToDB [lindex $argv [expr $q + 1]] [lindex $argv [expr $q + 2]] [lindex $argv [expr $q + 3]]}
            "-revokeOnDB" {revokeOnDB [lindex $argv [expr $q + 1]] [lindex $argv [expr $q + 2]]}
            "-addACE" {addACE [lindex $argv [expr $q + 1]] [lindex $argv [expr $q + 2]] [lindex $argv [expr $q + 3]]}
            "-gui" {openGUI}
            "-rep" {rep}
        }
    }   
}

proc rep {} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    pg_select $conn "SELECT id, product FROM refdb.nt WHERE product LIKE '%/a%'" data {
        set product "{[regsub -all {/a} $data(product) "} {"]}"
        lappend res "$data(id) {[lindex $product 0]}"
    }
    foreach rep $res {
        pg_exec $conn "UPDATE refdb.nt SET product='[lindex $rep 1]' WHERE id = '[lindex $rep 0]';"
    } 
}

proc help {mode} {
    puts "USAGE\n \
            Tranalyser_DB_manager.tcl \[-h\] \[-p\] \[-u\] \[-pwd\] \[-parentDB\] \[-gui\]\n  \
            \[-cRefDB\] \[-cDB\] \[-dDB\] \[-cFunc\] \[-addNucF\] \[-addProtF\]\n  \
            \[-addReadF\] \[-aBRef\]\n  \
            \[-SMARTRef\] \[-seqInfo\] \[-goStat\]\n  \
            \[-ipr2go\] \[-prot2ipr\] \[-blast2interpro\] \[-grantToDB\] \[-grantToFunc\] \[-help\]"
    
    if {$mode} {
        puts "\n ***Database connection\n\
                -h <host>\n    Sets the host IP-adress. Default = localhost\n\
                -p <port>\n    Sets the port number. Default = 5432\n\
                -u <user>\n    Sets the username. Default = postgres\n\
                -pwd <password>\n    Sets the password. Default = postgres\n\n\
                -parentDB <parentDB>\n    Sets the name of the parent database. Default = genomes\n\n\
                ***Create options\n\
                -cDB <database_name>\n    Creates a new database.\n\
                -cFunc\n    Creates the functions.\n\
                -cRefDB\n    Creates the reference database.\n\n\
                ***Delete options\n\
                -dDB <database_name>\n    Deletes a database.\n\
                ***Add options\n\
                -backupRefDB <output_file>\n    Writes reference schema to file.\n\
                -loadRefDB <input_file>\n    Creates reference schema from file.\n\
                -aBRef <blast_database_identifier> <input_file> <mode>\n    Creates a table with the name of the 'blast_database_identifier'\n    \Mode can be: 'fast', 'slow' or 'blast'.'\n   \
                and adds the reference information from the input file to it.\n\
                -addACE <database_name> <ACE_file> <contig_name>\n    Adds sequences from ACE file as contigs/reads to database.\n    The given 'contig_name' will be added to the contig identifier in the ACE file.\n\
                -addNucF <database_name> <nucleotide_fasta_file>\n    Adds sequences from input file as contigs to database.\n\
                -addProtF <database_name> <protein_fasta_file>\n    Adds sequences from input file as proteins associated with contigs to database.\n\
                -addReadF <database_name> <run_id> <nucleotide_fasta_file>\n    Adds sequences from input file as reads to database.\n\
                -GORef <GO_reference_file>\n    Adds GO references from input file to the reference database.\n    The file can be found here:\n      http://www.geneontology.org/ontology/obo_format_1_2/gene_ontology.1_2.obo\n\
                -GOTree\n    Builds GO Tree from GO references.\n\
                -KEGGMaps <map_title> <map_list>\n    Adds KEGG-Map references from input files to the reference database.\n    \
                The files can be found here:\n      map_list -> ftp://ftp.genome.jp/pub/kegg/pathway/map/map.list\n      map_title -> ftp://ftp.genome.jp/pub/kegg/pathway/map_title.tab\n\
                -KEGGRef <KEGG_reference_file>\n    Adds KEGG references from input file to the reference database.\n    The file can be found here:\n      ftp://ftp.genome.jp/pub/kegg/genes/ko\n\
                -SMARTRef <smart_reference_file>\n    Adds SMART references from input file to the reference database.\n    The file can be found here:\n      http://smart.embl-heidelberg.de/smart/descriptions.pl\n\
                -ipr2go <interPro2GO_file>\n    Adds InperPro2Go references.\n    The file can be found here:\n      http://www.geneontology.org/external2go/interpro2go, ftp://ftp.ebi.ac.uk/pub/databases/interpro/interpro2go\n\
                -prot2ipr <protID2InterPro_file>\n    Adds ProteinID2InterPro references.\n    The file can be found here:\n      ftp://ftp.ebi.ac.uk/pub/databases/interpro/protein2ipr.dat.gz\n\
                -prot2kegg <genes_ko> <genes_prot>\n    Adds ProteinID2KEGG references.\n    The files can be found here:\n      genes_ko   -> ftp://ftp.genome.jp/pub/kegg/linkdb/genes/genes_ko.list\n     \
                genes_prot -> ftp://ftp.genome.jp/pub/kegg/linkdb/genes/genes_uniprot.list and/or\n                 -> ftp://ftp.genome.jp/pub/kegg/linkdb/genes/genes_ncbi-gi.list\n\n\
                ***Database operations\n\
                -newUser <user> <optional: cDB>\n    Creates new user. If \"cDB\" is used, the user will be able, to create new databases.\n\
                -delUser <user>\n    Deletes the user.\n\
                -blast2interpro <database_name> <blast_database_identifier>\n    InterPro/GO associated blast-hit search. Adds found InterPro/GO hits to database.\n\
                -goStat <database_name>\n    Updates the GO statistics (GO-tree).\n\
                -grantToDB <database_name> <user>\n    Grants database access to user.\n\
                -grantToFunc <user> <optional: all>\n    Grants database functions access to user.\n    Only if \"all\" is used, the user will be able to delete databases and database entries.\n\
                -revokeOnDB <database_name> <user>\n    Revokes database access from user.\n\
                -revokeOnFunc <user>\n    Revokes database functions access from user.\n\
                ***Graphical interface\n\
                -gui\n    Opens the graphical interface.\n\
                \
        "
    }
}

proc openGUI {} {
    package require BWidget
    global host
    global port
    global user
    global password
    global parentDB
    global saveFolder
    global gui_parentDBCheck
    global gui_functionsCheck
    global gui_goRefCheck
    global gui_goTreeCheck
    global gui_gene3dRefCheck
    global gui_smartRefCheck
    global gui_ipr2goCheck
    global gui_prot2iprCheck
    global gui_prot2keggCheck
    global gui_keggMapsCheck
    global gui_keggRefCheck
    global gui_aBRefCheck
    global gui_newUserCheck
    global gui_newUsercDBCheck
    global gui_grantToDB_rb
    global gui_delUserCheck
    global gui_grantToFuncCheck
    global gui_grantToFunc_rb
    global gui_revokeOnFuncCheck
    global gui_grantToDBCheck
    global gui_revokeOnDBCheck
    global gui_cDBCheck
    global gui_dDBCheck
    global gui_addACECheck
    global gui_addNucCheck
    global gui_addProtCheck
    global gui_addReadCheck
    global gui_blast2interproCheck
    
    global gui_goRef
    global gui_gene3dRef
    global gui_smartRef
    global gui_ipr2go
    global gui_prot2ipr
    global gui_prot2keggKO
    global gui_prot2keggProt
    global gui_keggMapsTitle
    global gui_keggMapsList
    global gui_keggRef
    global gui_aBRef
    global gui_aBRefID
    global gui_newUser
    global gui_delUser
    global gui_grantToFunc
    global gui_revokeOnFunc
    global gui_grantToDBu
    global gui_grantToDBdb
    global gui_revokeOnDBu
    global gui_revokeOnDBdb
    global gui_db
    global gui_cDB
    global gui_dDB
    global gui_addACE
    global gui_addNuc
    global gui_addProt
    global gui_addRead
    global gui_addReadID
    global gui_blast2interpro
    
    wm title . "Tranalyser: Database Manager"
    wm minsize . 550 400
    
    variable host
    variable port
    variable user
    variable password
    variable parentDB
    variable gui_goRef
    variable gui_gene3dRef
    variable gui_smartRef
    variable gui_ipr2go
    variable gui_prot2ipr
    variable gui_prot2keggKO
    variable gui_prot2keggProt
    variable gui_keggMapsTitle
    variable gui_keggMapsList
    variable gui_keggRef
    variable gui_aBRef
    variable gui_aBRefID
    variable gui_newUser
    variable gui_delUser
    variable gui_grantToFunc
    variable gui_revokeOnFunc
    variable gui_grantToDBu
    variable gui_grantToDBdb
    variable gui_revokeOnDBu
    variable gui_revokeOnDBdb
    variable gui_db
    variable gui_cDB
    variable gui_dDB
    variable gui_addACE
    variable gui_addNuc
    variable gui_addProt
    variable gui_addRead
    variable gui_addReadID
    variable gui_blast2interpro
    
    set saveFolder [pwd]

    #Notebook
    frame .notebook1 -bd 2 -relief groove
    set notebook [NoteBook .notebook1.nb]
    # connection
    set frame [$notebook insert end conn -text "Database connection"]

    frame $frame.connection
    label $frame.connection.l -text "\n\n"
    frame $frame.connection.host
    label $frame.connection.host.l -text "Host:            "
    entry $frame.connection.host.ent -width 12 -background white -textvariable host
    frame $frame.connection.port
    label $frame.connection.port.l -text "Port:             "
    entry $frame.connection.port.ent -width 6 -background white -textvariable port
    frame $frame.connection.user  
    label $frame.connection.user.l -text "User:            "
    entry $frame.connection.user.ent -width 12 -background white -textvariable user
    frame $frame.connection.password
    label $frame.connection.password.l -text "Password:    "
    entry $frame.connection.password.ent -width 12 -background white -textvariable password
    frame $frame.connection.parentDB
    label $frame.connection.parentDB.l -text "ParentDB:    "
    entry $frame.connection.parentDB.ent -width 12 -background white -textvariable parentDB
    
    #pack connection
    pack $frame.connection.host.l -side left; pack $frame.connection.host.ent -side right
    pack $frame.connection.port.l -side left; pack $frame.connection.port.ent -side right
    pack $frame.connection.user.l -side left; pack $frame.connection.user.ent -side right
    pack $frame.connection.password.l -side left -fill both; pack $frame.connection.password.ent -side right -fill both
    pack $frame.connection.parentDB.l -side left -fill both; pack $frame.connection.parentDB.ent -side right -fill both
    pack $frame.connection.l $frame.connection.host $frame.connection.port $frame.connection.user $frame.connection.password $frame.connection.parentDB -side top -anchor w
    pack $frame.connection -side top -fill both
    
    #1 Creating Reference Database
    set frame [$notebook insert end ref -text "Reference database"]
    frame $frame.reference
    label $frame.reference.l -text "\n"
    frame $frame.reference.cRefDB -relief groove -bd 2
    frame $frame.reference.cRefDB.cb
    checkbutton $frame.reference.cRefDB.cb.cb -text "1. Create parent database" -variable gui_parentDBCheck
    frame $frame.reference.cFunc
    checkbutton $frame.reference.cFunc.cb -text "2. Create functions" -variable gui_functionsCheck
    label $frame.reference.l2 -text ""
    frame $frame.reference.go -relief groove -bd 2
    frame $frame.reference.go.goRef
    checkbutton $frame.reference.go.goRef.cb -text "3. Add GO references" -variable gui_goRefCheck
    entry $frame.reference.go.goRef.ent -width 12 -background white -textvariable gui_goRef
    button $frame.reference.go.goRef.browse -text "Browse" -command "browse goRef"
    label $frame.reference.go.l -text "      Source :\thttp://www.geneontology.org/ontology/obo_format_1_2/gene_ontology.1_2.obo\n" -anchor w
    frame $frame.reference.go.goTree
    checkbutton $frame.reference.go.goTree.cb -text "4. Build GO-tree" -variable gui_goTreeCheck
    frame $frame.reference.gene3d
    frame $frame.reference.gene3d.gene3dRef
    checkbutton $frame.reference.gene3d.gene3dRef.cb -text "5. Add Gene3d references" -variable gui_gene3dRefCheck
    entry $frame.reference.gene3d.gene3dRef.ent -width 12 -background white -textvariable gui_gene3dRef
    button $frame.reference.gene3d.gene3dRef.browse -text "Browse" -command "browse gene3dRef"
    label $frame.reference.gene3d.l -text "      Source :\thttp://release.cathdb.info/v3.4.0/CathNames\n" -anchor w
    frame $frame.reference.smart
    frame $frame.reference.smart.smartRef
    checkbutton $frame.reference.smart.smartRef.cb -text "6. Add SMART references" -variable gui_smartRefCheck
    entry $frame.reference.smart.smartRef.ent -width 12 -background white -textvariable gui_smartRef
    button $frame.reference.smart.smartRef.browse -text "Browse" -command "browse smartRef"
    label $frame.reference.smart.l -text "      Source :\thttp://smart.embl-heidelberg.de/smart/descriptions.pl\n" -anchor w
    frame $frame.reference.kegg -relief groove -bd 2
    frame $frame.reference.kegg.keggRef
    checkbutton $frame.reference.kegg.keggRef.cb -text "7. Add KEGG references" -variable gui_keggRefCheck
    entry $frame.reference.kegg.keggRef.ent -width 12 -background white -textvariable gui_keggRef
    button $frame.reference.kegg.keggRef.browse -text "Browse" -command "browse keggRef"
    label $frame.reference.kegg.l -text "      Source :\tftp://ftp.genome.jp/pub/kegg/genes/ko\n" -anchor w
    frame $frame.reference.kegg.keggMaps
    frame $frame.reference.kegg.keggMaps2
    checkbutton $frame.reference.kegg.keggMaps.cb -text "8. Add KEGG Map references" -variable gui_keggMapsCheck
    label $frame.reference.kegg.keggMaps.l -text "map_title : "
    entry $frame.reference.kegg.keggMaps.ent -width 12 -background white -textvariable gui_keggMapsTitle
    button $frame.reference.kegg.keggMaps.browse -text "Browse" -command "browse keggMaps_title"
    label $frame.reference.kegg.l1 -text "      Source :\tftp://ftp.genome.jp/pub/kegg/pathway/map_title.tab" -anchor w
    label $frame.reference.kegg.keggMaps2.l -text "map_list   : "
    entry $frame.reference.kegg.keggMaps2.ent -width 12 -background white -textvariable gui_keggMapsList
    button $frame.reference.kegg.keggMaps2.browse -text "Browse" -command "browse keggMaps_list"
    label $frame.reference.kegg.l2 -text "      Source :\tftp://ftp.genome.jp/pub/kegg/pathway/map/map.list" -anchor w
    frame $frame.reference.ipr
    frame $frame.reference.ipr.ipr2go
    checkbutton $frame.reference.ipr.ipr2go.cb -text "9. Add InterPro2GO references" -variable gui_ipr2goCheck
    entry $frame.reference.ipr.ipr2go.ent -width 12 -background white -textvariable gui_ipr2go
    button $frame.reference.ipr.ipr2go.browse -text "Browse" -command "browse ipr2go"
    label $frame.reference.ipr.l -text "      Source :\thttp://www.geneontology.org/external2go/interpro2go,\n\                                ftp://ftp.ebi.ac.uk/pub/databases/interpro/interpro2go\n" -anchor w
    frame $frame.reference.prot -relief groove -bd 2
    frame $frame.reference.prot.prot2ipr
    checkbutton $frame.reference.prot.prot2ipr.cb -text "10. Add Protein2InterPro references" -variable gui_prot2iprCheck
    entry $frame.reference.prot.prot2ipr.ent -width 12 -background white -textvariable gui_prot2ipr
    button $frame.reference.prot.prot2ipr.browse -text "Browse" -command "browse prot2ipr"
    label $frame.reference.prot.l1 -text "      Source :\tftp://ftp.ebi.ac.uk/pub/databases/interpro/protein2ipr.dat.gz\n" -anchor w
    frame $frame.reference.prot.prot2kegg
    frame $frame.reference.prot.prot2kegg2
    checkbutton $frame.reference.prot.prot2kegg.cb -text "11. Add Protein2KEGG references" -variable gui_prot2keggCheck
    label $frame.reference.prot.prot2kegg.l -text "genes_ko : "
    entry $frame.reference.prot.prot2kegg.ent -width 12 -background white -textvariable gui_prot2keggKO
    button $frame.reference.prot.prot2kegg.browse -text "Browse" -command "browse prot2kegg_ko"
    label $frame.reference.prot.l2 -text "      Source :\tgenes_ko   -> ftp://ftp.genome.jp/pub/kegg/linkdb/genes/genes_ko.list" -anchor w
    label $frame.reference.prot.prot2kegg2.l -text "genes_prot   : "
    entry $frame.reference.prot.prot2kegg2.ent -width 12 -background white -textvariable gui_prot2keggProt
    button $frame.reference.prot.prot2kegg2.browse -text "Browse" -command "browse prot2kegg_prot"
    label $frame.reference.prot.l3 -text "      Source :\tgenes_prot -> ftp://ftp.genome.jp/pub/kegg/linkdb/genes/genes_uniprot.list \n                                 and/or      -> ftp://ftp.genome.jp/pub/kegg/linkdb/genes/genes_ncbi-gi.list" -anchor w 
    frame $frame.reference.blastRef
    frame $frame.reference.blastRef.aBRef
    checkbutton $frame.reference.blastRef.aBRef.cb -text "12. Add blast references; database identifier:" -variable gui_aBRefCheck
    entry $frame.reference.blastRef.aBRef.id -width 12 -background white -textvariable gui_aBRefID
    label $frame.reference.blastRef.aBRef.l -text "  file:"
    entry $frame.reference.blastRef.aBRef.ent -width 12 -background white -textvariable gui_aBRef
    button $frame.reference.blastRef.aBRef.browse -text "Browse" -command "browse aBRef"
    label $frame.reference.blastRef.l -text "      Source :\tftp://ftp.ebi.ac.uk/pub/databases/uniprot/knowlegdebase/uniprot_sprot.dat.gz\n      The file has to be parsed. The insert file should be tab-delimited, with the following columns:\n               <id1>\t<id2>\t<organism>\t<description>\t<product>" -anchor w
    
    #pack reference
    pack $frame.reference.cRefDB.cb.cb -side left -fill both;
    pack $frame.reference.cRefDB.cb -side top -fill both -anchor w
    pack $frame.reference.cFunc.cb -side left -fill both
    pack $frame.reference.go.goRef.cb -side left -fill both; pack $frame.reference.go.goRef.browse $frame.reference.go.goRef.ent -side right -fill both
    pack $frame.reference.go.goTree.cb -side left -fill both
    pack $frame.reference.go.goRef $frame.reference.go.l $frame.reference.go.goTree -side top -fill both -anchor w
    pack $frame.reference.gene3d.gene3dRef.cb -side left -fill both; pack $frame.reference.gene3d.gene3dRef.browse $frame.reference.gene3d.gene3dRef.ent -side right -fill both
    pack $frame.reference.gene3d.gene3dRef $frame.reference.gene3d.l -side top -fill both -anchor w
    pack $frame.reference.smart.smartRef.cb -side left -fill both; pack $frame.reference.smart.smartRef.browse $frame.reference.smart.smartRef.ent -side right -fill both
    pack $frame.reference.smart.smartRef $frame.reference.smart.l -side top -fill both -anchor w
    pack $frame.reference.kegg.keggRef.cb -side left -fill both; pack $frame.reference.kegg.keggRef.browse $frame.reference.kegg.keggRef.ent -side right -fill both
    pack $frame.reference.kegg.keggMaps.cb -side left -fill both; pack $frame.reference.kegg.keggMaps.browse $frame.reference.kegg.keggMaps.ent $frame.reference.kegg.keggMaps.l -side right -fill both
    pack $frame.reference.kegg.keggMaps2.browse $frame.reference.kegg.keggMaps2.ent $frame.reference.kegg.keggMaps2.l -side right -fill both
    pack $frame.reference.kegg.keggRef $frame.reference.kegg.l $frame.reference.kegg.keggMaps $frame.reference.kegg.l1 $frame.reference.kegg.keggMaps2 $frame.reference.kegg.l2 -side top -fill both -anchor w
    pack $frame.reference.ipr.ipr2go.cb -side left -fill both; pack $frame.reference.ipr.ipr2go.browse $frame.reference.ipr.ipr2go.ent -side right -fill both
    pack $frame.reference.ipr.ipr2go $frame.reference.ipr.l -side top -fill both -anchor w
    pack $frame.reference.prot.prot2ipr.cb -side left -fill both; pack $frame.reference.prot.prot2ipr.browse $frame.reference.prot.prot2ipr.ent -side right -fill both
    pack $frame.reference.prot.prot2kegg.cb -side left -fill both; pack $frame.reference.prot.prot2kegg.browse $frame.reference.prot.prot2kegg.ent $frame.reference.prot.prot2kegg.l -side right -fill both
    pack $frame.reference.prot.prot2kegg2.browse $frame.reference.prot.prot2kegg2.ent $frame.reference.prot.prot2kegg2.l -side right -fill both
    pack $frame.reference.prot.prot2ipr $frame.reference.prot.l1 $frame.reference.prot.prot2kegg $frame.reference.prot.l2 $frame.reference.prot.prot2kegg2 $frame.reference.prot.l3 -side top -fill both -anchor w
    pack $frame.reference.blastRef.aBRef.cb $frame.reference.blastRef.aBRef.id -side left -fill both; pack $frame.reference.blastRef.aBRef.browse $frame.reference.blastRef.aBRef.ent $frame.reference.blastRef.aBRef.l -side right -fill both
    pack $frame.reference.blastRef.aBRef $frame.reference.blastRef.l -side top -fill both -anchor w
    pack $frame.reference.cRefDB $frame.reference.cFunc $frame.reference.l2 $frame.reference.go $frame.reference.gene3d $frame.reference.smart $frame.reference.kegg $frame.reference.ipr $frame.reference.prot $frame.reference.blastRef $frame.reference.l -side top -fill both
    pack $frame.reference -side top -fill both  -anchor w
    
    #2 User Management
    set frame [$notebook insert end user -text "User management"]
    frame $frame.user
    frame $frame.user.user
    label $frame.user.user.l -text "User name: "
    entry $frame.user.user.ent -width 12 -background white -textvariable gui_user
    label $frame.user.l -text "\n"
    frame $frame.user.newUser
    checkbutton $frame.user.newUser.cb -text "Add new user" -variable gui_newUserCheck
    checkbutton $frame.user.newUser.cDB -text "cDB" -variable gui_newUsercDBCheck
    frame $frame.user.grantToFunc
    checkbutton $frame.user.grantToFunc.cb -text "Grant function rights to user" -variable gui_grantToFuncCheck
    radiobutton $frame.user.grantToFunc.none -text "access" -variable gui_grantToFunc_rb -value "0"
    radiobutton $frame.user.grantToFunc.add -text "create" -variable gui_grantToFunc_rb -value "add"
    radiobutton $frame.user.grantToFunc.all -text "all" -variable gui_grantToFunc_rb -value "all"
    $frame.user.grantToFunc.none select
    frame $frame.user.grantToDB
    checkbutton $frame.user.grantToDB.cb -text "Grant access rights to user on database" -variable gui_grantToDBCheck
    radiobutton $frame.user.grantToDB.all -text "all" -variable gui_grantToDB_rb -value "all"
    radiobutton $frame.user.grantToDB.write -text "write" -variable gui_grantToDB_rb -value "write"
    radiobutton $frame.user.grantToDB.view -text "view" -variable gui_grantToDB_rb -value "view"
    $frame.user.grantToDB.view select
    entry $frame.user.grantToDB.entdb -width 22 -background white -textvariable gui_grantToDBdb
    frame $frame.user.delUser
    checkbutton $frame.user.delUser.cb -text "Delete user" -variable gui_delUserCheck
    frame $frame.user.revokeOnFunc
    checkbutton $frame.user.revokeOnFunc.cb -text "Revoke function rights of user" -variable gui_revokeOnFuncCheck
    frame $frame.user.revokeOnDB
    checkbutton $frame.user.revokeOnDB.cb -text "Revoke access right of user on database" -variable gui_revokeOnDBCheck
    entry $frame.user.revokeOnDB.entdb -width 22 -background white -textvariable gui_revokeOnDBdb
    
    #pack user management
    pack $frame.user.user.l $frame.user.user.ent -side left -fill both
    pack $frame.user.newUser.cb $frame.user.newUser.cDB -side left -fill both
    pack $frame.user.grantToFunc.cb -side left -fill both; pack  $frame.user.grantToFunc.none $frame.user.grantToFunc.add $frame.user.grantToFunc.all -side right -fill both
    pack $frame.user.grantToDB.cb $frame.user.grantToDB.all $frame.user.grantToDB.write $frame.user.grantToDB.view -side left -fill both; pack $frame.user.grantToDB.entdb -side right -fill both
    pack $frame.user.delUser.cb -side left -fill both
    pack $frame.user.revokeOnFunc.cb -side left -fill both
    pack $frame.user.revokeOnDB.cb -side left -fill both; pack $frame.user.revokeOnDB.entdb -side right -fill both
    pack $frame.user.user $frame.user.l $frame.user.newUser $frame.user.grantToFunc $frame.user.grantToDB $frame.user.delUser $frame.user.revokeOnFunc $frame.user.revokeOnDB -side top -fill both
    pack $frame.user -side top -fill both
    
    #3 Database options
    set frame [$notebook insert end db -text "Database options"]
    frame $frame.db
    label $frame.db.l -text "\n"
    frame $frame.db.db
    label $frame.db.db.l -text "Database name:"
    entry $frame.db.db.ent -width 42 -background white -textvariable gui_db
    frame $frame.db.cDB
    checkbutton $frame.db.cDB.cb -text "Create database" -variable gui_cDBCheck
    frame $frame.db.dDB
    checkbutton $frame.db.dDB.cb -text "Delete database" -variable gui_dDBCheck
    frame $frame.db.addACE
    checkbutton $frame.db.addACE.cb -text "Add ACE file" -variable gui_addACECheck
    entry $frame.db.addACE.ent -width 12 -background white -textvariable gui_addACE
    button $frame.db.addACE.browse -text "Browse" -command "browse addACE"
    frame $frame.db.addNuc
    checkbutton $frame.db.addNuc.cb -text "Add nucleotide sequences" -variable gui_addNucCheck
    entry $frame.db.addNuc.ent -width 12 -background white -textvariable gui_addNuc
    button $frame.db.addNuc.browse -text "Browse" -command "browse addNuc"
    frame $frame.db.addProt
    checkbutton $frame.db.addProt.cb -text "Add protein sequences" -variable gui_addProtCheck
    entry $frame.db.addProt.ent -width 12 -background white -textvariable gui_addProt
    button $frame.db.addProt.browse -text "Browse" -command "browse addProt"
    frame $frame.db.addRead
    checkbutton $frame.db.addRead.cb -text "Add read sequences; Run ID:            " -variable gui_addReadCheck
    entry $frame.db.addRead.id -width 12 -background white -textvariable gui_addReadID
    entry $frame.db.addRead.ent -width 12 -background white -textvariable gui_addRead
    button $frame.db.addRead.browse -text "Browse" -command "browse addRead"
    frame $frame.db.blast2interpro
    checkbutton $frame.db.blast2interpro.cb -text "Blast2InterPro; blast-database ID:    " -variable gui_blast2interproCheck
    entry $frame.db.blast2interpro.ent -width 12 -background white -textvariable gui_blast2interpro
    
    #pack database options
    pack $frame.db.db.l -side left -fill both; pack $frame.db.db.ent -side right -fill both
    pack $frame.db.cDB.cb -side left -fill both
    pack $frame.db.dDB.cb -side left -fill both
    pack $frame.db.addACE.cb -side left -fill both; pack $frame.db.addACE.browse $frame.db.addACE.ent -side right -fill both
    pack $frame.db.addNuc.cb -side left -fill both; pack $frame.db.addNuc.browse $frame.db.addNuc.ent -side right -fill both
    pack $frame.db.addProt.cb -side left -fill both; pack $frame.db.addProt.browse $frame.db.addProt.ent -side right -fill both
    pack $frame.db.addRead.cb $frame.db.addRead.id -side left -fill both; pack $frame.db.addRead.browse $frame.db.addRead.ent -side right -fill both
    pack $frame.db.blast2interpro.cb $frame.db.blast2interpro.ent -side left -fill both
    pack $frame.db.db $frame.db.l $frame.db.cDB $frame.db.dDB $frame.db.addACE $frame.db.addNuc $frame.db.addProt $frame.db.addRead $frame.db.blast2interpro -side top -fill both
    pack $frame.db -side top -fill both
       
    #packing Notebook
    $notebook raise [$notebook page 0]
    
    pack $notebook -side top -fill both -expand true
    pack .notebook1 -side top -fill both -expand true
    
    #buttons
    frame .buts -relief groove -bd 2
    button .buts.run -text "Run" -command "runGUI"
    
    #buttons
    pack .buts.run -side left -expand 1 -anchor w
    pack .buts -side top -fill both
}

proc runGUI {} {
    global host
    global port
    global user
    global password
    global parentDB
    global gui_parentDBCheck
    global gui_functionsCheck
    global gui_goRefCheck
    global gui_goTreeCheck
    global gui_gene3dRefCheck
    global gui_smartRefCheck
    global gui_ipr2goCheck
    global gui_prot2iprCheck
    global gui_prot2keggCheck
    global gui_keggRefCheck
    global gui_keggMapsCheck
    global gui_aBRefCheck
    global gui_newUserCheck
    global gui_newUsercDBCheck
    global gui_grantToDB_rb
    global gui_delUserCheck
    global gui_grantToFuncCheck
    global gui_grantToFunc_rb
    global gui_revokeOnFuncCheck
    global gui_grantToDBCheck
    global gui_revokeOnDBCheck
    global gui_cDBCheck
    global gui_dDBCheck
    global gui_addACECheck
    global gui_addNucCheck
    global gui_addProtCheck
    global gui_addReadCheck
    global gui_blast2interproCheck
    
    global gui_goRef
    global gui_gene3dRefCheck
    global gui_smartRef
    global gui_ipr2go
    global gui_prot2ipr
    global gui_prot2kegg
    global gui_keggMapsTitle
    global gui_keggMapsList
    global gui_aBRef
    global gui_aBRefID
    global gui_newUser
    global gui_delUser
    global gui_grantToFunc
    global gui_revokeOnFunc
    global gui_grantToDBu
    global gui_grantToDBdb
    global gui_revokeOnDBu
    global gui_revokeOnDBdb
    global gui_db
    global gui_cDB
    global gui_dDB
    global gui_addACE
    global gui_addNuc
    global gui_addProt
    global gui_addRead
    global gui_addReadID
    global gui_blast2interpro
    
    set host [.notebook1.nb.fconn.connection.host.ent get]
    set port [.notebook1.nb.fconn.connection.port.ent get]
    set user [.notebook1.nb.fconn.connection.user.ent get]
    set password [.notebook1.nb.fconn.connection.password.ent get]
    set parentDB [.notebook1.nb.fconn.connection.parentDB.ent get]
    
    if {$host ne "" && $port ne "" && $user ne "" && $password ne "" && $parentDB ne ""} {
        if {[.notebook1.nb raise] eq "conn"} {
        } elseif {[.notebook1.nb raise] eq "ref"} {
            if {$gui_parentDBCheck} {
                createRefDB
                set gui_parentDBCheck 0
            }
            if {$gui_functionsCheck} {
                createFunctions
                set gui_functionsCheck 0
            }
            if {$gui_goRefCheck} {
                if {[.notebook1.nb.fref.reference.go.goRef.ent get] ne ""} {
                    goRef [.notebook1.nb.fref.reference.go.goRef.ent get]
                    set gui_goRefCheck 0
                } else {
                    popupGUI goRef
                }
            }
            if {$gui_goTreeCheck} {
                goTree_build
            }
            if {$gui_gene3dRefCheck} {
                if {[.notebook1.nb.fref.reference.gene3d.gene3dRef.ent get] ne ""} {
                    gene3dRef [.notebook1.nb.fref.reference.gene3d.gene3dRef.ent get]
                    set gui_gene3dRefCheck 0
                } else {
                    popupGUI
                }
            }
            if {$gui_smartRefCheck} {
                if {[.notebook1.nb.fref.reference.smart.smartRef.ent get] ne ""} {
                    smartRef [.notebook1.nb.fref.reference.smart.smartRef.ent get]
                    set gui_smartRefCheck 0
                } else {
                    popupGUI
                }
            }
            if {$gui_keggRefCheck} {
                if {[.notebook1.nb.fref.reference.kegg.keggRef.ent get] ne ""} {
                    keggRef [.notebook1.nb.fref.reference.kegg.keggRef.ent get]
                    set gui_keggRefCheck 0
                } else {
                    popupGUI keggRef
                }
            }
            if {$gui_keggMapsCheck} {
                if {[.notebook1.nb.fref.reference.kegg.keggMaps.ent get] ne ""} {
                    if {[.notebook1.nb.fref.reference.kegg.keggMaps2.ent get] ne ""} {
                        getKEGGMaps [.notebook1.nb.fref.reference.kegg.keggMaps.ent get] [.notebook1.nb.fref.reference.kegg.keggMaps2.ent get]
                        set gui_keggMapsCheck 0
                    } else {
                        popupGUI keggMaps
                    }
                } else {
                    popupGUI keggMaps
                }
            }
            if {$gui_ipr2goCheck} {
                if {[.notebook1.nb.fref.reference.ipr.ipr2go.ent get] ne ""} {
                    ipr2go [.notebook1.nb.fref.reference.ipr.ipr2go.ent get]
                    set gui_ipr2goCheck 0
                } else {
                    popupGUI ipr2go
                }
            }
            if {$gui_prot2iprCheck} {
                if {[.notebook1.nb.fref.reference.prot.prot2ipr.ent get] ne ""} {
                    prot2ipr [.notebook1.nb.fref.reference.prot.prot2ipr.ent get]
                    set gui_prot2iprCheck 0
                } else {
                    popupGUI prot2ipr
                }
            }
            if {$gui_prot2keggCheck} {
                if {[.notebook1.nb.fref.reference.prot.prot2kegg.ent get] ne ""} {
                    if {[.notebook1.nb.fref.reference.prot.prot2kegg.ent get] ne ""} {
                        prot2kegg [.notebook1.nb.fref.reference.prot.prot2kegg.ent get] [.notebook1.nb.fref.reference.prot.prot2kegg2.ent get]
                        set gui_prot2keggCheck 0
                    } else {
                        popupGUI keggMaps
                    }
                } else {
                    popupGUI prot2kegg
                }
            }
            if {$gui_aBRefCheck && [.notebook1.nb.fref.reference.blastRef.aBRef.ent get] ne "" && [.notebook1.nb.fref.reference.blastRef.aBRef.id get] ne ""} {
                addBlastRef [.notebook1.nb.fref.reference.blastRef.aBRef.id get] [.notebook1.nb.fref.reference.blastRef.aBRef.ent get] fast
                set gui_aBRefCheck 0
            }
        } elseif {[.notebook1.nb raise] eq "user"} {
            if {$gui_newUserCheck} {
                if {[.notebook1.nb.fuser.user.user.ent get] ne ""} {
                    if {$gui_newUsercDBCheck} {
                        newUser [.notebook1.nb.fuser.user.user.ent get] cDB
                    } else {
                        newUser [.notebook1.nb.fuser.user.user.ent get] 0
                    }
                    set gui_newUsercDBCheck 0
                } else {
                    popupGUI user
                }
            }
            if {$gui_delUserCheck} {
                if {[.notebook1.nb.fuser.user.user.ent get] ne ""} {
                    delUser [.notebook1.nb.fuser.user.user.ent get]
                } else {
                    popupGUI user
                }
                set gui_delUserCheck 0
            }
            if {$gui_grantToFuncCheck} {
                if {[.notebook1.nb.fuser.user.user.ent get] ne ""} {
                    grantToFunc [.notebook1.nb.fuser.user.user.ent get] $gui_grantToFunc_rb
                } else {
                    popupGUI user
                }
                set gui_grantToFuncCheck 0
            }
            if {$gui_revokeOnFuncCheck} {
                if {[.notebook1.nb.fuser.user.user.ent get] ne ""} {
                    revokeOnFunc [.notebook1.nb.fuser.user.user.ent get]
                } else {
                    popupGUI user
                }
                set gui_revokeOnFuncCheck 0
            }
            if {$gui_grantToDBCheck} {
                if {[.notebook1.nb.fuser.user.user.ent get] ne "" && [.notebook1.nb.fuser.user.grantToDB.entdb get] ne ""} {
                    if {$gui_grantToDB_rb eq "all"} {
                        grantToDB [.notebook1.nb.fuser.user.grantToDB.entdb get] [.notebook1.nb.fuser.user.user.ent get] all
                    } elseif {$gui_grantToDB_rb eq "write"} {
                        grantToDB [.notebook1.nb.fuser.user.grantToDB.entdb get] [.notebook1.nb.fuser.user.user.ent get] write
                    } else {
                        grantToDB [.notebook1.nb.fuser.user.grantToDB.entdb get] [.notebook1.nb.fuser.user.user.ent get] 0
                    }
                } else {
                    popupGUI grantToDB
                }
                set gui_grantToDBCheck 0
            }
            if {$gui_revokeOnDBCheck && [.notebook1.nb.fuser.user.revokeOnDB.entdb get] ne ""} {
                if {[.notebook1.nb.fuser.user.user.ent get] ne "" && [.notebook1.nb.fuser.user.revokeOnDB.entdb get] ne ""} {
                    revokeOnDB [.notebook1.nb.fuser.user.revokeOnDB.entdb get] [.notebook1.nb.fuser.user.user.ent get]
                } else {
                    popupGUI grantToDB
                }
                set gui_revokeOnDBCheck 0
            }
        } elseif {[.notebook1.nb raise] eq "db"} {
            set gui_db [.notebook1.nb.fdb.db.db.ent get]
            if {$gui_cDBCheck} {
                if {$gui_db ne ""} {
                    createDB $gui_db
                } else  {
                    popupGUI db
                }
                set gui_cDBCheck 0
            }
            if {$gui_dDBCheck} {
                if {$gui_db ne ""} {
                    deleteDB $gui_db
                } else  {
                    popupGUI db
                }
                set gui_dDBCheck 0
            }
            if {$gui_addACECheck} {
                if {$gui_db ne ""} {
                    if {[.notebook1.nb.fdb.db.addACE.ent get] ne ""} {
                        addACE $gui_db [.notebook1.nb.fdb.db.addACE.ent get] $gui_db
                    } else {
                        popupGUI addACE
                    }
                } else  {
                    popupGUI db
                }
                set gui_addACECheck 0
            }
            if {$gui_addNucCheck} {
                if {$gui_db ne ""} {
                    if {[.notebook1.nb.fdb.db.addNuc.ent get] ne ""} {
                        addNuc $gui_db [.notebook1.nb.fdb.db.addNuc.ent get]
                    } else {
                        popupGUI addNuc
                    }
                } else  {
                    popupGUI db
                }
                set gui_addNucCheck 0
            }
            if {$gui_addProtCheck} {
                if {$gui_db ne ""} {
                    if {[.notebook1.nb.fdb.db.addProt.ent get] ne ""} {
                        addProt $gui_db [.notebook1.nb.fdb.db.addProt.ent get]
                    } else {
                        popupGUI addProt
                    }
                } else  {
                    popupGUI db
                }
                set gui_addProtCheck 0
            }
            if {$gui_addReadCheck} {
                if {$gui_db ne ""} {
                    if {[.notebook1.nb.fdb.db.addRead.ent get] ne "" && [.notebook1.nb.fdb.db.addRead.id get] ne ""} {
                        addReads $gui_db [.notebook1.nb.fdb.db.addRead.id get] [.notebook1.nb.fdb.db.addRead.ent get]
                    } else {
                        popupGUI addRead
                    }
                } else  {
                    popupGUI db
                }
                set gui_addReadCheck 0
            }
            if {$gui_blast2interproCheck} {
                if {$gui_db ne ""} {
                    if {[.notebook1.nb.fdb.db.blast2interpro.ent get] ne ""} {
                        blast2interpro $gui_db [.notebook1.nb.fdb.db.blast2interpro.ent get]
                    } else {
                        popupGUI blast2interpro
                    }
                } else  {
                    popupGUI db
                }
                set gui_blast2interproCheck 0
            }
        }
    } else  {
        popupGUI conn
    }
}

proc popupGUI {mode} {
    set txt ""
    set title "Error"
    set t .pGUI
    if {$mode eq "goRef"} {
        set txt "No GO reference file."
    } elseif {$mode eq "smartRef"} {
        set txt "No Smart reference file."
    } elseif {$mode eq "db"} {
        set txt "Please enter a  database name."
    } elseif {$mode eq "ipr2go"} {
        set txt "No ipr2go reference file."
    } elseif {$mode eq "prot2ipr"} {
        set txt "No prot2ipr reference file."
    } elseif {$mode eq "prot2kegg"} {
        set txt "No prot2kegg reference file."
    } elseif {$mode eq "user"} {
        set txt "Please enter a user name."
    } elseif {$mode eq "conn"} {
        set txt "Please enter connection settings."
    } elseif {$mode eq "grantToDB"} {
        set txt "Please enter user/database name."
    } elseif {$mode eq "blast2interpro"} {
        set txt "No blast identifier"
    } elseif {$mode eq "addACE"} {
        set txt "No ACE file."
    } elseif {$mode eq "addNuc"} {
        set txt "No nucleotide file."
    } elseif {$mode eq "addProt"} {
        set txt "No protein file."
    } elseif {$mode eq "addRead"} {
        set txt "No run identifier or read file."
    }
    
    catch {
        if {$txt ne ""} {
            toplevel $t
            wm title $t $title
            wm resizable $t 0 0
            wm attributes $t -topmost 1
            
            frame $t.ptitle
            label $t.ptitle.label -height 5 -text $txt
            
            frame $t.buts -bd 2 -relief groove
            button $t.buts.ok -text "OK" -command "destroy $t"
            
            pack $t.ptitle.label -side left -fill both
            pack $t.buts.ok -expand 1 -anchor c
            pack $t.ptitle $t.buts -side top -fill both
        }
    }
}

proc newUser {uName mode} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    
    if {$mode eq "cDB"} {
        pg_exec $conn "CREATE ROLE $uName LOGIN\n\
                ENCRYPTED PASSWORD '$uName' \n\
                NOINHERIT CREATEDB\n\
                VALID UNTIL 'infinity';"
        pg_exec $conn "GRANT ALL ON DATABASE $parentDB TO $uName"
    } else {
        pg_exec $conn "CREATE ROLE $uName LOGIN\n\
                ENCRYPTED PASSWORD '$uName' \n\
                NOINHERIT\n\
                VALID UNTIL 'infinity';"
        pg_exec $conn "GRANT CONNECT, TEMPORARY ON DATABASE $parentDB TO $uName"
    }
    set pkey "${uName}_pkey"
    
    pg_exec $conn "GRANT SELECT, INSERT ON TABLE public.dbs TO $uName;"
    pg_exec $conn "GRANT USAGE ON SCHEMA refdb TO $uName"
    pg_select $conn "SELECT tablename FROM pg_tables WHERE schemaname = 'refdb'" data {
        lappend refs $data(tablename)
    }
    foreach ref $refs {
        pg_exec $conn "GRANT SELECT, INSERT ON TABLE refdb.$ref TO $uName"
    }
    pg_disconnect $conn
}

proc delUser {delUser} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    revokeOnFunc $delUser

    pg_exec $conn "REVOKE ALL ON TABLE public.dbs FROM $delUser;"
    pg_exec $conn "REVOKE ALL ON SCHEMA refdb FROM $delUser;"
    pg_select $conn "SELECT tablename FROM pg_tables WHERE schemaname = 'refdb'" data {
        lappend refs $data(tablename)
    }
    foreach ref $refs {
        pg_exec $conn "REVOKE ALL ON TABLE refdb.$ref FROM $delUser"
    }
    pg_exec $conn "REVOKE ALL ON DATABASE $parentDB FROM $delUser"
    pg_exec $conn "DROP ROLE $delUser;"
    pg_disconnect $conn
    puts "delete user: $delUser"
}

proc addBlastRef {db data mode} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    if {$data eq "createTable"} {
        catch {
            pg_exec $conn "CREATE TABLE refdb.$db (id text NOT NULL, id2 text, organism text, description text, product text, CONSTRAINT ${db}_pkey PRIMARY KEY (id));"
            pg_exec $conn "CREATE INDEX index_id_$db ON refdb.$db USING btree (id);"
            pg_exec $conn "CREATE INDEX index_organism_$db ON refdb.$db USING btree (organism);"
            pg_exec $conn "CREATE INDEX index_description_$db ON refdb.$db USING btree (description);"
            pg_exec $conn "CREATE INDEX index_product_$db ON refdb.$db USING btree (product);"
        }
    } else {
        if {[catch {set fs [open $data r]}]} {
            puts "cant find $data."
        } else {
            set db_pkey $db; append db_pkey "_pkey"
            catch {
                pg_exec $conn "CREATE TABLE refdb.$db (id text NOT NULL, id2 text, organism text, description text, product text, CONSTRAINT ${db}_pkey PRIMARY KEY (id));"
                pg_exec $conn "CREATE INDEX index_id_$db ON refdb.$db USING btree (id);"
                pg_exec $conn "CREATE INDEX index_organism_$db ON refdb.$db USING btree (organism);"
                pg_exec $conn "CREATE INDEX index_description_$db ON refdb.$db USING btree (description);"
                pg_exec $conn "CREATE INDEX index_product_$db ON refdb.$db USING btree (product);"
            }
            if {$mode eq "fast"} {
                set res [pg_exec $conn "COPY refdb.$db FROM STDIN"]
                if {[pg_result $res -status] != "PGRES_COPY_IN"} {
                    puts [pg_result $res -error]
                    pg_result $res -clear
                }
                
                # Write to the database:
                set input ""
                set start 0
                set num 0
                while {[gets $fs line] != -1} {
                    incr num
                    if {$start eq 0} {
                        set start 1
                        append input "$line"
                    } else {
                        append input "\n$line"
                    }
                    if {$num >= 50000} {
                        puts $conn "$input"
                        set num 0
                        set input ""
                        set start 0
                    }
                }
                puts $conn "$input"
                # Write the end of data marker:
                puts $conn "\\."
                # Check final status:
                if {[pg_result $res -status] != "PGRES_COMMAND_OK"} {
                    puts [pg_result $res -error]
                    pg_result $res -clear
                }
                pg_result $res -clear
            } elseif {$mode eq "slow"} {
                while {[gets $fs line] != -1} {
                    set line "\{[regsub -all {\t} $line "\} \{"]\}"
                    catch {
                        pg_exec $conn "INSERT INTO refdb.$db VALUES ('[lindex $line 0]', '[lindex $line 1]', '[lindex $line 2]', '[lindex $line 3]', '[lindex $line 4]');"
                    }
                }
            } elseif {$mode eq "blast"} {
                set des 0
                set prod 0
                while {[gets $fs line] != -1} {
                    set line [regsub -all {=} [regsub -all {\]} [regsub -all {\[} [regsub -all {\}} [regsub -all {\{} [regsub -all {"} $line " "] "("] ")"] "("] ")"] " "]
                    if {[lindex $line 0] eq "LOCUS"} {
                        set tab ""
                        set id ""
                        set accid ""
                        set organism ""
                        set description ""
                        set product ""
                        set productid ""
                        set des 0
                        set prod 0
                    } elseif {[lindex $line 0] eq "DEFINITION"} {
                        set description [lrange $line 1 end]
                        set des 1
                    } elseif {[lindex $line 0] eq "ACCESSION"} {
                        set accid [lindex $line 1]
                        set des 0
                    } elseif {$des} {
                        append description " [string trim $line]"
                    } elseif {[lindex $line 0] eq "VERSION"} {
                        set id [lindex [split [lindex $line 2] :] 1]
                        set tab [string index $id 0]
                    } elseif {[lindex $line 0] eq "SOURCE"} {
                        set organism [lrange $line 1 end]
                    } elseif {[lindex $line 0] eq "/product"  && $productid eq ""} {
                        set product [lrange $line 1 end]
                        set prod 1
                    } elseif {[lindex $line 0] eq "/calculated_mol_wt" || [lindex $line 0] eq "/note"} {
                        set prod 0
                    } elseif {[lindex $line 0] eq "/protein_id" && $productid eq ""} {
                        set productid [lindex [split [lindex $line 1] .] 0]
                        set prod 0
                    } elseif {[lindex $line 0] eq "//"} {
                        if {[catch {pg_exec $conn "INSERT INTO refdb.blast$tab VALUES ('$id', '$accid', '$organism', '$description', '$product', '$productid')"}]} {
                            puts "could not insert $id"
                            flush stdout
                        } else {
                            puts "inserted $id"
                            flush stdout
                        }
                    } elseif {$prod} {
                        append product " [string trim $line]"
                    }
                }
            }
        }
    }
     pg_disconnect $conn 
}

#Tries to get InterPro annotations through existing blast hits (see table interpro2protein)
proc blast2interpro {dbName blastdb} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set hitL ""
    set tmp ""
    set e ""
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    pg_select $conn "SELECT id_seq, id, \"start\", \"end\", evalue FROM $dbName.blast_hits WHERE db = '$blastdb' ORDER BY id_seq, evalue" data {
        if {[lindex $tmp 0] eq $data(id_seq)} {
            if {$e < $data(evalue)} {
                set tmp "$data(id_seq) $data(id) $data(start) $data(end)"
                set e $data(evalue)
            }
        } elseif {$tmp ne ""} {
            lappend hitL $tmp
            set tmp "$data(id_seq) $data(id) $data(start) $data(end)"
            set e $data(evalue)
        } else {
            set tmp "$data(id_seq) $data(id) $data(start) $data(end)"
            set e $data(evalue)
        }
    }
    if {$tmp ne ""} {
        lappend hitL $tmp
    }
    
    foreach hit $hitL {
        set iprL ""
        pg_select $conn "SELECT DISTINCT interpro FROM (SELECT interpro, \"start\", \"end\" FROM refdb.interpro2protein WHERE protein = '[lindex $hit 1]') AS tmp WHERE start < [lindex $hit 3] AND \"end\" > [lindex $hit 2]" data {
            lappend iprL $data(interpro)
        }
        if {$iprL ne ""} {
            lappend hitL2 "[lindex $hit 0] {$iprL}"
        }
    }
    unset iprL
    set hitL ""
    foreach hit $hitL2 {
        set goL ""
        set tmpString ""
        foreach ipr [lindex $hit 1] {
            append tmpString ", '$ipr'"
        }
        set tmpString [string range $tmpString 2 end]        
        pg_select $conn "SELECT DISTINCT go FROM refdb.interpro2go WHERE interpro IN ($tmpString)" data {
            lappend goL $data(go)
        }
        lappend hitL "[lindex $hit 0] {[lindex $hit 1]} {$goL}"
    }
    unset goL
    unset hitL2
    set hitL [lsort -unique $hitL]
    
    foreach hit $hitL {
        foreach ipr [lindex $hit 1]  {
            pg_exec $conn "INSERT INTO $dbName.interpro_hits VALUES ('[lindex $hit 0]', -1, '$ipr')"
        }
        foreach go [lindex $hit 2]  {
            pg_exec $conn "INSERT INTO $dbName.go_hits VALUES ('[lindex $hit 0]', -1, '$go')"
        }
    }
    pg_disconnect $conn
}

#Tries to get InterPro annotations through existing domain hits (see table interpro2domain)
proc domain2interpro {dbName} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set iprL ""
    set goL ""
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    foreach ref {blastprodom_hits gene3d_hits panther_hits pfam_hits pir_hits patternscan_hits profilescan_hits smart_hits superfamily_hits tigr_hits} {
        pg_select $conn "SELECT DISTINCT $dbName.$ref.id_seq AS id_seq, $dbName.$ref.id_prot AS id_prot, refdb.interpro2domain.interpro AS id FROM $dbName.$ref INNER JOIN refdb.interpro2domain ON $dbName.$ref.id = refdb.interpro2domain.domain ORDER BY id_seq" data {
            lappend iprL "$data(id_seq) $data(id_prot) $data(id)"
        }
    }
    foreach ipr $iprL {
        catch {pg_exec $conn "INSERT INTO $dbName.interpro_hits VALUES ('[lindex $ipr 0]', '[lindex $ipr 1]', '[lindex $ipr 2]');"}
    }
    unset iprL
    pg_select $conn "SELECT DISTINCT $dbName.interpro_hits.id_seq AS id_seq, $dbName.interpro_hits.id_prot AS id_prot, refdb.interpro2go.go AS go FROM refdb.interpro2go INNER JOIN $dbName.interpro_hits ON refdb.interpro2go.interpro = $dbName.interpro_hits.id" data {
        lappend goL "$data(id_seq) $data(id_prot) $data(go)"
    }
    
    foreach go $goL {
        catch {pg_exec $conn "INSERT INTO $dbName.go_hits VALUES ('[lindex $go 0]', '[lindex $go 1]', '[lindex $go 2]');"}
    }
    unset goL
    pg_disconnect $conn
}

#Creates database
proc createDB {dbName} {
    global host
    global port
    global user
    global password
    global parentDB
    
    catch {exec createdb  -h $host -p $port -U $user $parentDB}
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    
    catch {pg_select $conn "SELECT functions.cdb('$dbName','$user') AS out" data {set out $data(out)}} out
    puts "$out"
    pg_disconnect $conn
}

#Deletes database
proc deleteDB {dbName} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    pg_exec $conn "DROP SCHEMA $dbName CASCADE;"
    pg_exec $conn "DELETE FROM public.dbs WHERE name = '$dbName';"
    pg_disconnect $conn
}

#Writes interpro2domain associations from file to database reference table 
proc ipr2domain {f} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    
    if {[catch {set fs [open $f r]}]} {
        puts "cant find $f."
    } else {
        set iprID ""
        set ipr2domainL ""
        set members 0
        set start 0
        while {[gets $fs line] != -1} {
            set line [regsub -all {\}} [regsub -all {\{} [regsub -all {["]} $line " "] "("] ")"]
            if {[lindex $line 0] eq "<interpro"} {
                set iprID [lindex $line 2]
            } elseif {[lindex $line 0] eq "<member_list>"} {
                set members 1
            } elseif {[lindex $line 0] eq "</member_list>"} {
                set members 0
            } elseif {[lindex $line 0] eq "</interpro>"} {
                set iprID ""
            } elseif {$members && $iprID ne ""} {
                set db ""
                switch [lindex $line 2] {
                    PFAM {set db pfam}
                    PROFILE {set db profilescan}
                    SMART {set db smart}
                    GENE3D {set db gene3d; lappend gene3dRefs "[lindex $line 4] [lindex $line 6]"}
                    PRODOM {set db blastprodom}
                    PIRSF {set db pir}
                    PANTHER {set db panther}
                    SSF {set db superfamily}
                    TIGRFAMs {set db tigr}
                    PROSITE {set db patternscan}
                }
                if {$db ne ""} {
                    if {$start} {
                        append ipr2domainL "\n$iprID\t$db\t[lindex $line 4]"
                    } else {
                        append ipr2domainL "$iprID\t$db\t[lindex $line 4]"
                        set start 1
                    }
                }
            }
        }
        close $fs
        if {$ipr2domainL ne ""} {
            catch {pg_exec $conn "DROP TABLE refdb.interpro2domain;"}
            catch {pg_exec $conn "CREATE TABLE refdb.interpro2domain (interpro text, db text, domain text);"}
            catch {
                set res [pg_exec $conn "COPY refdb.interpro2domain FROM STDIN"]
                if {[pg_result $res -status] != "PGRES_COPY_IN"} {
                    #set message [pg_result $res -error]
                    pg_result $res -clear
                }
                # Write to the database:
                puts $conn "$ipr2domainL"
                # Write the end of data marker:
                puts $conn "\\."
                # Check final status:
                if {[pg_result $res -status] != "PGRES_COMMAND_OK"} {
                    #set message [pg_result $res -error]
                    pg_result $res -clear
                }
                pg_result $res -clear
                unset ipr2domainL
            }
        }
        set exists 0
        foreach g $gene3dRefs {
            pg_select $conn "SELECT id FROM refdb.gene3d WHERE id = '[lindex $g 0]'" data {set exists 1}
            if {$exists} {
                pg_exec $conn "UPDATE refdb.gene3d SET id='[lindex $g 1]' WHERE id='[lindex $g 0]';"
            } else {
                pg_exec $conn "INSERT INTO refdb.gene3d VALUES ('[lindex $g 0]', '[lindex $g 1]')"
            }
        }
    }
    pg_disconnect $conn
}

#Writes interpro2go associations from file to database reference table
proc ipr2go {f} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    
    if {[catch {set fs [open $f r]}]} {
        puts "cant find ipr2go file: $f"
    } else {
        set input ""
        set start 0
        while {[gets $fs line] != -1} {
            if {[string index $line 0] ne "!"} {
                if {$start} {
                    append input "\n[lindex [split [lindex $line 0] :] 1]\t[lindex $line end]"
                } else {
                    append input "[lindex [split [lindex $line 0] :] 1]\t[lindex $line end]"
                    set start 1
                }
            }
        }
        close $fs
        set res [pg_exec $conn "COPY refdb.interpro2go FROM STDIN"]
        if {[pg_result $res -status] != "PGRES_COPY_IN"} {
            #set message [pg_result $res -error]
            pg_result $res -clear
        }
        # Write to the database:
        puts $conn "$input"
        # Write the end of data marker:
        puts $conn "\\."
        # Check final status:
        if {[pg_result $res -status] != "PGRES_COMMAND_OK"} {
            #set message [pg_result $res -error]
            pg_result $res -clear
        }
        pg_result $res -clear
    }
    pg_disconnect $conn
}

#Writes interpro2protein associations from file to database reference table
proc prot2ipr {f} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    
    
    if {[catch {set fs [open $f r]}]} {
        puts "cant find prot2ipr file: $f"
    } else {
        set input ""
        set start 0
        set count 0
        set protCol 0
        set iprCol 1
        set desCol 2
        set domCol 3
        set sCol 4
        set eCol 5
        set startLine 1
        while {[gets $fs line] != -1} {
            if {$startLine} {
                set startLine 0
                set i 0
                foreach e $line {
                    if {$e eq "proteinID"} {
                        set in 1
                        set protCol $i
                    } elseif {$e eq "iprID"} {
                        set iprCol $i
                    } elseif {$e eq "iprDesc"} {
                        set desCol $i
                    } elseif {$e eq "domainID"} {
                        set domCol $i
                    } elseif {$e eq "domainStarts"} {
                        set iprCol $i
                    } elseif {$e eq "domainEnds"} {
                        set iprCol $i
                    }
                    incr i
                }
            }
            incr count
            set line "\{[regsub -all {\t} $line "\} \{"]\}"
            if {$start} {
                set s [split [lindex $line $sCol] ,]
                set e [split [lindex $line $eCol] ,]
                if {$s eq ""} {
                    set s 0
                    set e 0
                }
                for {set i 0} {$i < [llength $s]} {incr i} {
                    append input "\n[lindex $line $protCol]\t[lindex $line $iprCol]\t[lindex $line $domCol]\t[lindex $s $i]\t\t[lindex $e $i]"
                }
            } else {
                set s [split [lindex $line $sCol] ,]
                set e [split [lindex $line $eCol] ,]
                if {$s eq ""} {
                    set s 0
                    set e 0
                }
                for {set i 0} {$i < [llength $s]} {incr i} {
                    append input "[lindex $line $protCol]\t[lindex $line $iprCol]\t[lindex $line $domCol]\t[lindex $s $i]\t\t[lindex $e $i]"
                }
                set start 1
            }
            lappend iprRefs "[lindex $line $iprCol] {[lindex $line $desCol]}"
            if {$count >= 50000} {
                set res [pg_exec $conn "COPY refdb.interpro2protein FROM STDIN"]
                if {[pg_result $res -status] != "PGRES_COPY_IN"} {
                    #set message [pg_result $res -error]
                    pg_result $res -clear
                }
                # Write to the database:
                puts $conn "$input"
                # Write the end of data marker:
                puts $conn "\\."
                # Check final status:
                if {[pg_result $res -status] != "PGRES_COMMAND_OK"} {
                    #set message [pg_result $res -error]
                    pg_result $res -clear
                }
                pg_result $res -clear
                set input ""
                set start 0
                set count 0
            }
        }
        close $fs
        if {$input ne ""} {
            set res [pg_exec $conn "COPY refdb.interpro2protein FROM STDIN"]
            if {[pg_result $res -status] != "PGRES_COPY_IN"} {
                #set message [pg_result $res -error]
                pg_result $res -clear
            }
            # Write to the database:
            puts $conn "$input"
            # Write the end of data marker:
            puts $conn "\\."
            # Check final status:
            if {[pg_result $res -status] != "PGRES_COMMAND_OK"} {
                #set message [pg_result $res -error]
                pg_result $res -clear
            }
            pg_result $res -clear
        }
        unset input
        
        set iprRefs [lsort -unique $iprRefs]
        foreach ipr $iprRefs {
            pg_exec $conn "INSERT INTO refdb.interpro VALUES ('[lindex $ipr 0]', '[lindex $ipr 1]');"
        }
    }
    pg_disconnect $conn
}

#Writes kegg2protein associations from file to database reference table
proc prot2kegg {genes_ko genes_prot} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    if {[catch {set fs [open $genes_prot r]}]} {
        puts "cant find genes_ko file: $genes_prot"
    } else {
        while {[gets $fs line] != -1} {
            set genesPArr([lindex $line 0]) "[lindex [split [lindex $line 1] :] 1]"
        }
        close $fs
        if {[catch {set fs [open $genes_ko r]}]} {
            puts "cant find genes_ko file: $genes_ko"
        } else {
            while {[gets $fs line] != -1} {
                append genesKArr([lindex $line 0]) "\t[lindex [split [lindex $line 1] :] 1]"
                lappend geneL [lindex $line 0]
            }
            close $fs
            catch {
                pg_exec $conn "CREATE TABLE refdb.kegg2protein (protein text NOT NULL, id_ko text, CONSTRAINT kegg2protein_pkey PRIMARY KEY (protein, id_ko));"
                pg_exec $conn "CREATE INDEX kegg2protein_id_index ON refdb.kegg2protein USING btree (id_ko);"
                pg_exec $conn "CREATE INDEX kegg2protein_protein_index ON refdb.kegg2protein USING btree (protein);"
            }
        }
        
        set input ""
        set start 0
        set kegg2protL ""
        foreach gene $geneL {
            set prot ""
            if {[catch {set prot $genesPArr($gene)}]} {
            } else {
                foreach k $genesKArr($gene) {
                    foreach p $prot {
                        lappend kegg2protL "$p\t$k"
                    }
                }
            }
            catch {set genesPArr($gene) ""}
            set genesKArr($gene) ""
        }
        set kegg2protL [lsort -unique $kegg2protL]
        foreach ent $kegg2protL {
            if {$start} {
                append input "\n$ent"
            } else {
                append input "$ent"
                set start 1
            }
        }
        unset kegg2protL
        if {$input ne ""} {
            set res [pg_exec $conn "COPY refdb.kegg2protein FROM STDIN"]
            if {[pg_result $res -status] != "PGRES_COPY_IN"} {
                puts [pg_result $res -error]
                pg_result $res -clear
            }
            # Write to the database:
            puts $conn "$input"
            # Write the end of data marker:
            puts $conn "\\."
            # Check final status:
            if {[pg_result $res -status] != "PGRES_COMMAND_OK"} {
                #set message [pg_result $res -error]
                pg_result $res -clear
            }
            pg_result $res -clear
        }
        unset input
        unset geneL
    }
    pg_disconnect $conn
}


proc prot2keggJGI {f} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    if {[catch {set fs [open $f r]}]} {
        puts "cant find prot2kegg file: $f"
    } else {
        set start 0
        while {[gets $fs line] != -1} {
            set ec2kegg([lindex $line 1]) "[lindex $line 0]"
            pg_select $conn "SELECT DISTINCT id FROM refdb.kegg WHERE description LIKE '%[lindex $line 1])%';" data {
                set ko $data(id)
            }
            if {$start} {
                append input "\n[lindex $line 0]\t$ko"
            } else {
                append input "[lindex $line 0]\t$ko"
                set start 1
            }
        }
        close $fs
        
    }

    if {$input ne ""} {
        set res [pg_exec $conn "COPY refdb.kegg2protein FROM STDIN"]
        if {[pg_result $res -status] != "PGRES_COPY_IN"} {
            puts [pg_result $res -error]
            pg_result $res -clear
        }
        # Write to the database:
        puts $conn "$input"
        # Write the end of data marker:
        puts $conn "\\."
        # Check final status:
        if {[pg_result $res -status] != "PGRES_COMMAND_OK"} {
            #set message [pg_result $res -error]
            pg_result $res -clear
        }
        pg_result $res -clear
    }
    unset input
    unset geneL
    pg_disconnect $conn
}

proc getKEGGMaps {map_title map_list} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    if {[catch {set fs [open $map_title r]}]} {
        puts "cant find $map_title."
    } else {
        while {[gets $fs line] != -1} {
            if {$line ne ""} {
                lappend mapL "[lindex $line 0] {[lrange $line 1 end]}"
            }
        }
        close $fs
        
        if {[catch {set fs [open $map_list r]}]} {
            puts "cant find $map_list."
        } else {
            catch {pg_exec $conn "CREATE TABLE refdb.kegg_maps (id_map text NOT NULL, id_ko text, id_ec text, id_rn text, id_cpd text, name text, CONSTRAINT kegg_maps_pkey PRIMARY KEY (id_map));"}
            catch {pg_exec $conn "DELETE FROM refdb.kegg_maps;"}
            set id_map ""
            set koL ""
            set ecL ""
            set rnL ""
            set cpdL ""
            while {[gets $fs line] != -1} {
                if {$id_map eq [lindex $line 0]} {
                    set tmp [split [lindex $line 1] :]
                    if {[lindex $tmp 0] eq "ko"} {
                        lappend koL [lindex $tmp 1]
                    } elseif {[lindex $tmp 0] eq "ec"} {
                        lappend ecL [lindex $tmp 1]
                    } elseif {[lindex $tmp 0] eq "rn"} {
                        lappend rnL [lindex $tmp 1]
                    } elseif {[lindex $tmp 0] eq "cpd"} {
                        lappend cpdL [lindex $tmp 1]
                    }
                } elseif {$id_map eq ""} {
                    set id_map [lindex $line 0]
                    set tmp [split [lindex $line 1] :]
                    if {[lindex $tmp 0] eq "ko"} {
                        lappend koL [lindex $tmp 1]
                    } elseif {[lindex $tmp 0] eq "ec"} {
                        lappend ecL [lindex $tmp 1]
                    } elseif {[lindex $tmp 0] eq "rn"} {
                        lappend rnL [lindex $tmp 1]
                    } elseif {[lindex $tmp 0] eq "cpd"} {
                        lappend cpdL [lindex $tmp 1]
                    }
                } else {
                    set i [lsearch -regexp $mapL [lindex [regsub -all {:map} $id_map " "] 1]]
                    lappend resL "ko[lindex [lindex $mapL $i] 0]\t$koL\t$ecL\t$rnL\t$cpdL\t[lindex [lindex $mapL $i] 1]"
                    set koL ""; set ecL ""; set rnL ""; set cpdL ""
                    set id_map [lindex $line 0]
                    set tmp [split [lindex $line 1] :]
                    if {[lindex $tmp 0] eq "ko"} {
                        lappend koL [lindex $tmp 1]
                    } elseif {[lindex $tmp 0] eq "ec"} {
                        lappend ecL [lindex $tmp 1]
                    } elseif {[lindex $tmp 0] eq "rn"} {
                        lappend rnL [lindex $tmp 1]
                    } elseif {[lindex $tmp 0] eq "cpd"} {
                        lappend cpdL [lindex $tmp 1]
                    }
                }
            }
            if {[lindex [regsub -all {:map} $id_map " "] 1] ne ""} {
                set i [lsearch -regexp $mapL [lindex [regsub -all {:map} $id_map " "] 1]]
                if {$i ne -1} {
                    lappend resL "ko[lindex [lindex $mapL $i] 0]\t$koL\t$ecL\t$rnL\t$cpdL\t[lindex [lindex $mapL $i] 1]"
                }
            }
            
            unset mapL
            close $fs
            set start 0
            foreach ent $resL {
                if {$start} {
                    append input "\n$ent"
                } else {
                    append input "$ent"
                    set start 1
                }
            }
            unset resL
            set res [pg_exec $conn "COPY refdb.kegg_maps FROM STDIN"]
            if {[pg_result $res -status] != "PGRES_COPY_IN"} {
                puts [pg_result $res -error]
                pg_result $res -clear
            }
            # Write to the database:
            puts $conn "$input"
            # Write the end of data marker:
            puts $conn "\\."
            # Check final status:
            if {[pg_result $res -status] != "PGRES_COMMAND_OK"} {
                #set message [pg_result $res -error]
                pg_result $res -clear
            }
            pg_result $res -clear
            unset input
        }
    }
    pg_disconnect $conn
}

proc seqInfo {dbName mode} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]

    puts "Running seqInfo..."
    catch {pg_select $conn "SELECT functions.seqinfo('$dbName', '$mode') AS out" data {set result $data(out)}} err
    catch {pg_exec $conn "SELECT functions.dbInfo('$dbName')"} result
    puts -nonewline "done:  seq$err; $result"
    pg_disconnect $conn
}

proc getNum {dbh dbName} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    if {$dbh eq "sequences_nucleotide"} {
        pg_select $conn "SELECT MAX(id_seq) AS n FROM $dbName.$dbh" data {
            set num $data(n)
        }
    } elseif {$dbh eq "sequences_protein"} {
        pg_select $conn "SELECT MAX(id_prot) AS n FROM $dbName.$dbh" data {
            set num $data(n)
        }
    } elseif {$dbh eq "sequences_read"} {
        pg_select $conn "SELECT MAX(id_read) AS n FROM $dbName.$dbh" data {
            set num $data(n)
        }
    } else {
        pg_select $conn "SELECT COUNT(id_seq) AS n FROM $dbName.$dbh" data {
            set num $data(n)
        }
    }
    
    pg_disconnect $conn
    if {$num eq ""} {
        return 0
    } else {
        return $num
    }  
}

proc goStat {dbName} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    catch {pg_select $conn "SELECT functions.gostat('$dbName') AS out" data {set result $data(out)}} err
    pg_disconnect $conn
}

proc goTree_build {} {
    global host
    global port
    global user
    global password
    global parentDB
    global goStatArr
    global goIDL
    
    set connRef [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    pg_exec $connRef "CREATE TABLE refdb.gotree (id text NOT NULL, parent_of text, member_of text, members text, level_biological_process text, level_molecular_function text, level_cellular_component text);CREATE INDEX gotree_id_index ON refdb.gotree USING btree (id);"
    pg_exec $connRef "DELETE FROM refdb.gotree;"
    pg_select $connRef "SELECT DISTINCT main_id AS id FROM refdb.go" data {
        set goStatArr($data(id).parentOf) " "
        set goStatArr($data(id).memberOf) "$data(id)"
        set goStatArr($data(id).members) " "
        set goStatArr($data(id).biological_process) " "
        set goStatArr($data(id).cellular_component) " "
        set goStatArr($data(id).molecular_function) " "
        lappend goIDL $data(id)
    } 
    pg_select $connRef "SELECT DISTINCT main_id AS id, is_a FROM refdb.go" data {
        foreach is_a $data(is_a) {
            lappend goStatArr($is_a.parentOf) $data(id)
        }
    }

    foreach id $goIDL {
        goTree_members $id $id
    }
    
    foreach id $goIDL {
        set goStatArr($id.members) [lsort -unique $goStatArr($id.members)]
        foreach member $goStatArr($id.members) {
            lappend goStatArr($member.memberOf) $id
        }
    }
    
    set goStatArr(GO:0008150.biological_process) 0
    set goStatArr(GO:0005575.cellular_component) 0
    set goStatArr(GO:0003674.molecular_function) 0
    
    goTree_levels GO:0008150 biological_process 1
    goTree_levels GO:0005575 cellular_component 1
    goTree_levels GO:0003674 molecular_function 1
    
    set res [pg_exec $connRef "COPY refdb.gotree FROM STDIN"]
    if {[pg_result $res -status] != "PGRES_COPY_IN"} {
        puts [pg_result $res -error]
        pg_result $res -clear
    }
    set input ""
    # Write to the database:
    set start 0
    foreach id $goIDL {
        if {$start eq 0} {
            set start 1
            append input "$id\t$goStatArr($id.parentOf)\t[lsort -unique $goStatArr($id.memberOf)]\t$goStatArr($id.members)\t|[regsub -all { } [lsort -unique $goStatArr($id.biological_process)] "|"]|\t|[regsub -all { } [lsort -unique $goStatArr($id.molecular_function)] "|"]|\t|[regsub -all { } [lsort -unique $goStatArr($id.cellular_component)] "|"]|"
        } else {
            append input "\n$id\t$goStatArr($id.parentOf)\t[lsort -unique $goStatArr($id.memberOf)]\t$goStatArr($id.members)\t|[regsub -all { } [lsort -unique $goStatArr($id.biological_process)] "|"]|\t|[regsub -all { } [lsort -unique $goStatArr($id.molecular_function)] "|"]|\t|[regsub -all { } [lsort -unique $goStatArr($id.cellular_component)] "|"]|"
        }
        unset goStatArr($id.parentOf); unset goStatArr($id.members); unset goStatArr($id.memberOf); unset goStatArr($id.biological_process); unset goStatArr($id.cellular_component); unset goStatArr($id.molecular_function)
    }
    unset goIDL
    puts $connRef "$input"
    # Write the end of data marker:
    puts $connRef "\\."
    # Check final status:
    if {[pg_result $res -status] != "PGRES_COMMAND_OK"} {
        puts [pg_result $res -error]
        pg_result $res -clear
    }
    pg_result $res -clear
    
    unset input
    
    pg_disconnect $connRef
}

proc goTree_members {id_parent id_child} {
    global goStatArr
    set childL $goStatArr($id_child.parentOf)
    if {$childL ne ""} {
        foreach child $childL {
            lappend goStatArr($id_parent.members) $child
            if {$goStatArr($child.members) eq " "} {
                if {$goStatArr($child.parentOf) ne " "} {
                    goTree_members $id_parent $child
                }
            }
            foreach member $goStatArr($child.members) {
                lappend goStatArr($id_parent.members) $member
            }
        }
    }
    lappend goStatArr($id_parent.members) $id_parent
}

proc goTree_levels {id category level} {
    global goStatArr
    set childL $goStatArr($id.parentOf)
    if {$childL ne ""} {
        foreach child $childL {
            lappend goStatArr($child.$category) $level
            goTree_levels $child $category [expr $level + 1]
        }
    }
}

proc goRef {file} {
    global host
    global port
    global user
    global password
    global parentDB
    
    if {[catch {set fs [open $file r]}]} {
    } else {
        set id ""
        set def ""
        set is_a ""
        set alt_ids ""
        while {[gets $fs line] != -1} {
            set line [regsub -all {[\]\[\\]} $line ""]
            set line [regsub -all {\{} $line "\\\{"]
            set line [regsub -all {\}} $line "\\\}"]
            set line [regsub -all {\"} $line "#"]
            if {[lindex $line 0] eq "id:"} {
                if {$id ne ""} {
                    foreach altid $alt_ids {
                        lappend goL "$altid\t$name_space\t$name\t$def\t$is_a\t$alt_ids\t$id"
                    }
                    set name ""
                    set name_space ""
                    set def ""
                    set is_a ""
                    set alt_ids ""
                }
                set id [lindex $line 1]
                set alt_ids [lindex $line 1]
            } elseif {[lindex $line 0] eq "name:"} {
                set name [lrange $line 1 end]
            } elseif {[lindex $line 0] eq "namespace:"} {
                set name_space [lrange $line 1 end]
            } elseif {[lindex $line 0] eq "alt_id:"} {
                lappend alt_ids [lindex $line 1]
            } elseif {[lindex $line 0] eq "def:"} {
                set line [split $line #]
                set def [lindex $line 1]
            } elseif {[lindex $line 0] eq "is_a:"} {
                lappend is_a [lindex $line 1]
            }
        }
        if {$id ne ""} {
            foreach altid $alt_ids {
                lappend goL "$altid\t$name_space\t$name\t$def\t$is_a\t$alt_ids\t$id"
            }
            unset name
            unset name_space
            unset def
            unset is_a
            unset alt_ids
        }
        close $fs
    }
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    pg_exec $conn "CREATE TABLE refdb.go (id text NOT NULL, category text, name text, description text, is_a text, alt_id text, main_id text, CONSTRAINT go_pkey PRIMARY KEY (id));"
    pg_exec $conn "DELETE FROM refdb.go"
    
    set res [pg_exec $conn "COPY refdb.go FROM STDIN"]
    if {[pg_result $res -status] != "PGRES_COPY_IN"} {
        puts [pg_result $res -error]
        pg_result $res -clear
    }
    set input ""
    # Write to the database:
    set start 0
    foreach ent $goL {
        #catch {puts $connHit "$i\tThis is data line $i"}
        if {$start eq 0} {
            set start 1
            append input "$ent"
        } else {
            append input "\n$ent"
        }
    }
    puts $conn "$input"
    # Write the end of data marker:
    puts $conn "\\."
    # Check final status:
    if {[pg_result $res -status] != "PGRES_COMMAND_OK"} {
        #set message [pg_result $res -error]
        pg_result $res -clear
    }
    pg_result $res -clear
    
    pg_disconnect $conn
}

proc keggRef {file} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set kegg2go ""
    if {[catch {set fs [open $file r]}]} {
    } else {
        set id ""
        set des ""
        set name ""
        while {[gets $fs line] != -1} {
            set line [regsub -all {\[} $line "("]
            set line [regsub -all {\]} $line ")"]
            if {[lindex $line 0] eq "ENTRY"} {
                if {$id ne ""} {
                    lappend keggL "$id\t$name\t$des"
                    set name ""
                    set des ""
                }
                set id [lindex $line 1]
            } elseif {[lindex $line 0] eq "NAME"} {
                set name [lrange $line 1 end]
            } elseif {[lindex $line 0] eq "DEFINITION"} {
                set des [lrange $line 1 end]
            } elseif {[lindex $line 0] eq "GO:"} {
                foreach go [lrange $line 1 end] {
                    lappend kegg2go "$id\tGO:$go"
                }
            }
        }
        close $fs
    }
    set kegg2go [lsort -unique $kegg2go] 
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    pg_exec $conn "CREATE TABLE refdb.kegg (id text NOT NULL, name text, description text, CONSTRAINT kegg_pkey PRIMARY KEY (id));"
    pg_exec $conn "CREATE TABLE refdb.kegg2go (ko text NOT NULL, go text NOT NULL, CONSTRAINT kegg2go_pkey PRIMARY KEY (ko, go));"
    pg_exec $conn "DELETE FROM refdb.kegg"
    pg_exec $conn "DELETE FROM refdb.kegg2go"
    
    set res [pg_exec $conn "COPY refdb.kegg FROM STDIN"]
    if {[pg_result $res -status] != "PGRES_COPY_IN"} {
        puts [pg_result $res -error]
        pg_result $res -clear
    }
    set input ""
    # Write to the database:
    set start 0
    foreach ent $keggL {
        if {$start eq 0} {
            set start 1
            append input "$ent"
        } else {
            append input "\n$ent"
        }
    }
    puts $conn "$input"
    # Write the end of data marker:
    puts $conn "\\."
    # Check final status:
    if {[pg_result $res -status] != "PGRES_COMMAND_OK"} {
        #set message [pg_result $res -error]
        pg_result $res -clear
    }
    pg_result $res -clear
    
    set res [pg_exec $conn "COPY refdb.kegg2go FROM STDIN"]
    if {[pg_result $res -status] != "PGRES_COPY_IN"} {
        #set message [pg_result $res -error]
        pg_result $res -clear
    }
    set input ""
    # Write to the database:
    set start 0
    foreach ent $kegg2go {
        if {$start eq 0} {
            set start 1
            append input "$ent"
        } else {
            append input "\n$ent"
        }
    }
    puts $conn "$input"
    # Write the end of data marker:
    puts $conn "\\."
    # Check final status:
    if {[pg_result $res -status] != "PGRES_COMMAND_OK"} {
        #set message [pg_result $res -error]
        pg_result $res -clear
    }
    pg_result $res -clear
    pg_disconnect $conn
    unset kegg2go
}

proc createRefDB {} {
    global host
    global port
    global user
    global password
    global parentDB
    
    puts "Create parentDB"
    if {[catch {exec createdb -h $host -p $port -U $user $parentDB} out]} {puts $out}
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    if {[catch {pg_exec $conn "CREATE SCHEMA refdb;"}]} {
        puts "Database RefDB already exists."
    } else {
        pg_exec $conn "CREATE TABLE refdb.go (id text NOT NULL, category text, name text, description text, is_a text, alt_id text, main_id text, CONSTRAINT go_pkey PRIMARY KEY (id)); \
                CREATE TABLE refdb.interpro (id text NOT NULL, description text, CONSTRAINT interpro_pkey PRIMARY KEY (id)); \
                CREATE TABLE refdb.blastprodom (id text NOT NULL, description text, CONSTRAINT blastprodom_pkey PRIMARY KEY (id)); \
                CREATE TABLE refdb.coil (id text NOT NULL, description text, CONSTRAINT coil_pkey PRIMARY KEY (id)); \
                CREATE TABLE refdb.gene3d (id text NOT NULL, description text, CONSTRAINT gene3d_pkey PRIMARY KEY (id)); \
                CREATE TABLE refdb.panther (id text NOT NULL, description text, CONSTRAINT panther_pkey PRIMARY KEY (id)); \
                CREATE TABLE refdb.pfam (id text NOT NULL, description text, CONSTRAINT pfam_pkey PRIMARY KEY (id)); \
                CREATE TABLE refdb.pir (id text NOT NULL, description text, CONSTRAINT pir_pkey PRIMARY KEY (id)); \
                CREATE TABLE refdb.smart (id text NOT NULL, description text, CONSTRAINT smart_pkey PRIMARY KEY (id)); \
                CREATE TABLE refdb.patternscan (id text NOT NULL, description text, CONSTRAINT patternscan_pkey PRIMARY KEY (id)); \
                CREATE TABLE refdb.profilescan (id text NOT NULL, description text, CONSTRAINT profilescan_pkey PRIMARY KEY (id)); \
                CREATE TABLE refdb.superfamily (id text NOT NULL, description text, CONSTRAINT superfamily_pkey PRIMARY KEY (id)); \
                CREATE TABLE refdb.tigr (id text NOT NULL, description text, CONSTRAINT tigr_pkey PRIMARY KEY (id)); \
                CREATE TABLE refdb.interpro2domain (interpro text, db text, domain text); \
                CREATE TABLE refdb.interpro2go (interpro text, go text); \
                CREATE TABLE refdb.interpro2protein (protein text, interpro text, id_domain text, \"start\" integer, \"end\" integer); \
                CREATE TABLE refdb.kegg (id text NOT NULL, name text, description text, CONSTRAINT kegg_pkey PRIMARY KEY (id)); \
                CREATE TABLE refdb.kegg2go (ko text NOT NULL, go text NOT NULL, CONSTRAINT kegg2go_pkey PRIMARY KEY (ko, go)); \
                CREATE TABLE refdb.kegg_maps (id_map text NOT NULL, id_ko text, id_ec text, id_rn text, id_cpd text, name text, CONSTRAINT kegg_maps_pkey PRIMARY KEY (id_map)); \
                CREATE TABLE refdb.kegg2protein (protein text NOT NULL, id_ko text, CONSTRAINT kegg2protein_pkey PRIMARY KEY (protein, id_ko)); \
                CREATE INDEX kegg_id_index ON refdb.kegg2protein USING btree (id_ko); \
                CREATE INDEX kegg_protein_index ON refdb.kegg2protein USING btree (protein); \
                CREATE INDEX interpro2protein_protein_index ON refdb.interpro2protein USING btree (protein); \
                CREATE INDEX interpro2go_interpro_index ON refdb.interpro2go USING btree (interpro); \
                CREATE TABLE public.dbs (name text NOT NULL, owner text, CONSTRAINT dbs_pkey PRIMARY KEY (name));"
        if {[catch {pg_exec $conn "CREATE LANGUAGE pltcl"} out]} {
            puts "could not execute createlang pltcl: $out"
        }
    }
    pg_disconnect $conn
}

proc createFunctions {} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    catch {pg_exec $conn "DROP SCHEMA functions CASCADE"}
    if {[catch {pg_exec $conn "CREATE SCHEMA functions"}]} {
        puts "Functions already exists."
    } else {
        #addnuc: adds nucleotide sequences to the sequences_nucleotide table and creates a seq_info entry
        catch {pg_exec $conn "CREATE FUNCTION functions.addnuc(text,text) \
                    RETURNS text AS\
                    \$BODY\$set num 0\n\
                    catch \{\n\
                    spi_exec -array data \"SELECT MAX(id_seq) AS n FROM \$1.sequences_nucleotide\" \{\n\
                    set num \$data(n)\n\
                    \}\n\
                    \}\n\
                    incr num\n\
                    catch \{\n\
                    spi_exec \"INSERT INTO \$1.sequences_nucleotide VALUES ('\$num', '\[lindex \[lindex \$2 0\] 0\]', '\[lindex \[lindex \$2 0\] 1\]', '\[lindex \[lindex \$2 0\] 2\]', '\[lindex \$2 1\]', '', '');\"\n\
                    spi_exec \"INSERT INTO \$1.seq_info VALUES ('\$num', '\[lindex \[lindex \$2 0\] 0\]', '\[lindex \[lindex \$2 0\] 2\]', '\[lindex \[lindex \$2 0\] 1\]', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0')\"\n\
                    \}\n\
                    return \"1\"\n\
                    \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #addprot: adds protein sequences to the sequences_protein table
        catch {pg_exec $conn "CREATE FUNCTION functions.addprot(text,text,text) \
                    RETURNS text AS\
                    \$BODY\$set num 0\n\
                    catch \{\n\
                        spi_exec -array data \"SELECT MAX(id_prot) AS n FROM \$1.sequences_protein\" \{\n\
                            set num \$data(n)\n\
                        \}\n\
                    \}\n\
                    set id_seq \"\"\n\
                    set len \[string length \[lindex \$2 1\]\]\n\
                    if \{\$3\} \{\n\
                        spi_exec -array data \"SELECT id_seq FROM \$1.sequences_nucleotide WHERE \\\"name\\\" = '\[lindex \[lindex \$2 0\] 1\]'\" \{\n\
                            set id_seq \$data(id_seq)\n\
                        \}\n\
                        if \{\$id_seq ne \"\"\} \{\n\
                            incr num\n\
                            if \{\[catch \{\n\
                                spi_exec \"INSERT INTO \$1.sequences_protein VALUES ('\$id_seq', '\$num', '\[lindex \[lindex \$2 0\] 0\]', '\[lindex \[lindex \$2 0\] 2\]', '\[lindex \[lindex \$2 0\] 3\]', '\$len', '\[lindex \$2 1\]');\"\n\
                                spi_exec \"INSERT INTO \$1.prot_info VALUES ('\$num', '\[lindex \[lindex \$2 0\] 0\]', '\$len', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0')\"\n\
                            \}\]\} \{return \"\[lindex \$2 0\] error.\"\}\n\
                        \} else \{set out \"ERROR: no id_seq found for \[lindex \$2 1\]\"\}\n\
                    \} else \{\n\
                        set id_seq \"-1\"\n\
                        incr num\n\
                        if \{\[catch \{\n\
                            spi_exec \"INSERT INTO \$1.sequences_protein VALUES ('\$id_seq', '\$num', '\[lindex \$2 0\]', '-1', '-1', '\$len', '\[lindex \$2 1\]');\"\n\
                            spi_exec \"INSERT INTO \$1.prot_info VALUES ('\$num', '\[lindex \$2 0\]', '\$len', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0')\"\n\
                        \}\]\} \{return \"\[lindex \$2 0\] error.\"\}\n\
                        
                    \}\n\
                    return \"\[lindex \$2 0\] added.\"\n\
                    \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #addrun: adds the given run information to the run_info table
        catch {pg_exec $conn "CREATE FUNCTION functions.addrun(text,text) \
                    RETURNS text AS\
                    \$BODY\$set exists 0\n\
                    spi_exec -array data \"SELECT id_run FROM \$1.run_info WHERE id_run = '\[lindex \$2 0\]'\" \{\n\
                        set exists 1\n\
                    \}\n\
                    if \{\$exists\} \{\n\
                        spi_exec \"UPDATE \$1.run_info SET description='\[lindex \$2 1\]', runs='\[lindex \$2 2\]', sequencer='\[lindex \$2 3\]', type='\[lindex \$2 4\]', datein='\[lindex \$2 5\]', dateout='\[lindex \$2 6\]', data='\[lindex \$2 7\]', sequences='\[lindex \$2 8\]', assembled='\[lindex \$2 9\]', singleton='\[lindex \$2 10\]', treatment='\[lindex \$2 11\]', comment='\[lindex \$2 12\]', color='\[lindex \$2 13\]', a_b='\[lindex \$2 14\]' WHERE id_run='\[lindex \$2 0\]'\"\n\
                    \} else \{\n\
                        spi_exec \"INSERT INTO \$1.run_info VALUES ('\[lindex \$2 0\]', '\[lindex \$2 1\]', '\[lindex \$2 2\]', '\[lindex \$2 3\]', '\[lindex \$2 4\]', '\[lindex \$2 5\]', '\[lindex \$2 6\]', '\[lindex \$2 7\]', '\[lindex \$2 8\]', '\[lindex \$2 9\]', '\[lindex \$2 10\]', '\[lindex \$2 11\]', '\[lindex \$2 12\]', '\[lindex \$2 13\]', '\[lindex \$2 14\]')\"\n\
                    \}\n\
                    return \"1\"\n\
                    \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #blast2interpro:
        catch {pg_exec $conn "CREATE FUNCTION functions.blast2interpro(text,text) \
                    RETURNS text AS\
                    \$BODY\$set hitL \"\"; set tmp \"\"; set e \"\"\n\
                    spi_exec -array data \"SELECT id_seq, id, start, \\\"end\\\", evalue FROM \$1.blast_hits WHERE db = '\$2' ORDER BY id_seq, evalue\" \{\n\
                        if \{\[lindex \$tmp 0\] eq \$data(id_seq)\} \{\n\
                            if \{\$e < \$data(evalue)\} \{\n\
                                set tmp \"\$data(id_seq) \$data(id) \$data(start) \$data(end)\"\n\
                                set e \$data(evalue)\n\
                            \}\n\
                        \} elseif \{\$tmp ne \"\"\} \{\n\
                            lappend hitL \$tmp\n\
                            set tmp \"\$data(id_seq) \$data(id) \$data(start) \$data(end)\"\n\
                            set e \$data(evalue)\n\
                        \} else \{\n\
                            set tmp \"\$data(id_seq) \$data(id) \$data(start) \$data(end)\"\n\
                            set e \$data(evalue)\n\
                        \}\n\
                    \}\n\
                    if \{\$tmp ne \"\"\} \{\n\
                        lappend hitL \$tmp\n\
                    \}\n\
                    set iprL \"\"; set hitL2 \"\"\n\
                    foreach hit \$hitL \{\n\
                        spi_exec -array data \"SELECT DISTINCT interpro FROM (SELECT interpro, start, \\\"end\\\" FROM refdb.interpro2protein WHERE protein = '\[lindex \$hit 1\]') AS tmp WHERE start < \[lindex \$hit 3\] AND \\\"end\\\" > \[lindex \$hit 2\]\" \{\n\
                            lappend iprL \$data(interpro)\n\
                        \}\n\
                        if \{\$iprL ne \"\"\} \{\n\
                            lappend hitL2 \"\[lindex \$hit 0\] \{\$iprL\}\"\n\
                            set iprL \"\"\n\
                        \}\n\
                    \}\n\
                    unset iprL; set hitL \"\"\n\
                    set goL \"\"\n\
                    foreach hit \$hitL2 \{\n\
                        set tmpString \"\"\n\
                        foreach ipr \[lindex \$hit 1\] \{\n\
                            append tmpString \", '\$ipr'\"\n\
                        \}\n\
                        set tmpString \[string range \$tmpString 2 end\]\n\
                        spi_exec -array data \"SELECT DISTINCT go FROM refdb.interpro2go WHERE interpro IN (\$tmpString)\" \{\n\
                            lappend goL \$data(go)\n\
                        \}\n\
                        lappend hitL \"\[lindex \$hit 0\] \{\[lindex \$hit 1\]\} \{\$goL\}\"\n\
                        set goL \"\"\n\
                    \}\n\
                    unset goL; unset hitL2\n\
                    set hitL \[lsort -unique \$hitL\]\n\
                    foreach hit \$hitL \{\n\
                        foreach ipr \[lindex \$hit 1\] \{\n\
                            spi_exec \"INSERT INTO \$1.interpro_hits VALUES ('\[lindex \$hit 0\]', -1, '\$ipr')\"\n\
                        \}\n\
                        foreach go \[lindex \$hit 2\] \{\n\
                            spi_exec \"INSERT INTO \$1.go_hits VALUES ('\[lindex \$hit 0\]', -1, '\$go')\"\n\
                        \}\n\
                    \}\n\
                    return \"1\"\n\
                    \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #changerun: changes run information
        catch {pg_exec $conn "CREATE FUNCTION functions.changerun(text,text) \
                    RETURNS text AS\
                    \$BODY\$foreach run \$2 \{\n
            spi_exec \"UPDATE \$1.run_info SET description='\[lindex \$run 1\]', treatment='\[lindex \$run 2\]', runs='\[lindex \$run 8\]', sequencer='\[lindex \$run 6\]', type='\[lindex \$run 7\]', datein='\[lindex \$run 9\]', dateout='\[lindex \$run 10\]', data='\[lindex \$run 11\]',  comment='\[lindex \$run 12\]', color='\[lindex \$run 13\]', a_b='\[lindex \$run 14\]' WHERE id_run='\[lindex \$run 0\]';\"\n
            \}; return \"1\"\n\
                    \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #coverage_alt: caculates the average coverage for each contig and updates this information in the seq_info table
        catch {pg_exec $conn "CREATE FUNCTION functions.coverage_alt(text) \
                    RETURNS text AS\
                    \$BODY\$set name \"\"; set coverL \"\"\n\
                    spi_exec -array data \"SELECT \$1.read_hits.name_seq AS name, \$1.read_hits.read_start AS s, \$1.read_hits.read_end AS e, \$1.sequences_nucleotide.length AS length FROM \$1.read_hits INNER JOIN \$1.sequences_nucleotide ON \$1.sequences_nucleotide.name = \$1.read_hits.name_seq ORDER BY \$1.read_hits.name_seq\" \{\n\
                        if \{\$data(name) eq \$name\} \{\n\
                            set cover \[expr \$cover + \$data(e) - \$data(s) + 1\]\n\
                        \} elseif \{\$name ne \"\"\} \{\n\
                            set cover \[expr \$cover.0 / \$len.0\]\n\
                            lappend coverL \"\$name \$cover\"\n\
                            set name \$data(name)\n\
                            set len \$data(length)\n\
                            set cover \[expr \$data(e) - \$data(s) + 1\]\n\
                        \} else \{\n\
                            set name \$data(name)\n\
                            set len \$data(length)\n\
                            set cover \[expr \$data(e) - \$data(s) + 1\]\n\
                        \}\n\
                    \}\n\
                    catch \{\n\
                        set cover \[expr \$cover.0 / \$len.0\]\n\
                        lappend coverL \"\$name \$cover\"\n\
                    \}\n\
                    if \{\$coverL eq \"\"\} \{\n\
                        spi_exec \"UPDATE \$1.seq_info SET coverage=0\"\n\
                    \} else \{\n\
                        foreach cover \$coverL \{\n\
                            spi_exec \"UPDATE \$1.seq_info SET coverage='\[lindex \$cover 1\]' WHERE name='\[lindex \$cover 0\]';\"\n\
                        \}\n\
                    \}\n\
                    return \"1\"\n\
            \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #coverage: caculates the average coverage for each contig and updates this information in the seq_info table
        catch {pg_exec $conn "CREATE FUNCTION functions.coverage(text) \
                    RETURNS text AS\
                    \$BODY\$set coverL \"\"\n\
                    spi_exec -array data \"SELECT id_seq, base_cover, sequence_gap FROM \$1.sequences_nucleotide" \{\n\
                        set length 0\n\
                        set cover 0\n\
                        for \{set i 0\} \{\$i < \[string length \$data(sequence_gap)\]\} \{incr i\} \{\n\
                            if \{\[string index \$data(sequence_gap) \$i\] ne \"*\"\} \{\n\
                                incr length\n\
                                set cover \[expr \$cover + \[lindex \[lindex \$data(base_cover) \$i\] 0\] + \[lindex \[lindex \$data(base_cover) \$i\] 1\] + \[lindex \[lindex \$data(base_cover) \$i\] 2\] + \[lindex \[lindex \$data(base_cover) \$i\] 3\]\]\n\
                            \}\n\
                        \}\n\
                        set cover \[expr \$cover / \$length.0\]\n\
                        lappend coverL \"\$data(id_seq) \$cover\"\n\
                    \}\n\
                    if \{\$coverL eq \"\"\} \{\n\
                        spi_exec \"UPDATE \$1.seq_info SET coverage=0\"\n\
                    \} else \{\n\
                        foreach cover \$coverL \{\n\
                            spi_exec \"UPDATE \$1.seq_info SET coverage='\[lindex \$cover 1\]' WHERE id_seq='\[lindex \$cover 0\]';\"\n\
                        \}\n\
                    \}\n\
                    return \"1\"\n\
                    \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #createdb: creates a new database with all necessary tables
        catch {pg_exec $conn "CREATE FUNCTION functions.cdb(text,text) \
                    RETURNS text AS\
                    \$BODY\$set out \"\"\n\
                    if \{\[catch \{spi_exec \"CREATE SCHEMA \$1;\"\} out\]\} \{\n\
                    return \"Error while creating schema \$1 : \$out\"\n\
                    \} else \{\n\
                    spi_exec \"CREATE TABLE \$1.db_info (nucseq integer, protseq integer, readseq integer, blast integer, \
                    blastprodom integer, coil integer, gene3d integer, go integer, panther integer, \
                    pfam integer, pir integer, smart integer, interpro integer, kegg integer, patternscan integer, \
                    profilescan integer, superfamily integer, tigr integer, minnuc integer, \
                    avgnuc integer, maxnuc integer, minprot integer, avgprot integer, \
                    maxprot integer, minread integer, avgread integer, maxread integer, rAssembled integer, rSingletons integer, n50 integer, gc_content real, at_gc_ratio real);\
                    CREATE TABLE \$1.seq_info (id_seq integer NOT NULL, name text, length integer, \
                    numreads integer, id_prot text, prot integer, blast integer, \
                    blastprodom integer, coil integer, gene3d integer, go integer, interpro integer, \
                    panther integer, patternscan integer, pfam integer, pir integer, \
                    profilescan integer, smart integer, superfamily integer, \
                    tigr integer, kegg integer, gotHits integer, coverage real, CONSTRAINT seq_info_pkey PRIMARY KEY (id_seq)); \
                    CREATE TABLE \$1.prot_info (id_prot integer NOT NULL, name text, length integer, blast integer, \
                    blastprodom integer, coil integer, gene3d integer, go integer, interpro integer, \
                    panther integer, patternscan integer, pfam integer, pir integer, \
                    profilescan integer, smart integer, superfamily integer, \
                    tigr integer, kegg integer, gotHits integer, CONSTRAINT prot_info_pkey PRIMARY KEY (id_prot)); \
                    CREATE TABLE \$1.run_info (id_run text NOT NULL, description text, runs text, \
                    sequencer text, type text, datein text, dateout text, data text, sequences integer, assembled integer, singleton integer, \
                    treatment text, comment text, color text, a_b text, CONSTRAINT run_info_pkey PRIMARY KEY (id_run)); \
                    CREATE TABLE \$1.db_comment (comment text); \
                    CREATE TABLE \$1.blast_hits (id_seq integer NOT NULL, id_prot integer NOT NULL, id text, db text, \
                    \\\"start\\\" integer, \\\"end\\\" integer, length integer, evalue text, score text, perfection text, CONSTRAINT blast_hits_pkey PRIMARY KEY (id_seq, id_prot, id, db)); \
                    CREATE TABLE \$1.blastprodom_hits (id_seq integer NOT NULL, id_prot integer, id text, \
                    \\\"start\\\" integer, \\\"end\\\" integer, length integer, evalue text, CONSTRAINT blastprodom_hits_pkey PRIMARY KEY (id_seq, id_prot, id, start)); \
                    CREATE TABLE \$1.coil_hits (id_seq integer NOT NULL, id_prot integer, id text, \
                    \\\"start\\\" integer, \\\"end\\\" integer, length integer, evalue text, CONSTRAINT coil_hits_pkey PRIMARY KEY (id_seq, id_prot, id, start)); \
                    CREATE TABLE \$1.gene3d_hits (id_seq integer NOT NULL, id_prot integer, id text, \
                    \\\"start\\\" integer, \\\"end\\\" integer, length integer, evalue text, CONSTRAINT gene3d_hits_pkey PRIMARY KEY (id_seq, id_prot, id, start)); \
                    CREATE TABLE \$1.go_hits (id_seq integer NOT NULL, id_prot integer, id text, CONSTRAINT go_hits_pkey PRIMARY KEY (id_seq, id_prot, id)); \
                    CREATE TABLE \$1.interpro_hits (id_seq integer NOT NULL, id_prot integer, id text, CONSTRAINT interpro_hits_pkey PRIMARY KEY (id_seq, id_prot, id)); \
                    CREATE TABLE \$1.kegg_hits (id_seq integer NOT NULL, id text, CONSTRAINT kegg_hits_pkey PRIMARY KEY (id_seq, id)); \
                    CREATE TABLE \$1.panther_hits (id_seq integer NOT NULL, id_prot integer, id text, \
                    \\\"start\\\" integer, \\\"end\\\" integer, length integer, evalue text, CONSTRAINT panther_hits_pkey PRIMARY KEY (id_seq, id_prot, id, start)); \
                    CREATE TABLE \$1.patternscan_hits (id_seq integer NOT NULL, id_prot integer, id text, \
                    \\\"start\\\" integer, \\\"end\\\" integer, length integer, evalue text, CONSTRAINT patternscan_hits_pkey PRIMARY KEY (id_seq, id_prot, id, start)); \
                    CREATE TABLE \$1.pfam_hits (id_seq integer NOT NULL, id_prot integer, id text, \
                    \\\"start\\\" integer, \\\"end\\\" integer, length integer, evalue text, CONSTRAINT pfam_hits_pkey PRIMARY KEY (id_seq, id_prot, id, start)); \
                    CREATE TABLE \$1.pir_hits (id_seq integer NOT NULL, id_prot integer, id text, \
                    \\\"start\\\" integer, \\\"end\\\" integer, length integer, evalue text, CONSTRAINT pir_hits_pkey PRIMARY KEY (id_seq, id_prot, id, start)); \
                    CREATE TABLE \$1.profilescan_hits (id_seq integer NOT NULL, id_prot integer, id text, \
                    \\\"start\\\" integer, \\\"end\\\" integer, length integer, evalue text, CONSTRAINT profilescan_hits_pkey PRIMARY KEY (id_seq, id_prot, id, start)); \
                    CREATE TABLE \$1.smart_hits (id_seq integer NOT NULL, id_prot integer, id text, \
                    \\\"start\\\" integer, \\\"end\\\" integer, length integer, evalue text, CONSTRAINT smart_hits_pkey PRIMARY KEY (id_seq, id_prot, id, start)); \
                    CREATE TABLE \$1.superfamily_hits (id_seq integer NOT NULL, id_prot integer, id text, \
                    \\\"start\\\" integer, \\\"end\\\" integer, length integer, evalue text, CONSTRAINT superfamily_hits_pkey PRIMARY KEY (id_seq, id_prot, id, start)); \
                    CREATE TABLE \$1.tigr_hits (id_seq integer NOT NULL, id_prot integer, id text, \
                    \\\"start\\\" integer, \\\"end\\\" integer, length integer, evalue text, CONSTRAINT tigr_hits_pkey PRIMARY KEY (id_seq, id_prot, id, start)); \
                    CREATE TABLE \$1.read_hits (name_read text NOT NULL, name_seq text NOT NULL, strand text, \
                    seq_start integer, read_start integer, read_end integer, sequence_gap text, CONSTRAINT read_hits_pkey PRIMARY KEY (name_read, name_seq)); \
                    CREATE TABLE \$1.read_distribution (id_seq integer NOT NULL, CONSTRAINT read_distribution_pkey PRIMARY KEY (id_seq)); \
                    CREATE TABLE \$1.go_stat (id text NOT NULL, hits integer); \
                    CREATE TABLE \$1.kegg_stat (id text NOT NULL, ko_num integer, ko_hits integer, id_seqL text); \
                    CREATE TABLE \$1.sequences_read (id_read integer NOT NULL, id_run text NOT NULL, name text NOT NULL, length integer, polya boolean, singleton boolean, sequence text, CONSTRAINT sequences_read_pkey PRIMARY KEY (id_run, \\\"name\\\")); \
                    CREATE TABLE \$1.sequences_protein (id_seq integer NOT NULL, id_prot integer NOT NULL, \\\"name\\\" text, frame text, orf integer, length integer, \\\"sequence\\\" text, CONSTRAINT sequences_protein_pkey PRIMARY KEY (\\\"name\\\", frame, orf)); \
                    CREATE TABLE \$1.sequences_nucleotide (id_seq integer NOT NULL, \\\"name\\\" text, numreads integer, length integer, \\\"sequence\\\" text, sequence_gap text, base_cover text, CONSTRAINT sequences_nucleotide_pkey PRIMARY KEY (\\\"name\\\")); \
                    CREATE TABLE \$1.sequences_nucleotide_description (id_seq integer NOT NULL, blast text, \
                    blastprodom text, gene3d text, go text, interpro text, panther text, patternscan text, \
                    pfam text, pir text, profilescan text, smart text, superfamily text, tigr text, kegg text, comment text, CONSTRAINT sequences_nucleotide_description_pkey PRIMARY KEY (id_seq)); \
                    CREATE TABLE \$1.sequences_protein_description (id_prot integer NOT NULL, blast text, \
                    blastprodom text, gene3d text, go text, interpro text, panther text, patternscan text, \
                    pfam text, pir text, profilescan text, smart text, superfamily text, tigr text, kegg text, comment text, CONSTRAINT sequences_protein_description_pkey PRIMARY KEY (id_prot)); \
                    CREATE TABLE \$1.sequences_nucleotide_primer (id_seq integer NOT NULL, primer_forward_sequence text, primer_reverse_sequence text,\
                    primer_pair_penalty text, primer_forward_penalty text, primer_reverse_penalty text,\
                    primer_forward_pos integer, primer_reverse_pos integer,\
                    primer_forward_len integer, primer_reverse_len integer, primer_forward_tm text,\
                    primer_reverse_tm text, primer_forward_gc text, primer_reverse_gc text,\
                    primer_forward_self_any text, primer_reverse_self_any text, primer_forward_self_end text,\
                    primer_reverse_self_end text, primer_forward_end_stability text,\
                    primer_reverse_end_stability text, primer_pair_compl_any text, primer_pair_compl_end text,\
                    primer_product_size integer, primer_product_tm text, primer_product_tm_oligo_tm_diff text,\
                    primer_pair_t_opt_a text, primer_salt_con text, primer_dna_con text,\
                    CONSTRAINT sequences_nucleotide_primer_pkey PRIMARY KEY (id_seq, primer_forward_sequence, primer_reverse_sequence, primer_salt_con, primer_dna_con)); \
                    CREATE TABLE \$1.sequences_nucleotide_repeat (id_seq integer NOT NULL, unit_length integer, unit text,\
                    \\\"start\\\" integer, \\\"end\\\" integer, length integer, score integer, perfection text, mismatches integer,\
                    insertions integer, deletions integer, num_of_ns integer, CONSTRAINT sequences_nucleotide_repeat_pkey PRIMARY KEY (id_seq, unit_length, unit, start)); \
                    
                    CREATE INDEX seq_info_id_seq_index_\$1 ON \$1.seq_info USING btree (id_seq); \
                    CREATE INDEX prot_info_id_prot_index_\$1 ON \$1.prot_info USING btree (id_prot); \
                    CREATE INDEX read_hits_name_read_index_\$1 ON \$1.read_hits USING btree (name_read); \
                    CREATE INDEX read_hits_name_seq_index_\$1 ON \$1.read_hits USING btree (name_seq); ALTER TABLE \$1.read_hits CLUSTER ON read_hits_name_seq_index_\$1; \
                    CREATE INDEX sequences_read_id_run_index_\$1 ON \$1.sequences_read USING btree (id_run); \
                    CREATE INDEX sequences_read_id_read_index_\$1 ON \$1.sequences_read USING btree (id_read); \
                    CREATE INDEX sequences_read_name_index_\$1 ON \$1.sequences_read USING btree (name); \
                    CREATE INDEX sequences_read_singleton_index_\$1 ON \$1.sequences_read USING btree (name, singleton); \
                    CREATE INDEX sequences_nucleotide_id_seq_index_\$1 ON \$1.sequences_nucleotide USING btree (id_seq); \
                    CREATE INDEX sequences_nucleotide_name_index_\$1 ON \$1.sequences_nucleotide USING btree (name); \
                    CREATE INDEX sequences_protein_id_seq_index_\$1 ON \$1.sequences_protein USING btree (id_seq); ALTER TABLE \$1.sequences_protein CLUSTER ON sequences_protein_id_seq_index_\$1;\
                    CREATE INDEX blast_hits_id_seq_index_\$1 ON \$1.blast_hits USING btree (id_seq); ALTER TABLE \$1.blast_hits CLUSTER ON blast_hits_id_seq_index_\$1; \n\
                    CREATE INDEX blastprodom_hits_id_seq_index_\$1 ON \$1.blastprodom_hits USING btree (id_seq); ALTER TABLE \$1.blastprodom_hits CLUSTER ON blastprodom_hits_id_seq_index_\$1; \n\
                    CREATE INDEX coil_hits_id_seq_index_\$1 ON \$1.coil_hits USING btree (id_seq); ALTER TABLE \$1.coil_hits CLUSTER ON coil_hits_id_seq_index_\$1; \n\
                    CREATE INDEX gene3d_hits_id_seq_index_\$1 ON \$1.gene3d_hits USING btree (id_seq); ALTER TABLE \$1.gene3d_hits CLUSTER ON gene3d_hits_id_seq_index_\$1; \n\
                    CREATE INDEX go_hits_id_seq_index_\$1 ON \$1.go_hits USING btree (id_seq); ALTER TABLE \$1.go_hits CLUSTER ON go_hits_id_seq_index_\$1; \n\
                    CREATE INDEX interpro_hits_id_seq_index_\$1 ON \$1.interpro_hits USING btree (id_seq); ALTER TABLE \$1.interpro_hits CLUSTER ON interpro_hits_id_seq_index_\$1; \n\
                    CREATE INDEX kegg_hits_id_seq_index_\$1 ON \$1.kegg_hits USING btree (id_seq); ALTER TABLE \$1.kegg_hits CLUSTER ON kegg_hits_id_seq_index_\$1; \n\
                    CREATE INDEX panther_hits_id_seq_index_\$1 ON \$1.panther_hits USING btree (id_seq); ALTER TABLE \$1.panther_hits CLUSTER ON panther_hits_id_seq_index_\$1; \n\
                    CREATE INDEX pfam_hits_id_seq_index_\$1 ON \$1.pfam_hits USING btree (id_seq); ALTER TABLE \$1.pfam_hits CLUSTER ON pfam_hits_id_seq_index_\$1; \n\
                    CREATE INDEX patternscan_hits_id_seq_index_\$1 ON \$1.patternscan_hits USING btree (id_seq); ALTER TABLE \$1.patternscan_hits CLUSTER ON patternscan_hits_id_seq_index_\$1; \n\
                    CREATE INDEX pir_hits_id_seq_index_\$1 ON \$1.pir_hits USING btree (id_seq); ALTER TABLE \$1.pir_hits CLUSTER ON pir_hits_id_seq_index_\$1; \n\
                    CREATE INDEX profilescan_hits_id_seq_index_\$1 ON \$1.profilescan_hits USING btree (id_seq); ALTER TABLE \$1.profilescan_hits CLUSTER ON profilescan_hits_id_seq_index_\$1; \n\
                    CREATE INDEX smart_hits_id_seq_index_\$1 ON \$1.smart_hits USING btree (id_seq); ALTER TABLE \$1.smart_hits CLUSTER ON smart_hits_id_seq_index_\$1; \n\
                    CREATE INDEX superfamily_hits_id_seq_index_\$1 ON \$1.superfamily_hits USING btree (id_seq); ALTER TABLE \$1.superfamily_hits CLUSTER ON superfamily_hits_id_seq_index_\$1; \n\
                    CREATE INDEX tigr_hits_id_seq_index_\$1 ON \$1.tigr_hits USING btree (id_seq); ALTER TABLE \$1.tigr_hits CLUSTER ON tigr_hits_id_seq_index_\$1; \n\
                                    
                    spi_exec \"INSERT INTO dbs VALUES ('\$1', '\{\$2 owner\}');\"\n\
                    \}\n\
                    return \"Database \$1 created.\"\n\
                    \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #dbcomment: updates the database comment entry
        catch {pg_exec $conn "CREATE FUNCTION functions.dbcomment(text,text) \
                    RETURNS text AS\n\
                    \$BODY\$spi_exec \"DELETE FROM \$1.db_comment\"\n\
                    spi_exec \"INSERT INTO \$1.db_comment VALUES ('\$2');\"\n\
                    return \"1\"\n\
                    \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #dbinfo: updates the database content information in the db_info table
        catch {pg_exec $conn "CREATE FUNCTION functions.dbinfo(text) \
                    RETURNS text AS\n\
                    \$BODY\$catch \{spi_exec -array data \"CREATE TABLE \$1.db_info (nucseq integer, protseq integer, readseq integer, blast integer, blastprodom integer, coil integer, gene3d integer, go integer, panther integer, pfam integer, pir integer, smart integer, interpro integer, kegg integer, patternscan integer, profilescan integer, superfamily integer, tigr integer, minnuc integer, avgnuc integer, maxnuc integer, minprot integer, avgprot integer, maxprot integer, minread integer, avgread integer, maxread integer, rAssembled integer, rSingletons integer, n50 integer, gc_content real, at_gc_ratio real)\"\}\n\
                    spi_exec -array data \"SELECT COUNT(id_seq) AS n FROM \$1.sequences_nucleotide\" \{set nucseq \$data(n)\}\n\
                    set seq 0\n\
                    set gc 0\n\
                    set ratio 0\n\
                    set n50 0\n\
                    catch \{\n\
                        spi_exec -array data \"SELECT nucseq, gc_content, at_gc_ratio FROM \$1.db_info\" \{\n\
                            set seq \$data(nucseq)\n\
                            set gc \$data(gc_content)\n\
                            set ratio \$data(at_gc_ratio)\n\
                        \}\n\
                    \}\n\
                    if \{\$seq ne \$nucseq\} \{\n\
                        set base_a 0\n\
                        set base_t 0\n\
                        set base_c 0\n\
                        set base_g 0\n\
                        spi_exec -array data \"SELECT sequence FROM \$1.sequences_nucleotide\" \{\n\
                            for \{set i 0\} \{\$i < \[string length \$data(sequence)\]\} \{incr i\} \{\n\
                                switch \[string index \$data(sequence) \$i\] \{\n\
                                    A \{incr base_a\}\n\
                                    T \{incr base_t\}\n\
                                    C \{incr base_c\}\n\
                                    G \{incr base_g\}\n\
                                    a \{incr base_a\}\n\
                                    t \{incr base_t\}\n\
                                    c \{incr base_c\}\n\
                                    g \{incr base_g\}\n\
                                \}\n\
                            \}\n\
                            set gc \[split \[expr (\$base_c.0 + \$base_g.0) / (\$base_c.0 + \$base_g.0 + \$base_a.0 + \$base_t.0) * 100\] .\]\n\
                            set gc \"\[lindex \$gc 0\].\[string range \[lindex \$gc 1\] 0 3\]\"\n\
                            set ratio \[split \[expr (\$base_a.0 + \$base_t.0) / (\$base_c.0 + \$base_g.0)\] .\]\n\
                            set ratio \"\[lindex \$ratio 0\].\[string range \[lindex \$ratio 1\] 0 3\]\"\n\
                        \}\n\
                    \}\n\
                    spi_exec -array data \"SELECT COUNT(id_prot) AS p FROM \$1.sequences_protein\" \{set protseq \$data(p)\}\n\
                    set readseq 0\n\
                    set rAssembled 0\n\
                    set rSingletons 0\n\
                    set minread \"\"\n\
                    catch \{\n\
                        spi_exec -array data \"SELECT COUNT(id_read) AS r FROM \$1.sequences_read\" \{set readseq \$data(r)\}\n\
                        catch \{\n\
                            spi_exec -array data \"SELECT COUNT(name_read) AS r FROM \$1.read_hits\" \{set rAssembled \$data(r)\}\n\
                            set rSingletons \[expr \$readseq - \$rAssembled\]\n\
                        \}\n\
                    \}\n\
                    spi_exec -array data \"SELECT COUNT(id_seq) AS b FROM \$1.blast_hits\" \{set blast \$data(b)\}\n\
                    spi_exec -array data \"SELECT COUNT(id_seq) AS b FROM \$1.blastprodom_hits\" \{set blastprodom \$data(b)\}\n\
                    spi_exec -array data \"SELECT COUNT(id_seq) AS c FROM \$1.coil_hits\" \{set coil \$data(c)\}\n\
                    spi_exec -array data \"SELECT COUNT(id_seq) AS g FROM \$1.gene3d_hits\" \{set gene3d \$data(g)\}\n\
                    spi_exec -array data \"SELECT COUNT(id_seq) AS g FROM \$1.go_hits\" \{set go \$data(g)\}\n\
                    spi_exec -array data \"SELECT COUNT(id_seq) AS i FROM \$1.interpro_hits\" \{set interpro \$data(i)\}\n\
                    spi_exec -array data \"SELECT COUNT(id_seq) AS k FROM \$1.kegg_hits\" \{set kegg \$data(k)\}\n\
                    spi_exec -array data \"SELECT COUNT(id_seq) AS h FROM \$1.panther_hits\" \{set panther \$data(h)\}\n\
                    spi_exec -array data \"SELECT COUNT(id_seq) AS h FROM \$1.pfam_hits\" \{set pfam \$data(h)\}\n\
                    spi_exec -array data \"SELECT COUNT(id_seq) AS h FROM \$1.pir_hits\" \{set pir \$data(h)\}\n\
                    spi_exec -array data \"SELECT COUNT(id_seq) AS h FROM \$1.smart_hits\" \{set smart \$data(h)\}\n\
                    spi_exec -array data \"SELECT COUNT(id_seq) AS p FROM \$1.patternscan_hits\" \{set patternscan \$data(p)\}\n\
                    spi_exec -array data \"SELECT COUNT(id_seq) AS p FROM \$1.profilescan_hits\" \{set profilescan \$data(p)\}\n\
                    spi_exec -array data \"SELECT COUNT(id_seq) AS s FROM \$1.superfamily_hits\" \{set superfamily \$data(s)\}\n\
                    spi_exec -array data \"SELECT COUNT(id_seq) AS t FROM \$1.tigr_hits\" \{set tigr \$data(t)\}\n\
                    set minnuc 0; set avgnuc 0; set maxnuc 0; set clength 0; set ll \"\"\n\
                    catch \{\n\
                        spi_exec -array data \"SELECT MIN(length) AS minnuc FROM \$1.sequences_nucleotide\" \{set minnuc \$data(minnuc)\}\n\
                        spi_exec -array data \"SELECT AVG(length) AS avgnuc FROM \$1.sequences_nucleotide\" \{set avgnuc \[lindex \[split \$data(avgnuc) .\] 0\]\}\n\
                        spi_exec -array data \"SELECT MAX(length) AS maxnuc FROM \$1.sequences_nucleotide\" \{set maxnuc \$data(maxnuc)\}\n\
                        spi_exec -array data \"SELECT SUM(length) AS clength FROM \$1.sequences_nucleotide\" \{\n\
                            if \{\[catch \{set clength \[expr \$data(clength) / 2\]\}\]\} \{\n\
                                set clength 0\n\
                            \}\n\
                        \}\n\
                        spi_exec -array data \"SELECT length FROM \$1.sequences_nucleotide\" \{lappend ll \$data(length)\}\n\
                        set ll \[lsort -real \$ll\]\n\
                        set llnum \[llength \$ll\]\n\
                        set n 0\n\
                        for \{set j 0\} \{\$j < \[llength \$ll\]\} \{incr j\} \{\n\
                            set llnum \[expr \$llnum - 1\]\n\
                            set n \[expr \$n + \[lindex \$ll \$llnum\]\]\n\
                            if \{\$n >= \$clength\} \{\n\
                                set n50 \[lindex \$ll \$llnum\]\n\
                                break\n\
                            \}\n\
                        \}\n\
                    \}\n\
                    unset ll\n\
                    set minprot \"\"\n\
                    catch \{\n\
                        spi_exec -array data \"SELECT MIN(length) AS minprot FROM \$1.sequences_protein\" \{set minprot \$data(minprot)\}\n\
                        spi_exec -array data \"SELECT AVG(length) AS avgprot FROM \$1.sequences_protein\" \{set avgprot \[lindex \[split \$data(avgprot) .\] 0\]\}\n\
                        spi_exec -array data \"SELECT MAX(length) AS maxprot FROM \$1.sequences_protein\" \{set maxprot \$data(maxprot)\}\n\
                    \}\n\
                    set minread \"\"\n\
                    catch \{\n\
                        spi_exec -array data \"SELECT MIN(length) AS minread FROM \$1.sequences_read\" \{set minread \$data(minread)\}\n\
                        spi_exec -array data \"SELECT AVG(length) AS avgread FROM \$1.sequences_read\" \{set avgread \[lindex \[split \$data(avgread) .\] 0\]\}\n\
                        spi_exec -array data \"SELECT MAX(length) AS maxread FROM \$1.sequences_read\" \{set maxread \$data(maxread)\}\n\
                    \}\n\
                    if \{\$minprot eq \"\"\} \{\n\
                        set minprot 0; set avgprot 0; set maxprot 0\n\
                    \}\n\
                    if \{\$minread eq \"\"\} \{\n\
                        set minread 0; set avgread 0; set maxread 0\n\
                    \}\n\
                    catch \{\n\
                        spi_exec -array data \"DELETE FROM \$1.db_info\"\n\
                        spi_exec -array data \"INSERT INTO \$1.db_info VALUES ('\$nucseq', '\$protseq', '\$readseq', '\$blast', '\$blastprodom', '\$coil', '\$gene3d', '\$go', '\$panther', '\$pfam', '\$pir', '\$smart', '\$interpro', '\$kegg', '\$patternscan', '\$profilescan', '\$superfamily', '\$tigr', '\$minnuc', '\$avgnuc', '\$maxnuc', '\$minprot', '\$avgprot', '\$maxprot', '\$minread', '\$avgread', '\$maxread', '\$rAssembled', '\$rSingletons', '\$n50', '\$gc', '\$ratio')\"\n\
                    \}\n\
                    return \"1\"\n\
                    \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #delcontigs: deletes given contigs and all associated data (proteins, hits)
        catch {pg_exec $conn "CREATE FUNCTION functions.delcontigs(text,text) \
                    RETURNS text AS\
                    \$BODY\$foreach del \$2 \{append tmpString \", '\$del'\"\}\n\
                    set tmpString \[string range \$tmpString 2 end\]\n\
                    foreach tab \{blast_hits blastprodom_hits coil_hits gene3d_hits go_hits interpro_hits kegg_hits panther_hits patternscan_hits pfam_hits pir_hits profilescan_hits smart_hits superfamily_hits tigr_hits seq_info sequences_nucleotide sequences_nucleotide_primer sequences_nucleotide_repeat sequences_nucleotide_description sequences_protein\} \{\n\
                        catch \{spi_exec \"DELETE FROM \$1.\$tab WHERE id_seq IN (\$tmpString);\"\}\n\
                    \}\n\
                    return \"1\"
            \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #deletedb: deletes the selected database (or more specific: the database scheme)
        catch {pg_exec $conn "CREATE FUNCTION functions.deldb(text) \
                    RETURNS text AS\
                    \$BODY\$spi_exec \"DROP SCHEMA \$1 CASCADE;\"\n\
                    spi_exec \"DELETE FROM public.dbs WHERE name = '\$1';\"\n\
                    return \"1\"\n\
                    \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #deleterun: deletes the selected run from the run_info table
        catch {pg_exec $conn "CREATE FUNCTION functions.delrun(text,text) \
                    RETURNS text AS\
                    \$BODY\$foreach run \$2 \{\n\
                    append tmpString \", '\$run'\"\n\
                    \}\n\
                    set tmpString \[string range \$tmpString 2 end\]\n\
                    spi_exec \"DELETE FROM \$1.run_info WHERE id_run IN (\$tmpString)\"\n\
                    return \"1\"\
                    \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #delhits: deletes the entries of selected hits from the according hit tables
        catch {pg_exec $conn "CREATE FUNCTION functions.delhits(text,text) \
                    RETURNS text AS\
                    \$BODY\$foreach del \$2 \{\n\
                    if \{\[lindex \$del 0\] eq \"sequences_nucleotide_primer\"\} \{\n\
                    spi_exec \"DELETE FROM \$1.\[lindex \$del 0\] WHERE id_seq = '\[lindex \$del 1\]' AND primer_forward_sequence = '\[lindex \$del 2\]' AND primer_reverse_sequence = '\[lindex \$del 3\]' AND primer_product_size = '\[lindex \$del 4\]';\"\n\
                    \} elseif \{\[lindex \$del 0\] eq \"sequences_nucleotide_repeat\"\} \{\n\
                    spi_exec \"DELETE FROM \$1.\[lindex \$del 0\] WHERE id_seq = '\[lindex \$del 1\]' AND unit_length = '\[lindex \$del 2\]' AND unit = '\[lindex \$del 3\]' AND start = '\[lindex \$del 4\]';\"\n\
                    \} elseif \{\[lindex \$del 0\] eq \"blast_hits\"\} \{\n\
                    spi_exec \"DELETE FROM \$1.\[lindex \$del 0\] WHERE id_seq = '\[lindex \$del 1\]' AND db = '\[lindex \$del 2\]' AND id = '\[lindex \$del 3\]';\"\n\
                    \} elseif \{\[lindex \$del 0\] eq \"kegg_hits\"\} \{\n\
                    spi_exec \"DELETE FROM \$1.\[lindex \$del 0\] WHERE id_seq = '\[lindex \$del 1\]' AND id = '\[lindex \$del 2\]';\"\n\
                    \} else \{\n\
                    spi_exec \"DELETE FROM \$1.\[lindex \$del 0\] WHERE id_seq = '\[lindex \$del 1\]' AND id_prot = '\[lindex \$del 2\]' AND id = '\[lindex \$del 2\]';\"\n\
                        \}\n\
                    \}\n\
                    \$BODY\$LANGUAGE pltcl STRICT;"
        }
        #domain2interpro:
        catch {pg_exec $conn "CREATE FUNCTION functions.domain2interpro(text) \
                    RETURNS text AS\
                    \$BODY\$set iprL \"\"\n\
                    set goL \"\"\n\
                    foreach ref \{blastprodom_hits gene3d_hits panther_hits pfam_hits pir_hits patternscan_hits profilescan_hits smart_hits superfamily_hits tigr_hits\} \{\n\
                    spi_exec -array data \"SELECT DISTINCT \$1.\$ref.id_seq AS id_seq, \$1.\$ref.id_prot AS id_prot, refdb.interpro2domain.interpro AS id FROM \$1.\$ref INNER JOIN refdb.interpro2domain ON \$1.\$ref.id = refdb.interpro2domain.domain ORDER BY id_seq\" \{\n\
                    lappend iprL \"\$data(id_seq) \$data(id_prot) \$data(id)\"\n\
                    \}\n\
                    \}\n\
                    foreach ipr \$iprL \{\n\
                    catch \{spi_exec -array data \"INSERT INTO \$1.interpro_hits VALUES ('\[lindex \$ipr 0\]', '\[lindex \$ipr 1\]', '\[lindex \$ipr 2\]');\"\}\n\
                    \}\n\
                    unset iprL\n\
                    spi_exec -array data \"SELECT DISTINCT \$1.interpro_hits.id_seq AS id_seq, \$1.interpro_hits.id_prot AS id_prot, refdb.interpro2go.go AS go FROM refdb.interpro2go INNER JOIN \$1.interpro_hits ON refdb.interpro2go.interpro = \$1.interpro_hits.id WHERE \$1.interpro_hits.id_prot != -1\" \{\n\
                        lappend goL \"\$data(id_seq) \$data(id_prot) \$data(go)\"\n\
                    \}\n\
                    foreach go \$goL \{\n\
                        catch \{spi_exec \"INSERT INTO \$1.go_hits VALUES ('\[lindex \$go 0\]', '\[lindex \$go 1\]', '\[lindex \$go 2\]');\"\}\n\
                    \}\n\
                    unset goL\n\
                    return \"1\"\
                    \$BODY\$LANGUAGE pltcl STRICT;"
        }
        #getdes: updates the description entries in the sequences_nucleotide_description or sequences_protein_description table
        pg_exec $conn "CREATE FUNCTION functions.getdes(text,text,text) \
                    RETURNS text AS\
                    \$BODY\$if \{\$3 eq \"id_seq\"\} \{\n\
                        catch \{spi_exec \"CREATE TABLE \$1.sequences_nucleotide_description (id_seq integer NOT NULL, blast text, blastprodom text, gene3d text, go text, interpro text, panther text, patternscan text, pfam text, pir text, profilescan text, smart text, superfamily text, tigr text, kegg text, comment text, CONSTRAINT sequences_nucleotide_description_pkey PRIMARY KEY (id_seq));\"\}\n\
                                set qL \"\"\n\
                                spi_exec -array data \"SELECT id_seq FROM \$1.sequences_nucleotide WHERE id_seq NOT IN (SELECT id_seq FROM \$1.sequences_nucleotide_description)\" \{\n\
                                lappend qL \$data(id_seq)\n\
                                \}\n\
                                foreach ent \$qL \{\n\
                                spi_exec \"INSERT INTO \$1.sequences_nucleotide_description VALUES ('\$ent', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '')\"\n\
                                \}\n\
                    \} elseif \{\$3 eq \"id_prot\"\} \{\n\
                        catch \{spi_exec \"CREATE TABLE \$1.sequences_protein_description (id_prot integer NOT NULL, blast text, blastprodom text, gene3d text, go text, interpro text, panther text, patternscan text, pfam text, pir text, profilescan text, smart text, superfamily text, tigr text, kegg text, comment text, CONSTRAINT sequences_protein_description_pkey PRIMARY KEY (id_prot));\"\}\n\
                                set qL \"\"\n\
                                spi_exec -array data \"SELECT id_prot FROM \$1.sequences_protein WHERE id_prot NOT IN (SELECT id_prot FROM \$1.sequences_protein_description)\" \{\n\
                                lappend qL \$data(id_prot)\n\
                                \}\n\
                                foreach ent \$qL \{\n\
                                spi_exec \"INSERT INTO \$1.sequences_protein_description VALUES ('\$ent', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '')\"\n\
                                \}\n\
                    \}\n\
                    if \{\$2 eq \"all\"\} \{\n\
                        set featL \"blastprodom coil gene3d go panther pfam pir interpro patternscan profilescan smart superfamily tigr kegg blast\"\n\
                    \} else \{\n\
                        set featL \$2\n\
                    \}\n\
                    foreach feat \$featL \{\n\
                        set resL \"\"\n\
                        set f \$feat\n\
                        set tab \$f; append tab \"_hits\"\n\
                        if \{\$f eq \"go\"\} \{\n\
                            spi_exec -array data \"SELECT DISTINCT \$1.\$tab.\$3 AS id, \$1.\$tab.id AS refid, refdb.\$feat.name AS description FROM \$1.\$tab INNER JOIN refdb.\$feat ON refdb.\$feat.id = \$1.\$tab.id\" \{\n\
                                lappend resL \"\$data(id) \{\$data(description) ; \$data(refid)\}\"\n\
                            \}\n\
                        \} elseif \{\$f eq \"blast\"\} \{\n\
                            spi_exec -array data \"SELECT DISTINCT db FROM \$1.\$tab\" \{\n\
                                lappend refL \$data(db)\n\
                            \}\n\
                            foreach f \$refL \{\n\
                                catch \{\n\
                                    set id \"\"\n\
                                    set refid \"\"\n\
                                    set evalue 100\n\
                                    spi_exec -array data \"SELECT \$1.\$tab.\$3 AS id, \$1.\$tab.id AS refid, refdb.\$f.description AS description, refdb.\$f.product AS product, \$1.\$tab.evalue AS evalue FROM \$1.\$tab INNER JOIN refdb.\$f ON refdb.\$f.id = \$1.\$tab.id ORDER BY \$1.\$tab.\$3\" \{\n\
                                        if \{\$data(id) eq \$id\} \{\n\
                                            if \{\$data(evalue) < \$evalue\} \{\n\
                                                set evalue \$data(evalue)\n\
                                                set refid \$data(refid)\n\
                                                set description \$data(product)\n\
                                                if \{\$description eq \"\"\} \{\n\
                                                    set description \$data(description)\n\
                                                \} else \{\n\
                                                    if \{\$data(description) ne \"\"\} \{\n\
                                                        append description \" ; \$data(description)\"\n\
                                                    \}\n\
                                                \}\n\
                                            \}\n\
                                        \} else \{\n\
                                            if \{\$id eq \"\"\} \{\n\
                                                set id \$data(id)\n\
                                                set evalue \$data(evalue)\n\
                                                set refid \$data(refid)\n\
                                                set description \$data(product)\n\
                                                if \{\$description eq \"\"\} \{\n\
                                                    set description \$data(description)\n\
                                                \} else \{\n\
                                                    if \{\$data(description) ne \"\"\} \{\n\
                                                        append description \" ; \$data(description)\"\n\
                                                    \}\n\
                                                \}\n\
                                            \} else \{\n\
                                                lappend restmp \"\$id \$f \{\$description; \$refid\}\"\n\
                                                set id \$data(id)\n\
                                                set evalue \$data(evalue)\n\
                                                set refid \$data(refid)\n\
                                                set description \$data(product)\n\
                                                if \{\$description eq \"\"\} \{\n\
                                                    set description \$data(description)\n\
                                                \} else \{\n\
                                                    if \{\$data(description) ne \"\"\} \{\n\
                                                        append description \" ; \$data(description)\"\n\
                                                    \}\n\
                                                \}\n\
                                            \}\n\
                                        \}\n\
                                    \}\n\
                                    lappend restmp \"\$id \$f \{\$description; \$refid\}\"\n\
                                \}\n\
                            \}\n\
                            set restmp \[lsort -unique \$restmp\]\n\
                            set id \"\"\n\
                            foreach res \$restmp \{\n\
                                if \{\$id eq \[lindex \$res 0\]\} \{\n\
                                    append description \" \{\[lindex \$res 1\] \{\[lindex \$res 2\]\}\}\"\n\
                                \} else \{\n\
                                    if \{\$id eq \"\"\} \{\n\
                                        set id \[lindex \$res 0\]\n\
                                        set description \"\{\[lindex \$res 1\] \{\[lindex \$res 2\]\}\}\"\n\
                                    \} else \{\n\
                                        lappend resL \"\$id \{\$description\}\"\n\
                                        set id \[lindex \$res 0\]\n\
                                        set description \"\{\[lindex \$res 1\] \{\[lindex \$res 2\]\}\}\"\n\
                                    \}\n\
                                \}\n\
                            \}\n\
                            lappend resL \"\$id \{\$description\}\"\n\
                        \} elseif \{\$f eq \"interpro\"\} \{\n\
                            spi_exec -array data \"SELECT DISTINCT \$1.\$tab.\$3 AS id, \$1.\$tab.id AS refid, refdb.\$feat.description AS description FROM \$1.\$tab INNER JOIN refdb.\$feat ON refdb.\$feat.id = \$1.\$tab.id\" \{\n\
                                lappend resL \"\$data(id) \{\$data(description) ; \$data(refid)\}\"\n\
                            \}\n\
                        \} elseif \{\$f eq \"kegg\"\} \{\n\
                            catch \{spi_exec -array data \"SELECT DISTINCT \$1.\$tab.\$3 AS id, \$1.\$tab.id AS refid, refdb.kegg.name AS name, refdb.kegg.description AS description FROM \$1.\$tab INNER JOIN refdb.kegg ON refdb.kegg.id = \$1.\$tab.id\" \{\n\
                                if \{\$data(description) ne \"\"\} \{\n\
                                    lappend resL \"\$data(id) \{\$data(description) ; \$data(refid)\}\"\n\
                                \} else \{\n\
                                    lappend resL \"\$data(id) \{\$data(name) ; \$data(refid)\}\"\n\
                                \}\n\
                            \}\}\n\
                        \} else \{\n\
                            set id \"\"\n\
                            set evalue 100\n\
                            spi_exec -array data \"SELECT \$1.\$tab.\$3 AS id, \$1.\$tab.id AS refid, refdb.\$feat.description AS description, \$1.\$tab.evalue AS evalue FROM \$1.\$tab INNER JOIN refdb.\$feat ON refdb.\$feat.id = \$1.\$tab.id ORDER BY \$1.\$tab.\$3\" \{\n\
                                if \{\$data(id) eq \$id\} \{\n\
                                    if \{\$data(evalue) < \$evalue\} \{\n\
                                        set evalue \$data(evalue)\n\
                                        set description \"\$data(description) ; \$data(refid)\"\n\
                                    \}\n\
                                \} else \{\n\
                                    if \{\$id eq \"\"\} \{\n\
                                        set id \$data(id)\n\
                                        set evalue \$data(evalue)\n\
                                        set description \"\$data(description) ; \$data(refid)\"\n\
                                    \} else \{\n\
                                        lappend resL \"\$id \{\$description\}\"\n\
                                        set id \$data(id)\n\
                                        set evalue \$data(evalue)\n\
                                        set description \"\$data(description) ; \$data(refid)\"\n\
                                    \}\n\
                                \}\n\
                            \}\n\
                            if \{\$id ne \"\"\} \{\n\
                                lappend resL \"\$id \{\$description\}\"\n\
                            \}\n\
                        \}\n\
                        set resL \[lsort -unique \$resL\]\n\
                        set id \"\"; set des \"\"\n\
                        foreach res \$resL \{\n\
                            if \{\[lindex \$res 0\] ne \$id\} \{\n\
                                set des \[regsub -all \{'\} \[lindex \$res 1\] \"''\"\]\n\
                                if \{\$3 eq \"id_seq\"\} \{\n\
                                    if \{\[catch \{spi_exec \"UPDATE \$1.sequences_nucleotide_description SET \$feat='\$des' WHERE id_seq = '\[lindex \$res 0\]';\"\} out\]\} \{return \$out\}\n\
                                \} elseif \{\$3 eq \"id_prot\"\} \{\n\
                                    if \{\[catch \{spi_exec \"UPDATE \$1.sequences_protein_description SET \$feat='\$des' WHERE id_prot = '\[lindex \$res 0\]';\"\} out\]\} \{return \$out\}\n\
                                \}\n\
                            \}\n\
                            set id \[lindex \$res 0\]\n\
                        \}\n\
                        unset resL; unset des; unset id\n\
                    \}\n\
                    return \"1\"\
                    \$BODY\$LANGUAGE 'pltcl' STRICT;"
        #gostat: updates the go statistics (go tree)
        catch {pg_exec $conn "CREATE FUNCTION functions.gostat(text) \
                    RETURNS text AS\
                    \$BODY\$catch \{spi_exec \"CREATE TABLE \$1.go_stat (id text NOT NULL, hits integer);\"\}\n\
                    spi_exec \"DELETE FROM \$1.go_stat;\"\n\
                    spi_exec -array data \"SELECT id FROM refdb.gotree\" \{\n\
                    lappend goL \$data(id)\n\
                    set goStatArr(\$data(id)) 0\n\
                    \}\n\
                    set nucL \"\"\n\
                    spi_exec -array data \"SELECT DISTINCT id_seq FROM \$1.go_hits\" \{\n\
                    lappend nucL \$data(id_seq)\n\
                    \}\n\
                    foreach nuc \$nucL \{\n\
                    set ancestorL \"\"\n\
                    spi_exec -array data \"SELECT member_of FROM refdb.gotree WHERE id IN (SELECT main_id FROM refdb.go INNER JOIN \$1.go_hits ON refdb.go.id = \$1.go_hits.id WHERE \$1.go_hits.id_seq = '\$nuc');\" \{\n\
                        append ancestorL \" \$data(member_of)\"\n\
                    \}\n\
                    set ancestorL \[lsort -unique \$ancestorL\]\n\
                    foreach ancestor \$ancestorL \{\n\
                        incr goStatArr(\$ancestor)\n\
                    \}\n\
                \}\n\
                unset nucL\n\
                set sql \"\"\n\
                foreach go \$goL \{\n\
                    append sql \"INSERT INTO \$1.go_stat VALUES ('\$go', '\$goStatArr(\$go)');\"\n\
                \}\n\
                unset goL\n\
                spi_exec \"\$sql\"\n\
                return \"1\"\n\
                \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #gostat: updates the kegg hits and maps
        catch {pg_exec $conn "CREATE FUNCTION functions.kegg(text) \
                    RETURNS text AS\
                    \$BODY\$spi_exec \"DELETE FROM \$1.kegg_hits\"\n\
                    spi_exec \"INSERT INTO \$1.kegg_hits(id_seq, id) SELECT DISTINCT id_seq, id FROM (SELECT DISTINCT \$1.blast_hits.id_seq AS id_seq, refdb.kegg2protein.id_ko AS id FROM \$1.blast_hits INNER JOIN refdb.kegg2protein ON refdb.kegg2protein.protein = \$1.blast_hits.id UNION ALL SELECT DISTINCT \$1.go_hits.id_seq AS id_seq, refdb.kegg2go.ko AS id FROM \$1.go_hits INNER JOIN refdb.kegg2go ON refdb.kegg2go.go = \$1.go_hits.id ORDER BY id_seq) A\"\n\
                    catch \{spi_exec \"CREATE TABLE \$1.kegg_stat (id text NOT NULL, ko_num integer, ko_hits integer, id_seqL text);\"\}\n\
                    spi_exec \"DELETE FROM \$1.kegg_stat;\"\n\
                    spi_exec -array data \"SELECT DISTINCT id_map, id_ko FROM refdb.kegg_maps\" \{\n\
                        lappend keggL \"\$data(id_map) \[llength \$data(id_ko)\] \{\$data(id_ko)\}\"\n\
                    \}\n\
                    foreach map \$keggL \{\n\
                        set idL \"\"; set id_seqL \"\"; set tmpString \"\"\n\
                        foreach ko \[lindex \$map 2\] \{\n\
                            append tmpString \", '\$ko'\"\n\
                        \}\n\
                        set tmpString \[string range \$tmpString 2 end\]\n\
                        if \{\$tmpString ne \"\"\} \{\n\
                            spi_exec -array data \"SELECT id_seq, id FROM \$1.kegg_hits WHERE id IN (\$tmpString) ORDER BY id_seq\" \{\n\
                                lappend id_seqL \$data(id_seq)\n\
                                lappend idL \$data(id)\n\
                            \}\n\
                            set id_seqL \[lsort -unique \$id_seqL\]\n\
                            set idL \[lsort -unique \$idL\]\n\
                            append sql \"INSERT INTO \$1.kegg_stat(id, ko_num, ko_hits, id_seql) VALUES ('\[lindex \$map 0\]', '\[lindex \$map 1\]', '\[llength \$idL\]', '\$id_seqL'); \"\n\
                        \}\n\
                    \}\n\
                    unset keggL; unset idL; unset id_seqL; unset tmpString\n\
                    spi_exec \$sql\n\
                    unset sql; return \"1\"
            \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #newnuc: adds a nucleotide entry to the sequences_nucleotide, sequences_nucleotide_description and seq_info table
        catch {pg_exec $conn "CREATE FUNCTION functions.newnuc(text,text,text) \
                    RETURNS text AS\
                    \$BODY\$set num -1\n\
                    catch \{\n\
                    spi_exec -array data \"SELECT MAX(id_seq) AS n FROM \$1.sequences_nucleotide\" \{\n\
                    set num \$data(n)\n\
                    \}\n\
                    \}\n\
                    incr num\n\
                    catch \{\n\
                    spi_exec \"INSERT INTO \$1.sequences_nucleotide VALUES ('\$num', '\[lindex \$2 0\]', '\[lindex \$2 1\]', '\[lindex \$2 2\]', '\[lindex \$2 3\]', '', '');\"\n\
                    spi_exec \"INSERT INTO \$1.sequences_nucleotide_description VALUES ('\$num', '', '', '', '', '', '', '', '', '', '', '', '', '', '\$3');\"\n\
                    spi_exec \"INSERT INTO \$1.seq_info VALUES ('\$num', '\[lindex \$2 0\]', '\[lindex \$2 2\]', '\[lindex \$2 1\]', '', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');\"\n\
                    \}\n\
                    return \"1\"
                    \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #nuccomment: updates the contig comment entry
        catch {pg_exec $conn "CREATE FUNCTION functions.nuccomment(text,text,text) \
                    RETURNS text AS\
                    \$BODY\$set in 0\n\
                    catch \{\n\
                    spi_exec -array data \"SELECT id_seq FROM \$1.sequences_nucleotide_description WHERE id_seq = '\$2'\" \{\n\
                    set in 1\n\
                    \}\n\
                    \}\n\
                    if \{\$in\} \{\n\
                    spi_exec \"UPDATE \$1.sequences_nucleotide_description SET comment='\$3' WHERE id_seq = '\$2';\"\n\
                    \} else \{\n\
                    spi_exec \"INSERT INTO \$1.sequences_nucleotide_description VALUES ('\$2', '', '', '', '', '', '', '', '', '', '', '', '', '', '');\"\n\
                    spi_exec \"UPDATE \$1.sequences_nucleotide_description SET comment='\$3' WHERE id_seq = '\$2';\"\n\
                    \}\n\
                    return \"1\"
            \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #protcomment: updates the protein comment entry
        catch {pg_exec $conn "CREATE FUNCTION functions.protcomment(text,text,text) \
                    RETURNS text AS\
                    \$BODY\$set in 0\n\
                    catch \{\n\
                    spi_exec -array data \"SELECT id_prot FROM \$1.sequences_protein_description WHERE id_prot = '\$2'\" \{\n\
                    set in 1\n\
                    \}\n\
                    \}\n\
                    if \{\$in\} \{\n\
                    spi_exec \"UPDATE \$1.sequences_protein_description SET comment='\$3' WHERE id_prot = '\$2';\"\n\
                    \} else \{\n\
                    spi_exec \"INSERT INTO \$1.sequences_protein_description VALUES ('\$2', '', '', '', '', '', '', '', '', '', '', '', '', '', '');\"\n\
                    spi_exec \"UPDATE \$1.sequences_protein_description SET comment='\$3' WHERE id_prot = '\$2';\"\n\
                    \}\n\
                    return \"1\"
            \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #readStatus: updates the singleton-state of the sequences_read table
        catch {pg_exec $conn "CREATE FUNCTION functions.readstatus(text) \
                    RETURNS text AS\
                    \$BODY\$set tmpString \"\"\n\
                    spi_exec \"UPDATE \$1.sequences_read SET singleton=TRUE\"\n\
                    spi_exec \"UPDATE \$1.sequences_read SET singleton=FALSE FROM \$1.read_hits WHERE \$1.sequences_read.name = \$1.read_hits.name_read\"\n\
                    set runL \"\"\n\
                    spi_exec -array data \"SELECT id_run FROM \$1.run_info\" \{\n\
                        lappend runL \$data(id_run)\n\
                    \}\n\
                    foreach run \$runL \{\n\
                        spi_exec \"UPDATE \$1.run_info SET sequences=(SELECT COUNT(name) FROM \$1.sequences_read WHERE id_run = '\$run'), assembled=(SELECT COUNT(name) FROM \$1.sequences_read WHERE id_run = '\$run' AND singleton = FALSE), singleton=(SELECT COUNT(name) FROM \$1.sequences_read WHERE id_run = '\$run' AND singleton = TRUE) WHERE id_run = '\$run'\"
                    \}\n\
                    unset runL\n\
                    return 1\n\
            \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #readDistribution: updates the read distribution of the contigs in the read_distribution table
        pg_exec $conn "CREATE FUNCTION functions.readdistribution(text) \
                    RETURNS text AS\
                    \$BODY\$set runL \"\"\n\
                    catch \{spi_exec \"CREATE TABLE \$1.read_distribution (id_seq integer NOT NULL, CONSTRAINT read_distribution_pkey PRIMARY KEY (id_seq));\"\}\n\
                    spi_exec -array data  \"SELECT DISTINCT id_run FROM \$1.run_info\" \{\n\
                        lappend runL \$data(id_run)\n\
                    \}\n\
                    if \{\$runL ne \"\"\} \{\n\
                        foreach run \$runL \{\n\
                            catch \{spi_exec \"ALTER TABLE \$1.read_distribution ADD COLUMN runID_\$run integer;\"\}\n\
                        \}\n\
                        spi_exec \"DELETE FROM \$1.read_distribution\"\n\
                        spi_exec -array data \"SELECT DISTINCT id_seq FROM \$1.sequences_nucleotide\" \{\n\
                            foreach run \$runL \{\n\
                                set resArr(\$data(id_seq).\$run) 0\n\
                            \}\n\
                            lappend nucL \$data(id_seq)\n\
                        \}\n\
                        spi_exec -array data \"SELECT \$1.sequences_nucleotide.id_seq AS id_seq, A.id_run AS run, A.num AS num \n\
                        FROM \$1.sequences_nucleotide INNER JOIN (SELECT COUNT(\$1.read_hits.name_read) AS num, \$1.read_hits.name_seq AS name_seq, \$1.sequences_read.id_run AS id_run \n\
                        FROM \$1.read_hits INNER JOIN \$1.sequences_read ON \$1.read_hits.name_read = \$1.sequences_read.name \n\
                        GROUP BY \$1.read_hits.name_seq, \$1.sequences_read.id_run) A ON \$1.sequences_nucleotide.name = A.name_seq ORDER BY id_seq;\" \{\n\
                            set resArr(\$data(id_seq).\$data(run)) \$data(num)\n\
                        \}\n\
                        foreach nuc \$nucL \{\n\
                            set columns \"\"; set values \"\"\n\
                            foreach run \$runL \{\n\
                                append columns \", runid_\$run\"\n\
                                append values \", \$resArr(\$nuc.\$run)\"\n\
                                unset resArr(\$nuc.\$run)\n\
                            \}\n\
                            set sql \"INSERT INTO \$1.read_distribution (id_seq\$columns) VALUES (\$nuc\$values)\"\n\
                            spi_exec \"\$sql\"\n\
                        \}\n\
                        unset columns; unset values; unset sql\n\
                        return 1\n\
                    \}\n\
                    return \"No runs available.\"\n\
                    \$BODY\$LANGUAGE 'pltcl' STRICT;"
        
        #seqinfo: updates the sequence info in the seq_info table
        catch {pg_exec $conn "CREATE FUNCTION functions.seqinfo(text,text) \
            RETURNS text AS\
                    \$BODY\$catch \{\n\
                        spi_exec \"CREATE TABLE \$1.seq_info (id_seq integer NOT NULL, name text, length integer, \
                                numreads integer, id_prot text, prot integer, blast integer, \
                                blastprodom integer, coil integer, gene3d integer, go integer, interpro integer, \
                                panther integer, patternscan integer, pfam integer, pir integer, \
                                profilescan integer, smart integer, superfamily integer, \
                                tigr integer, kegg integer, gotHits integer, coverage real);\"\n\
                        \}\n\
                        set nucL \"\"\n\
                        spi_exec -array data \"SELECT id_seq, name, length, numreads FROM \$1.sequences_nucleotide WHERE id_seq NOT IN (SELECT id_seq FROM \$1.seq_info)\" \{\n\
                            lappend nucL \"\$data(id_seq) \{\$data(name)\} \$data(length) \$data(numreads)\"\n\
                        \}\n\
                        foreach nuc \$nucL \{\n\
                            spi_exec \"INSERT INTO \$1.seq_info VALUES ('\[lindex \$nuc 0\]', '\[lindex \$nuc 1\]', '\[lindex \$nuc 2\]', '\[lindex \$nuc 3\]', '', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0')\"\n\
                        \}\n\
                        unset nucL\n\
                    if \{\$2 eq \"all\"\} \{\n\
                        foreach ref \{sequences_protein blast_hits blastprodom_hits coil_hits gene3d_hits go_hits interpro_hits kegg_hits panther_hits patternscan_hits pfam_hits pir_hits profilescan_hits smart_hits superfamily_hits tigr_hits\} \{\n\
                            if \{\$ref eq \"sequences_protein\"\} \{\n\
                                spi_exec \"UPDATE \$1.seq_info set prot=A.num FROM (SELECT DISTINCT id_seq, COUNT(id_seq) AS num FROM \$1.sequences_protein GROUP BY id_seq) A WHERE seq_info.id_seq = A.id_seq;\"\n\
                                set id \"\"; set tmpL \"\"; set protL \"\"\n\
                                spi_exec -array data \"SELECT id_seq, id_prot FROM \$1.sequences_protein\" \{\n\
                                    if \{\$id eq \$data(id_seq)\} \{\n\
                                        lappend tmpL \$data(id_prot)\n\
                                    \} elseif \{\$id eq \"\"\} \{\n\
                                        set tmpL \$data(id_prot)\n\
                                        set id \$data(id_seq)\n\
                                    \} else \{\n\
                                        lappend protL \"\$id \{\$tmpL\}\"\n\
                                        set id \$data(id_seq)\n\
                                        set tmpL \$data(id_prot)\n\
                                    \}\n\
                                \}\n\
                                if \{\$id ne \"\"\} \{\n\
                                    lappend protL \"\$id \{\$tmpL\}\"\n\
                                \}\n\
                                unset id; unset tmpL\n\
                                set protL \[lsort -unique \$protL\]\n\
                                foreach prot \$protL \{\n\
                                    spi_exec \"UPDATE \$1.seq_info SET id_prot='\[lindex \$prot 1\]' WHERE id_seq='\[lindex \$prot 0\]';\"\n\
                                \}\n\
                                unset protL\n\
                            \} else \{\n\
                                set col \[lindex \[split \$ref _\] 0\]\n\
                                spi_exec \"UPDATE \$1.seq_info set \$col=A.num FROM (SELECT DISTINCT id_seq, COUNT(id_seq) AS num FROM \$1.\$ref GROUP BY id_seq) A WHERE seq_info.id_seq = A.id_seq;\"\n\
                            \}\n\
                        \}\n\
                        spi_exec \"UPDATE \$1.seq_info set gothits=1 WHERE blast + blastprodom + coil + gene3d + go + interpro + kegg + panther + patternscan + pfam + pir + profilescan + smart + superfamily + tigr != 0;\"\n\
                    \} else \{\n\
                        if \{\$2 eq \"end\"\} \{\n\
                            set nuc \"\'0\'\"\n\
                            spi_exec -array data \"SELECT MAX(id_seq) AS n FROM \$1.sequences_nucleotide\" \{\n\
                                catch \{set nuc \"'\[expr \$data(n) + 1\]'\"\}\n\
                            \}\n\
                        \} else \{\n\
                            foreach ent \$2 \{\n\
                                append nuc \", '\$ent'\"\n\
                            \}\n\
                            set nuc \[string range \$nuc 2 end\]\n\
                        \}\n\
                        foreach ref \{sequences_protein blast_hits blastprodom_hits coil_hits gene3d_hits go_hits interpro_hits kegg_hits panther_hits patternscan_hits pfam_hits pir_hits profilescan_hits smart_hits superfamily_hits tigr_hits\} \{\n\
                            if \{\$ref eq \"sequences_protein\"\} \{\n\
                                spi_exec \"UPDATE \$1.seq_info set prot=A.num FROM (SELECT DISTINCT id_seq, COUNT(id_seq) AS num FROM \$1.sequences_protein WHERE id_seq IN (\$nuc) GROUP BY id_seq) A WHERE seq_info.id_seq = A.id_seq;\"\n\
                                set id \"\"; set tmpL \"\"; set protL \"\"\n\
                                spi_exec -array data \"SELECT id_seq, id_prot FROM \$1.sequences_protein\" \{\n\
                                    if \{\$id eq \$data(id_seq)\} \{\n\
                                        lappend tmpL \$data(id_prot)\n\
                                    \} elseif \{\$id eq \"\"\} \{\n\
                                        set tmpL \$data(id_prot)\n\
                                        set id \$data(id_seq)\n\
                                    \} else \{\n\
                                        lappend protL \"\$id \{\$tmpL\}\"\n\
                                        set id \$data(id_seq)\n\
                                        set tmpL \$data(id_prot)\n\
                                    \}\n\
                                \}\n\
                                if \{\$id ne \"\"\} \{\n\
                                    lappend protL \"\$id \{\$tmpL\}\"\n\
                                \}\n\
                                unset id; unset tmpL\n\
                                set protL \[lsort -unique \$protL\]\n\
                                foreach prot \$protL \{\n\
                                    spi_exec \"UPDATE \$1.seq_info SET id_prot='\[lindex \$prot 1\]' WHERE id_seq='\[lindex \$prot 0\]';\"\n\
                                \}\n\
                                unset protL\n\
                            \} else \{\n\
                                set col \[lindex \[split \$ref _\] 0\]\n\
                                spi_exec \"UPDATE \$1.seq_info set \$col=A.num FROM (SELECT DISTINCT id_seq, COUNT(id_seq) AS num FROM \$1.\$ref WHERE id_seq IN (\$nuc) GROUP BY id_seq) A WHERE seq_info.id_seq = A.id_seq;\"\n\
                            \}\n\
                        \}\n\
                        spi_exec \"UPDATE \$1.seq_info set gothits=1 WHERE blast + blastprodom + coil + gene3d + go + interpro + kegg + panther + patternscan + pfam + pir + profilescan + smart + superfamily + tigr != 0 AND id_seq IN (\$nuc);\"\n\
                        unset nuc\n\
                    \}\n\
                    return 1\n\
            \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
        #seqinfo: updates the protein info in the prot_info table
        catch {pg_exec $conn "CREATE FUNCTION functions.protinfo(text,text) \
            RETURNS text AS\
                    \$BODY\$catch \{\n\
                        spi_exec \"CREATE TABLE \$1.prot_info (id_prot integer NOT NULL, name text, length integer, blast integer, \
                                blastprodom integer, coil integer, gene3d integer, go integer, interpro integer, \
                                panther integer, patternscan integer, pfam integer, pir integer, \
                                profilescan integer, smart integer, superfamily integer, \
                                tigr integer, kegg integer, gotHits integer);\"\n\
                        \}\n\
                        set protL \"\"\n\
                        spi_exec -array data \"SELECT id_prot, name, length FROM \$1.sequences_protein WHERE id_prot NOT IN (SELECT id_prot FROM \$1.prot_info)\" \{\n\
                            lappend protL \"\$data(id_prot) \{\$data(name)\} \$data(length)\"\n\
                        \}\n\
                        foreach prot \$protL \{\n\
                            spi_exec \"INSERT INTO \$1.prot_info VALUES ('\[lindex \$prot 0\]', '\[lindex \$prot 1\]', '\[lindex \$prot 2\]', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0')\"\n\
                        \}\n\
                        unset protL\n\
                    if \{\$2 eq \"all\"\} \{\n\
                        foreach ref \{blast_hits blastprodom_hits coil_hits gene3d_hits go_hits interpro_hits kegg_hits panther_hits patternscan_hits pfam_hits pir_hits profilescan_hits smart_hits superfamily_hits tigr_hits\} \{\n\
                            set col \[lindex \[split \$ref _\] 0\]\n\
                            catch \{spi_exec \"UPDATE \$1.prot_info set \$col=A.num FROM (SELECT DISTINCT id_prot, COUNT(id_prot) AS num FROM \$1.\$ref GROUP BY id_prot) A WHERE prot_info.id_prot = A.id_prot;\"\}\n\
                        \}\n\
                        spi_exec \"UPDATE \$1.prot_info set gothits=1 WHERE blast + blastprodom + coil + gene3d + go + interpro + kegg + panther + patternscan + pfam + pir + profilescan + smart + superfamily + tigr != 0;\"\n\
                    \} else \{\n\
                        if \{\$2 eq \"end\"\} \{\n\
                            set nuc \"\'0\'\"\n\
                            spi_exec -array data \"SELECT MAX(id_prot) AS n FROM \$1.sequences_protein\" \{\n\
                                catch \{set prot \"'\[expr \$data(n) + 1\]'\"\}\n\
                            \}\n\
                        \} else \{\n\
                            foreach ent \$2 \{\n\
                                append prot \", '\$ent'\"\n\
                            \}\n\
                            set nuc \[string range \$prot 2 end\]\n\
                        \}\n\
                        foreach ref \{blast_hits blastprodom_hits coil_hits gene3d_hits go_hits interpro_hits kegg_hits panther_hits patternscan_hits pfam_hits pir_hits profilescan_hits smart_hits superfamily_hits tigr_hits\} \{\n\
                            set col \[lindex \[split \$ref _\] 0\]\n\
                            catch \{spi_exec \"UPDATE \$1.prot_info set \$col=A.num FROM (SELECT DISTINCT id_prot, COUNT(id_prot) AS num FROM \$1.\$ref WHERE id_prot IN (\$prot) GROUP BY id_prot) A WHERE prot_info.id_prot = A.id_prot;\"\}\n\
                        \}\n\
                        spi_exec \"UPDATE \$1.prot_info set gothits=1 WHERE blast + blastprodom + coil + gene3d + go + interpro + kegg + panther + patternscan + pfam + pir + profilescan + smart + superfamily + tigr != 0 AND id_prot IN (\$prot);\"\n\
                        unset prot\n\
                    \}\n\
                    return 1\n\
            \$BODY\$LANGUAGE 'pltcl' STRICT;"
        }
    }
    pg_disconnect $conn
}

#grants access to all tables of the database
proc grantToDB {dbName uName mode} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    catch {revokeOnDB $dbName $uName}
    catch {
        pg_select $conn "SELECT tablename FROM pg_tables WHERE schemaname = '[string tolower $dbName]'" data {
            lappend refs $data(tablename)
        }
        pg_select $conn "SELECT owner FROM dbs WHERE name = '$dbName'" data {
            set owner $data(owner)           
        }
        if {$mode eq "all"} {
            foreach ref $refs {
                pg_exec $conn "GRANT ALL ON SCHEMA $dbName TO $uName"
                pg_exec $conn "GRANT ALL ON TABLE $dbName.$ref TO $uName"
            }
            pg_exec $conn "UPDATE dbs SET owner='$owner {$uName owner}' WHERE name = '$dbName';"
        } elseif {$mode eq "write"} {
            foreach ref $refs {
                pg_exec $conn "GRANT USAGE ON SCHEMA $dbName TO $uName"
                pg_exec $conn "GRANT SELECT, INSERT ON TABLE $dbName.$ref TO $uName"
            }
            pg_exec $conn "UPDATE dbs SET owner='$owner {$uName guest}' WHERE name = '$dbName';"
        } else {
            foreach ref $refs {
                pg_exec $conn "GRANT USAGE ON SCHEMA $dbName TO $uName"
                pg_exec $conn "GRANT SELECT ON TABLE $dbName.$ref TO $uName"
            }
            pg_exec $conn "UPDATE dbs SET owner='$owner {$uName guest}' WHERE name = '$dbName';"
        }
    }
    pg_disconnect $conn
}

#revokes access on all tables of the database
proc revokeOnDB {dbName uName} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    pg_select $conn "SELECT tablename FROM pg_tables WHERE schemaname = '[string tolower $dbName]'" data {
        lappend refs $data(tablename)
    }
    foreach ref $refs {
        pg_exec $conn "REVOKE ALL ON TABLE $dbName.$ref FROM $uName"
    }
    pg_exec $conn "REVOKE ALL ON SCHEMA $dbName FROM $uName"
    pg_select $conn "SELECT owner FROM public.dbs WHERE name = '$dbName'" data {
        set owner $data(owner)
    }
    foreach o $owner {
        if {[lindex $o 0] ne $uName} {
            lappend newOwner $o
        }
    }
    catch {
        pg_exec $conn "UPDATE dbs SET owner='$newOwner' WHERE name = '$dbName';"
    }
    pg_disconnect $conn
}

#grants access to all functions
proc grantToFunc {uName mode} {
    global host
    global port
    global user
    global password
    global parentDB
    
    revokeOnFunc $uName
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    pg_exec $conn "GRANT USAGE ON SCHEMA functions TO $uName;"
    pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.blast2interpro(text,text) TO $uName;"
    pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.changerun(text,text) TO $uName;"
    pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.coverage(text) TO $uName;"
    pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.dbcomment(text,text) TO $uName;"
    pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.dbinfo(text) TO $uName;"
    pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.domain2interpro(text) TO $uName;"
    pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.exportnuc(text,text,text) TO $uName;"
    pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.getdes(text,text,text) TO $uName;"
    pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.gostat(text) TO $uName;"
    pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.kegg(text) TO $uName;"
    pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.nuccomment(text,text,text) TO $uName;"
    pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.protcomment(text,text,text) TO $uName;"
    if {$mode eq "all"} {
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.cdb(text,text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.delcontigs(text,text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.deldb(text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.delrun(text,text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.delhits(text,text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.addnuc(text,text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.addprot(text,text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.addrun(text,text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.newnuc(text,text,text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.readdistribution(text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.readstatus(text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.seqinfo(text,text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.protinfo(text,text) TO $uName;"
    } elseif {$mode eq "add"} {
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.cdb(text,text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.addnuc(text,text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.addprot(text,text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.addrun(text,text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.newnuc(text,text,text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.readdistribution(text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.readstatus(text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.seqinfo(text,text) TO $uName;"
        pg_exec $conn "GRANT EXECUTE ON FUNCTION functions.protinfo(text,text) TO $uName;"
    }
    pg_disconnect $conn
    revokeOnFunc PUBLIC
}

#revokes access to all functions from user
proc revokeOnFunc {uName} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.addnuc(text,text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.addprot(text,text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.addrun(text,text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.blast2interpro(text,text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.changerun(text,text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.coverage(text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.cdb(text,text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.dbcomment(text,text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.dbinfo(text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.delcontigs(text,text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.deldb(text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.delrun(text,text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.delhits(text,text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.domain2interpro(text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.exportnuc(text,text,text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.getdes(text,text,text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.gostat(text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.kegg(text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.newnuc(text,text,text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.nuccomment(text,text,text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.protcomment(text,text,text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.protinfo(text,text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.readdistribution(text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.readstatus(text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON FUNCTION functions.seqinfo(text,text) FROM $uName;"
    pg_exec $conn "REVOKE ALL ON SCHEMA functions FROM $uName;"
    pg_disconnect $conn
}

proc backupRefDB {f} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    
    set out ""
    if {[catch {set fs [open "$f" w]}]} {
        puts "cant find $f."
    } else {
        set out "# go"
        pg_select $conn "SELECT id, category, name, description, is_a FROM refdb.go" data {
            append out "\n$data(id)\t$data(category)\t$data(name)\t$data(description)\t$data(is_a)"
        }
        puts $fs $out
        flush $fs
        foreach ref {interpro blastprodom coil gene3d panther patternscan pfam pir profilescan smart superfamily tigr} {
            set out "# $ref"
            set count 0
            pg_select $conn "SELECT id, description FROM refdb.$ref" data {
                append out "\n$data(id)\t$data(description)"
                incr count
                if {$count >= 50000} {
                    puts -nonewline $fs $out
                    flush $fs
                    set count 0
                    set out ""
                }
            }
            puts $fs $out
            flush $fs
        }
        set count 0
        set out "# kegg"
        pg_select $conn "SELECT id, name, description FROM refdb.kegg" data {
            append out "\n$data(id)\t$data(name)\t$data(description)"
            incr count
            if {$count >= 50000} {
                puts -nonewline $fs $out
                flush $fs
                set count 0
                set out ""
            }
        }
        puts $fs $out
        flush $fs
        set count 0
        set out "# interpro2domain"
        pg_select $conn "SELECT interpro, db, domain FROM refdb.interpro2domain" data {
            append out "\n$data(interpro)\t$data(db)\t$data(domain)"
            incr count
            if {$count >= 50000} {
                puts -nonewline $fs $out
                flush $fs
                set count 0
                set out ""
            }
        }
        puts $fs $out
        flush $fs
        set count 0
        set out "# interpro2go"
        pg_select $conn "SELECT interpro, go FROM refdb.interpro2go" data {
            append out "\n$data(interpro)\t$data(go)"
            incr count
            if {$count >= 50000} {
                puts -nonewline $fs $out
                flush $fs
                set count 0
                set out ""
            }
        }
        puts $fs $out
        flush $fs
        set count 0
        set out "# interpro2protein"
        pg_select $conn "SELECT protein, interpro, id_domain, start, \"end\" FROM refdb.interpro2protein" data {
            append out "\n$data(protein)\t$data(interpro)\t$data(id_domain)\t$data(start)\t$data(end)"
            incr count
            if {$count >= 50000} {
                puts -nonewline $fs $out
                flush $fs
                set count 0
                set out ""
            }
        }
        puts $fs $out
        flush $fs
        set count 0
        set out "# kegg2go"
        pg_select $conn "SELECT ko, go FROM refdb.kegg2go" data {
            append out "\n$data(ko)\t$data(go)"
            incr count
            if {$count >= 50000} {
                puts -nonewline $fs $out
                flush $fs
                set count 0
                set out ""
            }
        }
        puts $fs $out
        flush $fs
        set count 0
        set out "# kegg_maps"
        pg_select $conn "SELECT id_map, id_ko, id_ec, id_rn, id_cpd, name FROM refdb.kegg_maps" data {
            append out "\n$data(id_map)\t$data(id_ko)\t$data(id_ec)\t$data(id_rn)\t$data(id_cpd)\t$data(name)"
            incr count
            if {$count >= 50000} {
                puts -nonewline $fs $out
                flush $fs
                set count 0
                set out ""
            }
        }
        puts $fs $out
        flush $fs
        set count 0
        set out "# kegg2protein"
        pg_select $conn "SELECT protein, id_ko FROM refdb.kegg2protein" data {
            append out "\n$data(protein)\t$data(id_ko)"
            incr count
            if {$count >= 50000} {
                puts -nonewline $fs $out
                flush $fs
                set count 0
                set out ""
            }
        }
        puts $fs $out
        flush $fs
        
        pg_select $conn "SELECT tablename FROM pg_tables WHERE schemaname = 'refdb' AND tablename NOT IN ('kegg', 'interpro2domain', 'interpro2go', 'interpro2protein', 'kegg2go', 'kegg2protein', 'kegg_maps', 'interpro', 'blastprodom', 'coil', 'gene3d', 'go', 'panther', 'patternscan', 'pfam', 'pir', 'profilescan', 'smart', 'superfamily', 'tigr')" data {
            lappend refs $data(tablename)
        }
        foreach ref $refs {
            set count 0
            if {$ref eq "gotree"} {
                set out "# gotree"
                pg_select $conn "SELECT id, parent_of, members FROM refdb.gotree" data {
                    append out "\n$data(id)\t$data(parent_of)\t$data(members)"
                    incr count
                    if {$count >= 50000} {
                        puts -nonewline $fs $out
                        flush $fs
                        set count 0
                        set out ""
                    }
                }
                puts $fs $out
                flush $fs
            } else {
                set out "# blastdb $ref"
                pg_select $conn "SELECT id, id2, organism, description, product FROM refdb.$ref" data {
                    append out "\n$data(id)\t$data(id2)\t$data(organism)\t$data(description)\t$data(product)"
                    incr count
                    if {$count >= 50000} {
                        puts -nonewline $fs $out
                        flush $fs
                        set count 0
                        set out ""
                    }
                }
                puts $fs $out
                flush $fs
            }
        }
        unset out
        close $fs
    }    
}

proc loadRefDB {f} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB port=$port user=$user password='$password'"]
    set in ""
    if {[catch {set fs [open $f r]}]} {
        puts "cant find $f."
    } else {
        set start 0
        set counter 0
        set tab ""
        while {[gets $fs line] != -1} {
            if {[string index $line 0] eq "#"} {
                if {$in ne ""} {
                    catch {loadRefDB_write $tab "$in"}
                    set in ""
                    set start 0
                    set counter 0
                }
                if {[lindex $line 1] eq "blastdb"} {
                    set db_pkey [lindex $line 2]; append db_pkey "_pkey"
                    catch {
                        pg_exec $conn "CREATE TABLE refdb.[lindex $line 2] (id text NOT NULL, id2 text, organism text, description text, product text, CONSTRAINT $db_pkey PRIMARY KEY (id));"
                        pg_exec $conn "CREATE INDEX index_id_[lindex $line 2] ON refdb.[lindex $line 2] USING btree (id);"
                        pg_exec $conn "CREATE INDEX index_organism_[lindex $line 2] ON refdb.[lindex $line 2] USING btree (organism);"
                        #pg_exec $conn "CREATE INDEX index_description_[lindex $line 2] ON refdb.[lindex $line 2] USING btree (description);"
                        #pg_exec $conn "CREATE INDEX index_product_[lindex $line 2] ON refdb.[lindex $line 2] USING btree (product);"
                    }
                    set tab [lindex $line 2]
                } else {
                    set tab [lindex $line 1]
                }
            } elseif {[lindex $line] ne ""} {
                incr counter
                if {$start eq 0} {
                    set start 1
                    set in "$line"
                } else {
                    append in "\n$line"
                }
                if {$counter > 50000} {
                    catch {loadRefDB_write $tab "$in"}
                    set in ""
                    set start 0
                    set counter 0
                }
            }
        }
        if {$in ne ""} {
            catch {loadRefDB_write $tab "$in"}
        }
        close $fs
    }
    pg_disconnect $conn
}

proc loadRefDB_write {tab data} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set connCopy [pg_connect -conninfo "host=$host dbname=$parentDB port=$port user=$user password='$password'"]
    
    set res [pg_exec $connCopy "COPY refdb.$tab FROM STDIN"]
    
    if {[pg_result $res -status] != "PGRES_COPY_IN"} {
        puts [pg_result $res -error]
        pg_result $res -clear
    }
    puts $connCopy "$data"
    puts $connCopy "\\."
    if {[pg_result $res -status] != "PGRES_COMMAND_OK"} {
        puts [pg_result $res -error]
        pg_result $res -clear
    }
    pg_result $res -clear
    pg_disconnect $connCopy
    
}

proc smartRef {data} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set connRef [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    if {[catch {set fs [open $data r]}]} {
        puts "cant find $data."
    } else {
        while {[gets $fs line] != -1} {
            set line "\{[regsub -all {\t} $line "\} \{"]\}"
            # Write to the database:
            pg_exec $connRef "INSERT INTO refdb.smart VALUES ('[lindex $line 1]', '[lindex $line 2] ([lindex $line 0])')"
        }
        pg_disconnect $connRef
    }
}

proc gene3dRef {data} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set connRef [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    if {[catch {set fs [open $data r]}]} {
        puts "cant find $data."
    } else {
        while {[gets $fs line] != -1} {
            if {[string index $line 0] ne "#"} {
                set line [regsub -all {[:]} $line ""]
                set line [regsub -all {\{} $line "("]
                set line [regsub -all {\}} $line ")"]
                if {$line ne ""} {
                    pg_exec $connRef "INSERT INTO refdb.gene3d VALUES ('G3DSA:[lindex $line 0]', '[lrange $line 2 end]')"
                }    
            }
        }
        pg_disconnect $connRef
    }
}

proc addACE {dbName f contigName} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    if {[catch {set fs [open $f r]}]} {
        puts "cant find $f."
    } else {
        puts "reading ACE file..."
        set contig_num [getNum sequences_nucleotide $dbName]
        if {$contig_num eq 0} {
            set mode 0
        } else  {
            set mode 1
        }
        set readL ""
        set contig_qual ""
        set contig_sequence_gap ""
        set contig_reads 0
        set readSeqL ""
        set q 0
        set sC 0
        set sR 0
        while {[gets $fs line] != -1} {
            if {[lindex $line 0] eq "CO"} {
                if {$contig_reads ne 0} {
                    if {[llength $readSeqL] >= 40} {
                        set seqTMP $contig_sequence_gap
                        for {set i 0} {$i < [llength $contig_qual]} {incr i} {
                            if {[lindex $contig_qual $i] eq 7} {
                                if {([lindex $contig_qual [expr $i + 1]] eq 60 || [lindex $contig_qual [expr $i + 1]] eq 7) && ([lindex $contig_qual [expr $i - 1]] eq 60 || [lindex $contig_qual [expr $i - 1]] eq 7)} {
                                    set ic 0
                                    set ipos 0
                                    while {$ipos <= $i} {
                                        if {[string index $seqTMP $ic] ne "*"} {
                                            incr ipos
                                        }
                                        incr ic
                                    }
                                    set a 0; set t 0; set c 0; set g 0; set gap 0
                                    foreach seq $readSeqL {
                                        set pos [string toupper [string index [lindex $seq 0] [expr $ic - [lindex $seq 1]]]]
                                        if {$pos eq "*"} {
                                            incr gap
                                        } elseif {$pos eq "A"} {
                                            incr a
                                        } elseif {$pos eq "T"} {
                                            incr t
                                        } elseif {$pos eq "C"} {
                                            incr c
                                        } elseif {$pos eq "G"} {
                                            incr g
                                        }
                                    }
                                    set replace $a
                                    set replacement "A"
                                    if {$t > $replace} {
                                        set replacement "T"
                                        set replace $t
                                    }
                                    if {$c > $replace} {
                                        set replacement "C"
                                        set replace $c
                                    }
                                    if {$g > $replace} {
                                        set replacement "G"
                                        set replace $g
                                    }
                                    if {$gap > $replace} {
                                        set replacement "*"
                                    }
                                    set ic [expr $ic - 1]
                                    puts "$contig_name $i $ic $replacement (A: $a; T: $t; G: $g; C: $c; *: $gap)"
                                    set contig_sequence_gap [string replace $contig_sequence_gap $ic $ic $replacement]
                                }
                            }
                        }
                    }
                    set base_cover ""
                    set base_cover_a ""
                    set base_cover_t ""
                    set base_cover_c ""
                    set base_cover_g ""
                    set base_cover_gap ""
                    for {set i 0} {$i < [string length $contig_sequence_gap]} {incr i} {
                        lappend base_cover_a "0"
                        lappend base_cover_t "0"
                        lappend base_cover_c "0"
                        lappend base_cover_g "0"
                        lappend base_cover_gap "0"
                    }
                    foreach r $readL {
                        set r_seq [lindex $r 5]
                        for {set i [expr [lindex $r 3] - 1]} {$i < [string length $r_seq]} {incr i} {
                            set base [string toupper [string index $r_seq $i]]
                            catch {
                                set ind [expr [lindex $r 2] + $i - 1]
                                if {$base eq "A"} {
                                    set base_cover_a [lreplace $base_cover_a $ind $ind [expr [lindex $base_cover_a $ind] + 1]]
                                } elseif {$base eq "T"} {
                                    set base_cover_t [lreplace $base_cover_t $ind $ind [expr [lindex $base_cover_t $ind] + 1]]
                                } elseif {$base eq "C"} {
                                    set base_cover_c [lreplace $base_cover_c $ind $ind [expr [lindex $base_cover_c $ind] + 1]]
                                } elseif {$base eq "G"} {
                                    set base_cover_g [lreplace $base_cover_g $ind $ind [expr [lindex $base_cover_g $ind] + 1]]
                                } elseif {$base eq "*"} {
                                    set base_cover_gap [lreplace $base_cover_gap $ind $ind [expr [lindex $base_cover_gap $ind] + 1]]
                                }
                            }
                        }
                        if {$mode} {
                            set exists 0
                            pg_select $conn "SELECT name_read FROM $dbName.read_hits WHERE name_read = '[lindex $r 0]'" data {set exists 1}
                            if {$exists} {
                                pg_exec $conn "UPDATE $dbName.read_hits SET strand='[lindex $r 1]', seq_start='[lindex $r 2]', read_start='[lindex $r 3]', read_end='[lindex $r 4]', sequence_gap='[lindex $r 5]' WHERE name_seq='$contig_name';"
                            } else {
                                pg_exec $conn "INSERT INTO $dbName.read_hits VALUES ('[lindex $r 0]', '$contig_name', '[lindex $r 1]', '[lindex $r 2]', '[lindex $r 3]', '[lindex $r 4]', '[lindex $r 5]')"
                            }
                        } else {
                            pg_exec $conn "INSERT INTO $dbName.read_hits VALUES ('[lindex $r 0]', '$contig_name', '[lindex $r 1]', '[lindex $r 2]', '[lindex $r 3]', '[lindex $r 4]', '[lindex $r 5]')"
                        }
                        catch {
                            pg_exec $conn "UPDATE $dbName.sequences_read SET singleton=FALSE WHERE name = '[lindex $r 0]';"
                        }
                    }
                    
                    for {set i 0} {$i < [string length $contig_sequence_gap]} {incr i} {
                        lappend base_cover "[lindex $base_cover_a $i] [lindex $base_cover_t $i] [lindex $base_cover_c $i] [lindex $base_cover_g $i] [lindex $base_cover_gap $i]"
                    }
                    if {$mode} {
                        set exists 0
                        pg_select $conn "SELECT name FROM $dbName.sequences_nucleotide WHERE name = '$contig_name'" data {set exists 1}
                        if {$exists} {
                            pg_exec $conn "UPDATE $dbName.sequences_nucleotide SET sequence_gap='$contig_sequence_gap', base_cover='$base_cover' WHERE name='$contig_name';"
                        } else {
                            set contig_sequence [regsub -all {\*} $contig_sequence_gap ""]
                            set contig_length [string length $contig_sequence]
                            incr contig_num
                            pg_exec $conn "INSERT INTO $dbName.sequences_nucleotide VALUES ('$contig_num', '$contig_name', '$contig_reads', '$contig_length', '$contig_sequence', '$contig_sequence_gap', '$base_cover')"
                            pg_exec $conn "INSERT INTO $dbName.seq_info VALUES ('$contig_num', '$contig_name', '$contig_length', '$contig_reads', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0')"
                        }
                    } else {
                        set contig_sequence [regsub -all {\*} $contig_sequence_gap ""]
                        set contig_length [string length $contig_sequence]
                        incr contig_num
                        pg_exec $conn "INSERT INTO $dbName.sequences_nucleotide VALUES ('$contig_num', '$contig_name', '$contig_reads', '$contig_length', '$contig_sequence', '$contig_sequence_gap', '$base_cover')"
                        pg_exec $conn "INSERT INTO $dbName.seq_info VALUES ('$contig_num', '$contig_name', '$contig_length', '$contig_reads', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0')"
                    }
                    set base_cover ""
                    set base_cover_a ""
                    set base_cover_t ""
                    set base_cover_c ""
                    set base_cover_g ""
                    set base_cover_gap ""
                    set contig_reads 0
                    set contig_sequence_gap ""
                    set contig_qual ""
                    set readSeqL ""
                    set readL ""
                }
                set sC 1
                if {$contigName ne ""} {
                    set contig_name $contigName; append contig_name "_[lindex $line 1]"
                } else {
                    set contig_name "[lindex $line 1]"
                }
            } elseif {[lindex $line 0] eq "BQ"} {
                set q 1
                set sC 0
            } elseif {$sC eq 1} {
                append contig_sequence_gap "$line"
            } elseif {[lindex $line 0] eq "AF"} {
                set q 0
                lappend readStartL "[lindex [split [lindex $line 1] .] 0] [lindex $line 2] [lindex $line 3]"
            } elseif {$q eq 1} {
                append contig_qual "$line "
            } elseif {[lindex $line 0] eq "RD"} {
                set readStartNum 0
                set sR 1
                set read_sequence_gap ""
                set seqName [lindex [split [lindex $line 1] .] 0]
                foreach readStart $readStartL {
                    if {[lindex [split [lindex $line 1] .] 0] eq [lindex $readStart 0]} {
                        set readTmp "[lindex [split [lindex $line 1] .] 0] [lindex $readStart 1] [lindex $readStart 2]"
                        set readStartL [lreplace $readStartL $readStartNum $readStartNum]
                        break
                    }
                    incr readStartNum
                }
            } elseif {[lindex $line 0] eq "QA"} {
                if {$seqName eq [lindex $readTmp 0]} {
                    lappend readSeqL "$read_sequence_gap [lindex $readTmp 2]"
                }
                set sR 0
                append readTmp " [lindex $line 1] [lindex $line 2] $read_sequence_gap"
                lappend readL $readTmp
            } elseif {$sR eq 1} {
                append read_sequence_gap "$line"
            } elseif {[lindex $line 0] eq "DS"} {
                set numreads [split [lindex $line 2] =]
                if {[lindex $numreads 0] eq "numreads"} {
                    set contig_reads [expr $contig_reads + [lindex $numreads 1]]
                } else {
                    incr contig_reads
                }
            }
        }
        if {$contig_reads ne 0} {
            if {[llength $readSeqL] >= 400} {
                set seqTMP $contig_sequence_gap
                for {set i 0} {$i < [llength $contig_qual]} {incr i} {
                    if {[lindex $contig_qual $i] eq 7} {
                        if {([lindex $contig_qual [expr $i + 1]] eq 60 || [lindex $contig_qual [expr $i + 1]] eq 7) && ([lindex $contig_qual [expr $i - 1]] eq 60 || [lindex $contig_qual [expr $i - 1]] eq 7)} {
                            set ic 0
                            set ipos 0
                            while {$ipos <= $i} {
                                if {[string index $seqTMP $ic] ne "*"} {
                                    incr ipos
                                }
                                incr ic
                            }
                            set a 0; set t 0; set c 0; set g 0; set gap 0
                            foreach seq $readSeqL {
                                set pos [string toupper [string index [lindex $seq 0] [expr $ic - [lindex $seq 1]]]]
                                if {$pos eq "*"} {
                                    incr gap
                                } elseif {$pos eq "A"} {
                                    incr a
                                } elseif {$pos eq "T"} {
                                    incr t
                                } elseif {$pos eq "C"} {
                                    incr c
                                } elseif {$pos eq "G"} {
                                    incr g
                                }
                            }
                            set replace $a
                            set replacement "A"
                            if {$t > $replace} {
                                set replacement "T"
                                set replace $t
                            }
                            if {$c > $replace} {
                                set replacement "C"
                                set replace $c
                            }
                            if {$g > $replace} {
                                set replacement "G"
                                set replace $g
                            }
                            if {$gap > $replace} {
                                set replacement "*"
                            }
                            set ic [expr $ic - 1]
                            puts "$contig_name $i $ic $replacement (A: $a; T: $t; G: $g; C: $c; *: $gap)"
                            set contig_sequence_gap [string replace $contig_sequence_gap $ic $ic $replacement]
                        }
                    }
                }
            }
            set base_cover ""
            set base_cover_a ""
            set base_cover_t ""
            set base_cover_c ""
            set base_cover_g ""
            set base_cover_gap ""
            for {set i 0} {$i < [string length $contig_sequence_gap]} {incr i} {
                lappend base_cover_a "0"
                lappend base_cover_t "0"
                lappend base_cover_c "0"
                lappend base_cover_g "0"
                lappend base_cover_gap "0"
            }
            foreach r $readL {
                set r_seq [lindex $r 5]
                for {set i [expr [lindex $r 3] - 1]} {$i < [string length $r_seq]} {incr i} {
                    set base [string toupper [string index $r_seq $i]]
                    catch {
                        set ind [expr [lindex $r 2] + $i - 1]
                        if {$base eq "A"} {
                            set base_cover_a [lreplace $base_cover_a $ind $ind [expr [lindex $base_cover_a $ind] + 1]]
                        } elseif {$base eq "T"} {
                            set base_cover_t [lreplace $base_cover_t $ind $ind [expr [lindex $base_cover_t $ind] + 1]]
                        } elseif {$base eq "C"} {
                            set base_cover_c [lreplace $base_cover_c $ind $ind [expr [lindex $base_cover_c $ind] + 1]]
                        } elseif {$base eq "G"} {
                            set base_cover_g [lreplace $base_cover_g $ind $ind [expr [lindex $base_cover_g $ind] + 1]]
                        } elseif {$base eq "*"} {
                            set base_cover_gap [lreplace $base_cover_gap $ind $ind [expr [lindex $base_cover_gap $ind] + 1]]
                        }
                    }
                }
                if {$mode} {
                    pg_select $conn "SELECT name_read FROM $dbName.read_hits WHERE name_read = '[lindex $r 0]'" data {set exists 1}
                    if {$exists} {
                        pg_exec $conn "UPDATE $dbName.read_hits SET strand='[lindex $r 1]', seq_start='[lindex $r 2]', read_start='[lindex $r 3]', read_end='[lindex $r 4]', sequence_gap='[lindex $r 5]' WHERE name_seq='$contig_name';"
                    } else {
                        pg_exec $conn "INSERT INTO $dbName.read_hits VALUES ('[lindex $r 0]', '$contig_name', '[lindex $r 1]', '[lindex $r 2]', '[lindex $r 3]', '[lindex $r 4]', '[lindex $r 5]')"
                    }
                } else {
                    pg_exec $conn "INSERT INTO $dbName.read_hits VALUES ('[lindex $r 0]', '$contig_name', '[lindex $r 1]', '[lindex $r 2]', '[lindex $r 3]', '[lindex $r 4]', '[lindex $r 5]')"
                }
                catch {
                    pg_exec $conn "UPDATE $dbName.sequences_read SET singleton=FALSE WHERE name = '[lindex $r 0]';"
                }
            }
            
            for {set i 0} {$i < [string length $contig_sequence_gap]} {incr i} {
                lappend base_cover "[lindex $base_cover_a $i] [lindex $base_cover_t $i] [lindex $base_cover_c $i] [lindex $base_cover_g $i] [lindex $base_cover_gap $i]"
            }
            if {$mode} {
                set exists 0
                pg_select $conn "SELECT name FROM $dbName.sequences_nucleotide WHERE name = '$contig_name'" data {set exists 1}
                if {$exists} {
                    pg_exec $conn "UPDATE $dbName.sequences_nucleotide SET sequence_gap='$contig_sequence_gap', base_cover='$base_cover' WHERE name='$contig_name';"
                } else {
                    set contig_sequence [regsub -all {\*} $contig_sequence_gap ""]
                    set contig_length [string length $contig_sequence]
                    incr contig_num
                    pg_exec $conn "INSERT INTO $dbName.sequences_nucleotide VALUES ('$contig_num', '$contig_name', '$contig_reads', '$contig_length', '$contig_sequence', '$contig_sequence_gap', '$base_cover')"
                    pg_exec $conn "INSERT INTO $dbName.seq_info VALUES ('$contig_num', '$contig_name', '$contig_length', '$contig_reads', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0')"
                }
            } else {
                set contig_sequence [regsub -all {\*} $contig_sequence_gap ""]
                set contig_length [string length $contig_sequence]
                incr contig_num
                pg_exec $conn "INSERT INTO $dbName.sequences_nucleotide VALUES ('$contig_num', '$contig_name', '$contig_reads', '$contig_length', '$contig_sequence', '$contig_sequence_gap', '$base_cover')"
                pg_exec $conn "INSERT INTO $dbName.seq_info VALUES ('$contig_num', '$contig_name', '$contig_length', '$contig_reads', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0')"
            }
            
            set base_cover ""
            set base_cover_a ""
            set base_cover_t ""
            set base_cover_c ""
            set base_cover_g ""
            set base_cover_gap ""
            set contig_reads 0
            set contig_sequence_gap ""
            set contig_qual ""
            set readL ""
        }
        close $fs
    }
}

proc addReads {dbName run readFile} {
    global host
    global port
    global user
    global password
    global parentDB
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    pg_exec $conn "CREATE TABLE $dbName.sequences_read (id_read integer NOT NULL, id_run text, name text, length integer, polya boolean, singleton boolean, sequence text)"
    
    if {[catch {set fs [open $readFile r]}]} {
        puts "cant find read sequence file: $readFile"
    } else {
        puts "adding read sequences..."
        set strH ""
        set strS ""
        while {[gets $fs line] != -1} {
            if {[string index $line 0] eq ">"} {
                if {$strS ne ""} {
                    lappend readSeqs "$strH [string length $strS] $polyA TRUE $strS"
                    set strS ""
                    set strH [string range [lindex $line 0] 1 end]
                    if {[lindex $line 1] eq "polyA"} {
                        set polyA TRUE
                    } else {
                        set polyA FALSE
                    }
                } else {
                    set strH [string range [lindex $line 0] 1 end]
                    if {[lindex $line 1] eq "polyA"} {
                        set polyA TRUE
                    } else {
                        set polyA FALSE
                    }
                }
            } else {
                append strS "$line"
            }
        }
        lappend readSeqs "$strH [string length $strS] $polyA TRUE $strS"
        close $fs
        
        set res [pg_exec $conn "COPY $dbName.sequences_read FROM STDIN"]
        if {[pg_result $res -status] != "PGRES_COPY_IN"} {
            #set message [pg_result $res -error]
            pg_result $res -clear
        }
        
        # Write to the database:
        set input ""
        set start 0
        set num [getNum sequences_read $dbName]
        foreach ent $readSeqs {
            if {$start eq 0} {
                set start 1
                append input "$num\t$run\t[lindex $ent 0]\t[lindex $ent 1]\t[lindex $ent 2]\t[lindex $ent 3]\t[lindex $ent 4]"
            } else {
                append input "\n$num\t$run\t[lindex $ent 0]\t[lindex $ent 1]\t[lindex $ent 2]\t[lindex $ent 3]\t[lindex $ent 4]"
            }
            incr num
        }
        unset readSeqs
        puts $conn "$input"
        # Write the end of data marker:
        puts $conn "\\."
        # Check final status:
        if {[pg_result $res -status] != "PGRES_COMMAND_OK"} {
            #set message [pg_result $res -error]
            pg_result $res -clear
        }
        pg_result $res -clear
        
        pg_disconnect $conn
    }
}

proc addNuc {dbName nucleoS} {
    global host
    global port
    global user
    global password
    global parentDB
    
    if {[catch {set fs [open $nucleoS r]}]} {
        puts "cant find nucleotide sequence file: $nucleoS"
    } else {
        puts "adding nucleotide sequences..."
        set strH ""
        set strS ""
        while {[gets $fs line] != -1} {
            if {[string index $line 0] eq ">"} {
                if {$strS ne ""} {
                    if {[lindex $strH 2] eq "?"} {
                        set strH [lreplace $strH 2 2 [string length $strS]]
                    }
                    lappend nucSeqs "$strH $strS"
                    if {[lindex [split [lindex $line 2] =] 0] eq "numreads"} {
                        set strH "[string range [lindex $line 0] 1 end] [lindex [split [lindex $line 2] =] 1] [lindex [split [lindex $line 1] =] 1]"
                    } else {
                        set strH [regsub -all {'} "{[string range $line 1 end]} 1 ?" `]
                    }
                    set strS ""
                } else {
                    if {[lindex [split [lindex $line 2] =] 0] eq "numreads"} {
                        set strH "[string range [lindex $line 0] 1 end] [lindex [split [lindex $line 2] =] 1] [lindex [split [lindex $line 1] =] 1]"
                    } else {
                        set strH [regsub -all {'} "{[string range $line 1 end]} 1 ?" `]
                    }
                }
            } else {
                append strS "$line"
            }
        }
        if {[lindex $strH 2] eq "?"} {
            set strH [lreplace $strH 2 2 [string length $strS]]
        }
        lappend nucSeqs "$strH $strS"
        close $fs
        
        set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
        pg_exec $conn "CREATE TABLE $dbName.sequences_nucleotide (id_seq text NOT NULL, \"name\" text NOT NULL, numreads integer, length integer, \"sequence\" text);"
        set num [getNum sequences_nucleotide $dbName]
        
        set res [pg_exec $conn "COPY $dbName.sequences_nucleotide FROM STDIN"]
        if {[pg_result $res -status] != "PGRES_COPY_IN"} {
            #set message [pg_result $res -error]
            pg_result $res -clear
        }
        
        # Write to the database:
        set input ""
        set start 0
        foreach ent $nucSeqs {
            incr num
            if {$start eq 0} {
                set start 1
                append input "$num\t[lindex $ent 0]\t[lindex $ent 1]\t[lindex $ent 2]\t[lindex $ent 3]\t\t"
            } else {
                append input "\n$num\t[lindex $ent 0]\t[lindex $ent 1]\t[lindex $ent 2]\t[lindex $ent 3]\t\t"
            }
        }
        unset nucSeqs
        puts $conn "$input"
        # Write the end of data marker:
        puts $conn "\\."
        # Check final status:
        if {[pg_result $res -status] != "PGRES_COMMAND_OK"} {
            #set message [pg_result $res -error]
            pg_result $res -clear
        }
        pg_result $res -clear
        pg_disconnect $conn
    }
}

proc addProt {dbName proteinS} {
    global host
    global port
    global user
    global password
    global parentDB
    
    if {[catch {set fs [open $proteinS r]}]} {
        puts "cant find protein sequence file: $proteinS."
    } else {
        puts "adding protein sequences..."
        set strH ""
        set strS ""
        while {[gets $fs line] != -1} {
            if {[string index $line 0] eq ">"} {
                if {$strS ne ""} {
                    lappend pSeqs "$strH $strS"
                    set strH "[string range [lindex $line 0] 1 end] [lindex $line 3] [string index [lindex $line 6] 0] [string range [lindex $line 8] 0 [expr [string length [lindex $line 8]] - 2]]"
                    set strS ""
                } else {
                    set strH "[string range [lindex $line 0] 1 end] [lindex $line 3] [string index [lindex $line 6] 0] [string range [lindex $line 8] 0 [expr [string length [lindex $line 8]] - 2]]"
                }
            } else {
                append strS "$line"
            }
        }
        lappend pSeqs "$strH $strS"
        close $fs
    }
    
    set conn [pg_connect -conninfo "host=$host dbname=$parentDB user=$user password=$password"]
    pg_exec $conn "CREATE TABLE $dbName.sequences_protein (id_seq integer NOT NULL, id_prot integer NOT NULL, \"name\" text NOT NULL, frame text, orf integer, length integer, \"sequence\" text);"
    set num [getNum sequences_protein $dbName]
    foreach ent $pSeqs {
        catch {
            set len [string length [lindex $ent 4]]
            pg_select $conn "SELECT id_seq FROM $dbName.sequences_nucleotide WHERE \"name\" = '[lindex $ent 1]'" data {
                set id_seq $data(id_seq)
            }
            incr num
            lappend protSeqs "$id_seq\t$num\t[lindex $ent 0]\t[lindex $ent 2]\t[lindex $ent 3]\t$len\t[lindex $ent 4]"
        }
    }
    unset pSeqs
    set res [pg_exec $conn "COPY $dbName.sequences_protein FROM STDIN"]
    if {[pg_result $res -status] != "PGRES_COPY_IN"} {
        #set message [pg_result $res -error]
        pg_result $res -clear
    }
    
    # Write to the database:
    set input ""
    set start 0
    foreach ent $protSeqs {
        if {$start eq 0} {
            set start 1
            append input "$ent"
        } else {
            append input "\n$ent"
        }
    }
    unset protSeqs
    puts $conn "$input"
    # Write the end of data marker:
    puts $conn "\\."
    # Check final status:
    if {[pg_result $res -status] != "PGRES_COMMAND_OK"} {
        #set message [pg_result $res -error]
        pg_result $res -clear
    }
    pg_result $res -clear
    unset protSeqs
    pg_disconnect $conn
}

#browsing for file or folder
proc browse {mode} {
    global saveFolder
    global gui_goRef
    global gui_gene3dRef
    global gui_smartRef
    global gui_ipr2go
    global gui_prot2ipr
    global gui_prot2keggKO
    global gui_prot2keggProt
    global gui_keggMapsTitle
    global gui_keggMapsList
    global gui_keggRef
    global gui_aBRef
    global gui_addACE
    global gui_addNuc
    global gui_addProt
    global gui_addRead  
    
    if {$mode eq "goRef"} {
        set types {
            {{obo Files} {.obo} }
            {{All Files} * }
        }
        set files [tk_getOpenFile -filetypes $types -initialdir $saveFolder]
        if {$files != ""} {
            set gui_goRef $files
        }
    } elseif {$mode eq "gene3dRef"} {
        set types {
            {{txt Files} {.txt} }
            {{All Files} * }
        }
        set files [tk_getOpenFile -filetypes $types -initialdir $saveFolder]
        if {$files != ""} {
            set gui_gene3dRef $files
        }
    } elseif {$mode eq "smartRef"} {
        set types {
            {{txt Files} {.txt} }
            {{All Files} * }
        }
        set files [tk_getOpenFile -filetypes $types -initialdir $saveFolder]
        if {$files != ""} {
            set gui_smartRef $files
        }
    } elseif {$mode eq "ipr2go"} {
        set types {
            {{All Files} * }
        }
        set files [tk_getOpenFile -filetypes $types -initialdir $saveFolder]
        if {$files != ""} {
            set gui_ipr2go $files
        }
    } elseif {$mode eq "prot2ipr"} {
        set types {
            {{txt Files} {.txt} }
            {{All Files} * }
        }
        set files [tk_getOpenFile -filetypes $types -initialdir $saveFolder]
        if {$files != ""} {
            set gui_prot2ipr $files
        }
    } elseif {$mode eq "prot2kegg_ko"} {
        set types {
            {{list Files} {.list} }
            {{All Files} * }
        }
        set files [tk_getOpenFile -filetypes $types -initialdir $saveFolder]
        if {$files != ""} {
            set gui_prot2keggKO $files
        }
    } elseif {$mode eq "prot2kegg_prot"} {
        set types {
            {{list Files} {.list} }
            {{All Files} * }
        }
        set files [tk_getOpenFile -filetypes $types -initialdir $saveFolder]
        if {$files != ""} {
            set gui_prot2keggProt $files
        }
    } elseif {$mode eq "aBRef"} {
        set types {
            {{txt Files} {.txt} }
            {{All Files} * }
        }
        set files [tk_getOpenFile -filetypes $types -initialdir $saveFolder]
        if {$files != ""} {
            set gui_aBRef $files
        }
    } elseif {$mode eq "addACE"} {
        set types {
            {{ACE Files} {.ace} }
            {{All Files} * }
        }
        set files [tk_getOpenFile -filetypes $types -initialdir $saveFolder]
        if {$files != ""} {
            set gui_addACE $files
        }
    } elseif {$mode eq "addNuc"} {
        set types {
            {{Fasta Files} {.fasta .fas .fna .fa} }
            {{All Files} * }
        }
        set files [tk_getOpenFile -filetypes $types -initialdir $saveFolder]
        if {$files != ""} {
            set gui_addNuc $files
        }
    } elseif {$mode eq "addProt"} {
        set types {
            {{Fasta Files} {.fasta .fas .fna .fa} }
            {{All Files} * }
        }
        set files [tk_getOpenFile -filetypes $types -initialdir $saveFolder]
        if {$files != ""} {
            set gui_addProt $files
        }
    } elseif {$mode eq "addRead"} {
        set types {
            {{Fasta Files} {.fasta .fas .fna .fa} }
            {{All Files} * }
        }
        set files [tk_getOpenFile -filetypes $types -initialdir $saveFolder]
        if {$files != ""} {
            set gui_addRead $files
        }
    } elseif {$mode eq "keggMaps_title"} {
        set types {
            {{keggMaps title table} {.tab} }
            {{All Files} * }
        }
        set files [tk_getOpenFile -filetypes $types -initialdir $saveFolder]
        if {$files != ""} {
            set gui_keggMapsTitle $files
        }
    } elseif {$mode eq "keggMaps_list"} {
        set types {
            {{keggMaps map list} {.list} }
            {{All Files} * }
        }
        set files [tk_getOpenFile -filetypes $types -initialdir $saveFolder]
        if {$files != ""} {
            set gui_keggMapsList $files
        }
    } elseif {$mode eq "keggRef"} {
        set types {
            {{All Files} * }
        }
        set files [tk_getOpenFile -filetypes $types -initialdir $saveFolder]
        if {$files != ""} {
            set gui_keggRef $files
        }
    }
    
    set saveFolder ""
    set f1 [split $files /]
    for {set i 1} {$i < [expr [llength $f1] - 1]} {incr i} {
        append saveFolder "/[lindex $f1 $i]"
    }
}

init $argv